 /**
 *                                                                             *
 * @file About_ui.cpp                                                          *
 * Project name: HeKatE hqed                                                   *
 * $Id: About_ui.cpp,v 1.18 2008-03-03 22:04:31 kinio Exp $                     *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 28.04.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje metod klasy obslugujacej okno           *
 * informacji o programie                                                      *
 *                                                                             *
 */

#include <QKeyEvent>

#include "GLAboutWidget.h"
#include "About_ui.h"
// -----------------------------------------------------------------------------

About_ui* AboutWin;
// -----------------------------------------------------------------------------

/**
 * Konstruktor kalsy
 * @param QWidget *parent - Wskanik do rodzica
 * @returns Brak zwracanych wartosci
*/
About_ui::About_ui(QWidget*)
{
	setupUi(this);
	setWindowIcon(QIcon(":/all_images/images/mainico.bmp")); 
    
	setWindowModality(Qt::ApplicationModal);
	setWindowFlags(Qt::SplashScreen);
    
	// Wyrownanie elementow
	glScene = new GLAboutWidget(this);
    
	formLayout = new QGridLayout;
	formLayout->addWidget(groupBox, 0, 0, 1, 2);
	formLayout->addWidget(glScene, 0, 2, 1, 2);
	formLayout->addWidget(label, 1, 0);
	formLayout->addWidget(label_2, 2, 0);
	formLayout->addWidget(label_4, 3, 0);
	formLayout->addWidget(label_3, 4, 0);
	formLayout->addWidget(label_5, 1, 1, 4, 2);
	formLayout->addWidget(toolButton_3, 1, 3, 4, 1);
	formLayout->setColumnMinimumWidth(0, 135);
	formLayout->setColumnMinimumWidth(1, 135);
	formLayout->setColumnMinimumWidth(2, 135);
	formLayout->setColumnMinimumWidth(3, 135);
	formLayout->setRowMinimumHeight(0, 290);
	formLayout->setColumnStretch(0, 1);
	formLayout->setColumnStretch(1, 1);
	formLayout->setColumnStretch(2, 1);
	formLayout->setColumnStretch(3, 1);
	setLayout(formLayout);
    
	// Zapisanie wersji programu
	fAppVersion = "HeKatE Qt Editor ver. M5_2";
	label->setText(fAppVersion);
    
	QString licenceInfo = "<font size=\"4\"><b>Implementation by Krzysztof Kaczor</b></font><br><font size=\"4\">kinio4444@gmail.com</font>";
    
	licenceInfo += "<br><br><b>Copyright (C) 2006-9 by the HeKatE Project</b>";
	licenceInfo += "<br>HQEd has been develped within the <b>HeKatE Project</b>, see <a href=\"http://hekate.ia.agh.edu.pl\">http://hekate.ia.agh.edu.pl</a>";

	licenceInfo += "<br><br>This file is part of <b>HQEd</b>.";

	licenceInfo += "<br><br><u>HQEd is free software:</u> you can redistribute it and/or modify ";
	licenceInfo += "it under the terms of the GNU General Public License as published by ";
	licenceInfo += "the Free Software Foundation, either version 3 of the License, or ";
	licenceInfo += "(at your option) any later version.";

	licenceInfo += "<br><br>HQEd is distributed in the hope that it will be useful, ";
	licenceInfo += "but WITHOUT ANY WARRANTY; without even the implied warranty of ";
	licenceInfo += "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the ";
	licenceInfo += "GNU General Public License for more details.";

	licenceInfo += "<br><br>You should have received a copy of the GNU General Public License";
	licenceInfo += "along with HQEd.  If not, see <a href=\"http://www.gnu.org/licenses/\">http://www.gnu.org/licenses/</a>.";
	
	textEdit->setWordWrapMode(QTextOption::WordWrap);
	textEdit->setHtml(licenceInfo);
}
// -----------------------------------------------------------------------------

/**
 * Destruktor kalsy
 * @returns Brak zwracanych wartosci
*/
About_ui::~About_ui(void)
{
	delete glScene;
	delete formLayout;
}
// -----------------------------------------------------------------------------

/**
 * Metoa wywolywana w momencie kiedy zostanie nacisniety jakis klawisz
 * @param QKeyEvent* event - Wskanik do obiektu przechwoujacego informacje o zdarzeniu
 * @returns Brak zwracanych wartoci
*/
void About_ui::keyPressEvent(QKeyEvent *event)
{
	glScene->keyPressEvent(event);
	
     switch(event->key())
     {
          case Qt::Key_Escape:
               close();
               break;

          case Qt::Key_Return:
               close();
               break;

          default:
               QWidget::keyPressEvent(event);
     }
}
// -----------------------------------------------------------------------------

/**
 * Metoa zwracajaca informacje o wersji programu
 * @returns zwraca informacje o wersji programu jako string
*/
QString About_ui::appVersion(void)
{
	return fAppVersion;
}
// -----------------------------------------------------------------------------
