 /**
 *                                                                             *
 * @file GLAboutWidget.h                                                       *
 * Project name: HeKatE hqed                                                   *
 * $Id: GLAboutWidget.h,v 1.7 2008-03-03 22:04:31 kinio Exp $                       *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 12.01.2008                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje klasy bedacej obiekten rysowania        *
 * przez OpenGL                                                                *
 *                                                                             *
 */

#ifndef GLWIDGET_H
#define GLWIDGET_H
// -----------------------------------------------------------------------------

#include <QGLWidget>
#include <QtOpenGL>
// -----------------------------------------------------------------------------

class GLAboutWidget : public QGLWidget
{
    Q_OBJECT
    
    /// Parametry przezroczystosci tla
    float bkgAplpha;
    float d_bkgAlpha;
    
    /// Zmienne pozycjonujace
    float xrot1, yrot1, zrot1;
    float xpos1, ypos1;
    float d_xrot1, d_yrot1, d_zrot1, d_xpos1, d_ypos1;
    
    float xrot2, yrot2, zrot2;
    float xpos2, ypos2;
    float d_xrot2, d_yrot2, d_zrot2, d_xpos2, d_ypos2;
    
    /// Wspolrzedne bryly obcinania
    float gl_x_min, gl_x_max;
    float gl_y_min, gl_y_max;
    float gl_z_min, gl_z_max;
    
    /// Tekstuwy
    GLuint eagle;
    GLuint eaglebw;
    GLuint wall;
    GLuint bkgwall;
    GLuint flag;
    GLuint xttt;
    GLuint ardt;
    
    /// Listy
    GLuint cube1;
    GLuint cube2;
    
    /// Jakas zmienna tymczasowa
    float tmpVar;

public:

	/// Konstruktor
	GLAboutWidget(QWidget *parent = 0);
	
	/// Destruktor
	~GLAboutWidget(void);
	
	/// Metoda reagujaca na zdarzenie wcisniecia klawisza na klawiaturze
	void keyPressEvent(QKeyEvent*);

protected:

	/// Metoda inicjalizujaca openGL
	void initializeGL(void);
	
	/// Metoda wywolywana w momencie zmiany rozmiaru ekranu OpenGL
	void resizeGL(int width, int height);
	
	/// Metoda rysujaca scene OpenGL
	void paintGL(void);
	
	/// Metoda budujaca listy
	void buildLists(void);
	
public slots:
	
	/// Uaktualnia scene OpenGL
	void renderScene(void);
};
// -----------------------------------------------------------------------------
#endif
