 /**
 *                                                                             *
 * @file MainWin_ui.cpp                                                        *
 * Project name: HeKatE hqed                                                   *
 * $Id: MainWin_ui.cpp,v 1.20 2008-03-03 22:07:46 kinio Exp $                   *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 24.04.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajcy definicje funckji obslugujacych okienko glowne     *
 * programu                                                                    *
 *                                                                             *
 */

#include <math.h>

#include <QPlastiqueStyle>
#include <QCDEStyle>
#include <QWindowsXPStyle>
#include <QMotifStyle>

#include <QMessageBox>
#include <QtGui>
#include <QDialog>
#include <QObject>
#include <QPainter>
#include <QPrinter>
#include <QList>

#include <QPixmap>

#include <Qt>
#include <QtGui>
#include <QDir>

#include <QDial>
#include <QSpinBox>

#include <QDomDocument>

#if QT_VERSION >= 0x040300
	#include <QtSvg>
	#include <QSvgGenerator>
	
	#include <QXmlStreamWriter>
#endif

#include "ARD/ardGraphicsView.h"
#include "ARD/ardGraphicsScene.h"

#include "../M/ARD/ARD_Level.h"
#include "../M/ARD/ARD_LevelList.h"
#include "../M/ARD/ARD_Dependency.h"
#include "../M/ARD/ARD_DependencyList.h"
#include "../M/ARD/ARD_AttributeList.h"
#include "../M/ARD/ARD_Property.h"
#include "../M/ARD/ARD_PropertyList.h"
#include "../M/ARD/ARD_DependencyList.h"

#include "../V/ARD/gTPHtree.h"
#include "../V/ARD/gARDlevel.h"
#include "../V/ARD/gARDlevelList.h"

#include "XTT/ErrorsListWidget.h"
#include "XTT/ExecuteMessagesListWidget.h"
#include "XTT/MyGraphicsView.h"
#include "XTT/MyGraphicsScene.h"

#include "../V/XTT/GTable.h"
#include "../M/XTT/XTT_ConnectionsList.h"
#include "../M/XTT/XTT_Table.h"
#include "../M/XTT/XTT_TableList.h"
#include "../M/XTT/XTT_AttributeGroups.h"
#include "../M/XTT/XTT_Cell.h"
#include "../M/XTT/XTT_Row.h"
#include "XTT/UnusedAttributes_ui.h"
#include "XTT/ConnectionManager_ui.h"
#include "XTT/DeleteConnection_ui.h"
#include "XTT/ConnectionEditor_ui.h"
#include "XTT/CellEditor_ui.h"
#include "XTT/DeleteTable_ui.h"
#include "XTT/TableEditor_ui.h"
#include "XTT/ColumnEditor_ui.h"
#include "XTT/AttributeDelete_ui.h"
#include "XTT/AttributeEditor_ui.h"
#include "XTT/AttributeManager_ui.h"
#include "XTT/GroupManager_ui.h"

#include "sysTrayObject.h"
#include "Settings_ui.h"
#include "About_ui.h"

#include "MainWin_ui.h"
// -----------------------------------------------------------------------------

#define ARD_DOCKED_WIDGETS 1
// -----------------------------------------------------------------------------

// Okienko glowne aplikacji
MainWin_ui* MainWin;
// -----------------------------------------------------------------------------

/**
 * Konstruktor kalsy
 * @param QWidget *parent - Wskanik do rodzica
 * @returns Brak zwracanych wartosci
*/
MainWin_ui::MainWin_ui(QMainWindow*)
{	
	QApplication::setStyle(new QPlastiqueStyle);
     setupUi(this);
	
	setAcceptDrops(true);
	setWindowIcon(QIcon(":/all_images/images/mainico.bmp")); 
	
	/// ARD
	ard_modelView = new ardGraphicsView(centralwidget);
	ard_modelView->setObjectName(QString::fromUtf8("ard_graphicsView"));
	gridLayout->addWidget(ard_modelView, 0, 0, 1, 1);
	
	ard_modelScene = new ardGraphicsScene(ard_modelView);
	ard_modelScene->setItemIndexMethod(QGraphicsScene::NoIndex);
     ard_modelScene->setSceneRect(-200, -200, 400, 400);
	fCurrentARDscene = ard_modelScene;
	
	/// XTT
	xtt_graphicsView = new MyGraphicsView(centralwidget);
	xtt_graphicsView->setObjectName(QString::fromUtf8("graphicsView"));
	gridLayout->addWidget(xtt_graphicsView, 0, 0, 1, 1);
	
	xtt_scene = new MyGraphicsScene(xtt_graphicsView);
     xtt_scene->setItemIndexMethod(QGraphicsScene::NoIndex);
     xtt_scene->setSceneRect(-200, -200, 400, 400);
	
	printer = 0;
	
	action_New->setStatusTip("Create new project");
	action_Open->setStatusTip("Open project...");
     action_Save->setStatusTip("Save project");
     action_Close->setStatusTip("Close program");
     actionEdit_tabele->setStatusTip("Run table editor...");
     actionEdit_attribute->setStatusTip("Run attribute editor...");
     actionNew_tabele->setStatusTip("Create new table dialog...");
	actionEdit_Attribute->setStatusTip("Delete table dialog...");
     actionAbout->setStatusTip("Show information about this program...");
     action_New_attribute->setStatusTip("Create new attribute...");
     actionDelete_attribute->setStatusTip("Delete attribute dialog...");
     action_Attribute_manager->setStatusTip("Run attributes magager...");
     actionGroups_manager->setStatusTip("Run groups manager...");
     actionQLine->setStatusTip("qline");
     actionZoom_in->setStatusTip("Increase zoom factor");
     actionZoom_out->setStatusTip("Decrease zoom factor");
     actionRotate_90->setStatusTip("rot90");
     actionCell_editor->setStatusTip("Run cell editor...");
     action_Add_new_connection->setStatusTip("Add new table dialog...");
     actionConnection_manager->setStatusTip("Run connections manager...");
     action_Edit_connection->setStatusTip("Connections editor...");
     action_Delete_connection->setStatusTip("Delete connections dialog...");
     actionZoom_in_2->setStatusTip("Increase zoom factor");
     actionZoom_out_2->setStatusTip("Decrease zoom factor");
     actionMove_all_left->setStatusTip("Moves all items left");
     actionMove_all_right->setStatusTip("Moves all items right");
     actionMove_all_down->setStatusTip("Moves all items down");
     actionMove_all_up->setStatusTip("Moves all items up");
     actionAdapt_scene_size->setStatusTip("Adapt scene size");
     actionAntialiasing->setStatusTip("On/Off antialiasing");
     actionTextAntialiasing->setStatusTip("On/Off text antialiasing");
     actionSmooth_pixmap_transform->setStatusTip("On/Off smooth pixmap transform");
     actionUnused_attributes->setStatusTip("Show unused attributes...");
     actionNew_with_the_same_attributes->setStatusTip("Create new project, but keep defined attributes");
     actionRun->setStatusTip("Verify and execute model");
     actionB_W_view->setStatusTip("Change color mode");
     actionXTTML_file_ver_1_0->setStatusTip("Save model to xttml ver. 1.0 file...");
     actionXTTML_file_ver_2_0->setStatusTip("Save model to xttml ver. 2.0 file...");
     actionXTTML_file_ver_3_0->setStatusTip("Save model to xttml ver. 3.0 file...");
     actionXTTML_file_ver_4_0->setStatusTip("Save model to xttml ver. 4.0 file...");
     actionATTML_file_ver_1_0->setStatusTip("Save attributes to attml ver. 1.0 file...");
     actionATTML_file_ver_2_0->setStatusTip("Save attributes to attml ver. 2.0 file...");
     actionAttribute_import->setStatusTip("Import attributes from attml file...");
     actionReset_rotate->setStatusTip("Set the rotate angle to zero");
	actionExoprt_scene_to_SVG_file->setStatusTip("Save scene as SVG picture (Scalable Vector Graphics)");
	actionExoprt_scene_to_PNG_file->setStatusTip("Save scene as PNG picture (Portable Network Graphics)");
	actionExoprt_scene_to_BMP_file->setStatusTip("Save scene as BMP picture (Windows Bitmap)");
	actionExoprt_scene_to_JPG_file->setStatusTip("Save scene as JPG picture (Joint Photographic Experts Group)");
	actionExoprt_scene_to_PPM_file->setStatusTip("Save scene as PPM picture (Portable Pixmap)");
	actionExoprt_scene_to_XBM_file->setStatusTip("Save scene as XBM picture (X11 Bitmap)");
	actionExoprt_scene_to_XPM_file->setStatusTip("Save scene as XPM picture (X11 Pixmap)");
	actionPrint->setStatusTip("Print the scene");
	actionPrint_setup->setStatusTip("Printer setup...");
	actionSettings->setStatusTip("Application settings...");

     // signals/slots mechanism in action
     connect(action_New_attribute, SIGNAL(triggered()), this, SLOT(AddNewAttribute()));
     //connect(toolButton_8, SIGNAL(clicked()), this, SLOT(AddNewAttribute()));
     connect(actionEdit_attribute, SIGNAL(triggered()), this, SLOT(EditAttribute()));
     connect(actionDelete_attribute, SIGNAL(triggered()), this, SLOT(DeleteAttribute()));
     //connect(toolButton_12, SIGNAL(clicked()), this, SLOT(DeleteAttribute()));
     connect(actionGroups_manager, SIGNAL(triggered()), this, SLOT(GroupManagerShow()));
     connect(action_Attribute_manager, SIGNAL(triggered()), this, SLOT(AttributeManagerShow()));
     connect(actionNew_tabele, SIGNAL(triggered()), this, SLOT(TableEditorShow()));
     //connect(toolButton_7, SIGNAL(clicked()), this, SLOT(TableEditorShow()));
     connect(actionEdit_tabele, SIGNAL(triggered()), this, SLOT(TableEditorEdit()));
     connect(actionEdit_Attribute, SIGNAL(triggered()), this, SLOT(DeleteTableShow()));
     //connect(toolButton_11, SIGNAL(clicked()), this, SLOT(DeleteTableShow()));
     connect(actionCell_editor, SIGNAL(triggered()), this, SLOT(ShowCellEditor()));
     connect(action_Add_new_connection, SIGNAL(triggered()), this, SLOT(ShowConnEditor()));
     //connect(toolButton_10, SIGNAL(clicked()), this, SLOT(ShowConnEditor()));
     connect(action_Edit_connection, SIGNAL(triggered()), this, SLOT(ShowConnEditorInEditMode()));
     connect(action_Delete_connection, SIGNAL(triggered()), this, SLOT(ShowConnectionDeleteWindow()));
     //connect(toolButton_13, SIGNAL(clicked()), this, SLOT(ShowConnectionDeleteWindow()));
     connect(actionConnection_manager, SIGNAL(triggered()), this, SLOT(ShowConnectionManager()));
     //connect(toolButton_6, SIGNAL(clicked()), this, SLOT(zout()));
     //connect(toolButton_4, SIGNAL(clicked()), this, SLOT(zin()));
     connect(actionAntialiasing, SIGNAL(triggered()), this, SLOT(UpdateRenderHints()));
     connect(actionTextAntialiasing, SIGNAL(triggered()), this, SLOT(UpdateRenderHints()));
     connect(actionSmooth_pixmap_transform, SIGNAL(triggered()), this, SLOT(UpdateRenderHints()));
     //connect(toolButton_14, SIGNAL(clicked()), this, SLOT(ChangeAntialiasingStatus()));
     //connect(toolButton_16, SIGNAL(clicked()), this, SLOT(AdaptSceneSize()));
     //connect(toolButton_5, SIGNAL(clicked()), this, SLOT(CloseForm()));
	connect(this, SIGNAL(destroyed()), this, SLOT(CloseForm()));
     connect(action_Close, SIGNAL(triggered()), this, SLOT(CloseForm()));
     //connect(toolButton_17, SIGNAL(clicked()), this, SLOT(ShowUnusedAttributes()));
     connect(actionUnused_attributes, SIGNAL(triggered()), this, SLOT(ShowUnusedAttributes()));
     connect(actionAbout, SIGNAL(triggered()), this, SLOT(ShowAboutWin()));
     //connect(toolButton_9, SIGNAL(clicked()), this, SLOT(ShowAboutWin()));
     //connect(toolButton, SIGNAL(clicked()), this, SLOT(NewClick()));
     connect(action_New, SIGNAL(triggered()), this, SLOT(NewClick()));
     connect(actionNew_with_the_same_attributes, SIGNAL(triggered()), this, SLOT(NewWhithOldAttributiesClick()));
     connect(action_Save, SIGNAL(triggered()), this, SLOT(saveToXTTML2_0()));
     //connect(toolButton_3, SIGNAL(clicked()), this, SLOT(saveToXTTML2_0()));
     connect(actionXTTML_file_ver_1_0, SIGNAL(triggered()), this, SLOT(saveAs_xttml_1_0()));
	connect(actionXTTML_file_ver_2_0, SIGNAL(triggered()), this, SLOT(saveAs_xttml_2_0()));
     //connect(toolButton_2, SIGNAL(clicked()), this, SLOT(openFile()));
     //connect(toolButton_15, SIGNAL(clicked()), this, SLOT(ExecuteModel()));
     connect(actionRun, SIGNAL(triggered()), this, SLOT(ExecuteModel()));
     connect(actionB_W_view, SIGNAL(triggered()), this, SLOT(SwitchColorMode()));
	connect(actionAttribute_import, SIGNAL(triggered()), this, SLOT(openATTMLFile()));
	connect(actionATTML_file_ver_1_0, SIGNAL(triggered()), this, SLOT(saveToATTML1_0()));
	connect(actionReset_rotate, SIGNAL(triggered()), this, SLOT(resetRotate()));
	connect(actionExoprt_scene_to_SVG_file, SIGNAL(triggered()), this, SLOT(exportSceneToSVGfile()));
	connect(actionExoprt_scene_to_PNG_file, SIGNAL(triggered()), this, SLOT(exportSceneToPNGfile()));
	connect(actionExoprt_scene_to_BMP_file, SIGNAL(triggered()), this, SLOT(exportSceneToBMPfile()));
	connect(actionExoprt_scene_to_JPG_file, SIGNAL(triggered()), this, SLOT(exportSceneToJPGfile()));
	connect(actionExoprt_scene_to_PPM_file, SIGNAL(triggered()), this, SLOT(exportSceneToPPMfile()));
	connect(actionExoprt_scene_to_XBM_file, SIGNAL(triggered()), this, SLOT(exportSceneToXBMfile()));
	connect(actionExoprt_scene_to_XPM_file, SIGNAL(triggered()), this, SLOT(exportSceneToXPMfile()));
	connect(actionExoprt_TPH_diagram_to_SVG_file, SIGNAL(triggered()), this, SLOT(exportTPHtoSVGfile()));
	connect(actionExoprt_TPH_diagram_to_PNG_file, SIGNAL(triggered()), this, SLOT(exportTPHtoPNGfile()));
	connect(actionExoprt_TPH_diagram_to_BMP_file, SIGNAL(triggered()), this, SLOT(exportTPHtoBMPfile()));
	connect(actionExoprt_TPH_diagram_to_JPG_file, SIGNAL(triggered()), this, SLOT(exportTPHtoJPGfile()));
	connect(actionExoprt_TPH_diagram_to_PPM_file, SIGNAL(triggered()), this, SLOT(exportTPHtoPPMfile()));
	connect(actionExoprt_TPH_diagram_to_XBM_file, SIGNAL(triggered()), this, SLOT(exportTPHtoXBMfile()));
	connect(actionExoprt_TPH_diagram_to_XPM_file, SIGNAL(triggered()), this, SLOT(exportTPHtoXPMfile()));
	connect(actionAbout_Qt, SIGNAL(triggered()), qApp, SLOT(aboutQt()));
	connect(actionPrint, SIGNAL(triggered()), this, SLOT(printModel()));
	connect(actionPrint_setup, SIGNAL(triggered()), this, SLOT(printSetup()));
	connect(actionSettings, SIGNAL(triggered()), this, SLOT(showConfigurationDialog()));
	connect(actionARD_editor, SIGNAL(triggered()), this, SLOT(useARDmode()));
	connect(actionXTT_editor, SIGNAL(triggered()), this, SLOT(useXTTmode()));
	
	// Tworzenie okienek dokowalnych i paskow narzedzi
	xtt_createMenu();
	ard_createDockWindows();
	xtt_createDockWindows();
	xtt_createToolBars();
	createStatusBar();
	
	// Dodanie do menu skrotow klawiaturowych
	actionMove_all_right->setShortcut(Qt::CTRL + Qt::Key_Right);
	actionMove_all_left->setShortcut(Qt::CTRL + Qt::Key_Left);
	actionMove_all_up->setShortcut(Qt::CTRL + Qt::Key_Up);
	actionMove_all_down->setShortcut(Qt::CTRL + Qt::Key_Down);
	actionReset_rotate->setShortcut(tr("Ctrl+R"));
	actionARD_editor->setShortcut(tr("F11"));
	actionXTT_editor->setShortcut(tr("F12"));
	
	// Ustawienie wlaczonych przyciskow renderingu
	actionAntialiasing->setChecked(true);
	actionTextAntialiasing->setChecked(true);
	actionSmooth_pixmap_transform->setChecked(true);

     xtt_graphicsView->setScene(xtt_scene);
     xtt_graphicsView->setCacheMode(QGraphicsView::CacheBackground);
     xtt_graphicsView->setRenderHints(QPainter::Antialiasing | QPainter::TextAntialiasing | QPainter::SmoothPixmapTransform);
     xtt_graphicsView->setTransformationAnchor(QGraphicsView::AnchorUnderMouse);
     xtt_graphicsView->setResizeAnchor(QGraphicsView::AnchorViewCenter);
     xtt_scene->AdaptSceneSize();
	
	ard_modelView->setScene(ard_modelScene);
     ard_modelView->setCacheMode(QGraphicsView::CacheBackground);
     ard_modelView->setRenderHints(QPainter::Antialiasing | QPainter::TextAntialiasing | QPainter::SmoothPixmapTransform);
     ard_modelView->setTransformationAnchor(QGraphicsView::AnchorUnderMouse);
     ard_modelView->setResizeAnchor(QGraphicsView::AnchorViewCenter);
     ard_modelScene->AdaptSceneSize();
	
	ard_tphView->setScene(ard_thpScene);
     ard_tphView->setCacheMode(QGraphicsView::CacheBackground);
     ard_tphView->setRenderHints(QPainter::Antialiasing | QPainter::TextAntialiasing | QPainter::SmoothPixmapTransform);
     ard_tphView->setTransformationAnchor(QGraphicsView::AnchorUnderMouse);
     ard_tphView->setResizeAnchor(QGraphicsView::AnchorViewCenter);
     ard_thpScene->AdaptSceneSize();
	
	menu_Execute->setTearOffEnabled(true);
	menu_Edit->setTearOffEnabled(true);
	menu_Connections->setTearOffEnabled(true);
	menu_View->setTearOffEnabled(true);
	menu_Help->setTearOffEnabled(true);
	menu_File->setTearOffEnabled(true);
	menuS_ave_as->setTearOffEnabled(true);
	menuAttribute_export->setTearOffEnabled(true);
	menuExport_scene_view->setTearOffEnabled(true);
	menuTools->setTearOffEnabled(true);
	menu_View_2->setTearOffEnabled(true);
	menuRender_hint->setTearOffEnabled(true);
	menuMode->setTearOffEnabled(true);
	menuExport_TPH_diagram->setTearOffEnabled(true);

	// Odczyt opcji czy nalezy pokazac wskazowki dla trybow pracy programu
	fShowARDtip = Settings->showTrayTips();
	fShowXTTtip = Settings->showTrayTips();
	
     isXTTFile = false;
     fXttFileName = "New project";
	setXTT_Changed(false);
	
	isARDFile = false;
     fArdFileName = "New project";
	//setARD_Changed(false);
	
	// Utworzenie ikony w zasobniku
	trayIcon = new sysTrayObject(this);
	if((Settings->showSystemTrayIcon()) && (QSystemTrayIcon::isSystemTrayAvailable()))
		trayIcon->show();
	
	setCurrentMode(1);
}
// -----------------------------------------------------------------------------

/**
 * Destruktor okienka, kasuje dynamicznie zaalokowane obiekty
 * @returns Brak zwracanych wartoci
*/
MainWin_ui::~MainWin_ui(void)
{
	delete xtt_graphicsView;
	delete xtt_scene;
	
	delete ard_modelView;
	delete ard_tphView;
	delete ard_modelScene;
	delete ard_thpScene;
	
	delete printer;
	
	delete toolBarMenu;
	delete fileToolBar;
     delete viewToolBar;
	delete tableToolBar;
	delete attributesToolBar;
	delete connectionsToolBar;
	delete executeToolBar;
	delete helpToolBar;
	delete dial;
	delete rotateAngleEdit;
	delete fCurrentARDscene;
	delete rotateAngleEdit;
	delete dial;
	delete dockedWindows;
	delete printer;
	
	delete ard_tphDockWindow;
	delete xtt_errorsDockWindow;
	delete xtt_runModelMessagesDockWindow;
	
	delete xtt_runModelMessagesDockWindowContents;
	delete xtt_runModelMessagesDockWindowGridLayout;
	delete xtt_runModelMessagesDockWindowMessagesList;
	delete xtt_runModelMessagesDockWindowSpacerItem;
	delete xtt_runModelMessagesDockWindowInfoCheckBox;
	delete xtt_runModelMessagesDockWindowWarningCheckBox;
	delete xtt_runModelMessagesDockWindowErrorCheckBox;
	delete xtt_runModelMessagesDockWindowLabel;
	
	delete trayIcon;
	//delete trayIconMenu;
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie pojawienia sie okienka na ekranie
 * @param QShowEvent* event - zmienna przechwujaca parametry zdarzenia
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::showEvent(QShowEvent*)
{
	if((qApp->arguments().count() == 2) && (QFile::exists(qApp->arguments().at(1))))
		openFile(qApp->arguments().at(1));
}
// -----------------------------------------------------------------------------

/**
 * Metoda obslugujaca zdarzenie upuszczania pliku na obszar okienka, sprawdza typ danych w upuszczanym elemencie
 * @param QDragEnterEvent *event - parametry danych upuszczanych na formularz
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::dragEnterEvent(QDragEnterEvent *event)
{
     if(event->mimeData()->hasFormat("text/uri-list"))
		event->acceptProposedAction();
}
// -----------------------------------------------------------------------------

/**
 * Metoda wobslugujaca zdarzenie upuszczania pliku na obszar okienka
 * @param QDragEnterEvent *event - parametry danych upuszczanych na formularz
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::dropEvent(QDropEvent *event)
{
	QList<QUrl> urlList = event->mimeData()->urls();
	if(urlList.size() > 0)
	{
		  QString url = urlList.at(0).toLocalFile();
		  openFile(url);
	}

     event->acceptProposedAction();
} 
// -----------------------------------------------------------------------------

/**
 * Metoda tworzaca menu
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::xtt_createMenu(void)
{
	toolBarMenu = new QMenu("Tollbar");
	menu_View_2->insertMenu(actionZoom_in_2, toolBarMenu);
	menu_View_2->insertSeparator(actionZoom_in_2);
	
	dockedWindows = new QMenu("Docked windows");
	menu_View_2->insertMenu(actionZoom_in_2, dockedWindows);
	menu_View_2->insertSeparator(actionZoom_in_2);
}
// -----------------------------------------------------------------------------

/**
 * Metoda tworzaca pasek przyciskow
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::xtt_createToolBars(void)
{
	// Menu File
	fileToolBar = addToolBar(tr("File"));
	fileToolBar->addAction(action_Close);
	fileToolBar->addSeparator();
     fileToolBar->addAction(action_New);
     fileToolBar->addAction(action_Open);
     fileToolBar->addAction(action_Save);
	fileToolBar->addSeparator();
	fileToolBar->addAction(actionExoprt_scene_to_SVG_file);
	fileToolBar->addSeparator();
	fileToolBar->addAction(actionPrint);
     fileToolBar->addAction(actionPrint_setup);
	toolBarMenu->addAction(fileToolBar->toggleViewAction());
	
	// Obiekty umieszczane na pasku
	dial = new QDial(NULL);
     dial->setGeometry(0, 0, 32, 32);
	dial->setMaximumSize(32, 32);
	dial->setMinimum(0);
	dial->setMaximum(359);
	dial->setStatusTip("Rotate scene");
	rotateAngleEdit = new QSpinBox(NULL);
	rotateAngleEdit->setMaximumSize(40, 20);
	rotateAngleEdit->setMinimum(0);
	rotateAngleEdit->setMaximum(359);
	connect(dial, SIGNAL(valueChanged(int)), rotateAngleEdit, SLOT(setValue(int)));
	connect(rotateAngleEdit, SIGNAL(valueChanged(int)), this, SLOT(angleEditorChange(int)));
	
	// Menu view
	viewToolBar = addToolBar(tr("View"));
	viewToolBar->addAction(actionZoom_in_2);
	viewToolBar->addAction(actionZoom_out_2);
	viewToolBar->addSeparator();
	viewToolBar->addAction(actionMove_all_left);
	viewToolBar->addAction(actionMove_all_right);
	viewToolBar->addAction(actionMove_all_up);
	viewToolBar->addAction(actionMove_all_down);
	viewToolBar->addSeparator();
	viewToolBar->addAction(actionAdapt_scene_size);
	viewToolBar->addSeparator();
	viewToolBar->addWidget(dial);
	viewToolBar->addWidget(rotateAngleEdit);
	toolBarMenu->addAction(viewToolBar->toggleViewAction());
	
	// Menu atrybutow
	attributesToolBar = addToolBar(tr("Atributes"));
	attributesToolBar->addAction(action_New_attribute);
	attributesToolBar->addAction(actionEdit_attribute);
	attributesToolBar->addAction(actionDelete_attribute);
	attributesToolBar->addSeparator();
	attributesToolBar->addAction(actionUnused_attributes);
	attributesToolBar->addSeparator();
	attributesToolBar->addAction(action_Attribute_manager);
	attributesToolBar->addSeparator();
	attributesToolBar->addAction(actionGroups_manager);
	toolBarMenu->addAction(attributesToolBar->toggleViewAction());
	
	// Menu tabeli
	tableToolBar = addToolBar(tr("Table"));
     tableToolBar->addAction(actionNew_tabele);
	tableToolBar->addAction(actionEdit_tabele);
	tableToolBar->addAction(actionEdit_Attribute);
	tableToolBar->addSeparator();
	tableToolBar->addAction(actionCell_editor);
	toolBarMenu->addAction(tableToolBar->toggleViewAction());
	
	// Menu polaczen
	connectionsToolBar = addToolBar(tr("Connections"));
	connectionsToolBar->addAction(action_Add_new_connection);
	connectionsToolBar->addAction(action_Edit_connection);
	connectionsToolBar->addAction(action_Delete_connection);
	connectionsToolBar->addSeparator();
	connectionsToolBar->addAction(actionConnection_manager);
	toolBarMenu->addAction(connectionsToolBar->toggleViewAction());
	
	// Menu uruchamiania
	executeToolBar = addToolBar(tr("Execute"));
	executeToolBar->addAction(actionRun);
	toolBarMenu->addAction(executeToolBar->toggleViewAction());
	
	// Menu narzedzi
	toolsToolBar = addToolBar(tr("Settings"));
	toolsToolBar->addAction(actionSettings);
	toolBarMenu->addAction(toolsToolBar->toggleViewAction());
	
	// Menu pomocy
	helpToolBar = addToolBar(tr("Help"));
	helpToolBar->addAction(actionAbout);
	toolBarMenu->addAction(helpToolBar->toggleViewAction());
	
	addToolBar(Qt::LeftToolBarArea, viewToolBar);
}
// -----------------------------------------------------------------------------

/**
 * Metoda tworzaca okna dokowane
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::ard_createDockWindows(void)
{
	// Tworzenie okna bledow
     ard_tphDockWindow = new QDockWidget(tr("TPH diagram"), this);
	ard_tphView = new ardGraphicsView(ard_tphDockWindow);
     ard_thpScene = new ardGraphicsScene(ard_tphView);
     ard_tphDockWindow->setWidget(ard_tphView);
	addDockWidget(Qt::LeftDockWidgetArea, ard_tphDockWindow);
     dockedWindows->addAction(ard_tphDockWindow->toggleViewAction());
}
// -----------------------------------------------------------------------------

/**
 * Metoda tworzaca okna dokowane
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::xtt_createDockWindows(void)
{
	// Tworzenie okna bledow
     xtt_errorsDockWindow = new QDockWidget(tr("Errors"), this);
     xtt_errorsDockWindow->setAllowedAreas(Qt::TopDockWidgetArea | Qt::BottomDockWidgetArea);
     xtt_errorsList = new ErrorsListWidget(xtt_errorsDockWindow);
     xtt_errorsDockWindow->setWidget(xtt_errorsList);
	addDockWidget(Qt::BottomDockWidgetArea, xtt_errorsDockWindow);
     dockedWindows->addAction(xtt_errorsDockWindow->toggleViewAction());
	
	// Tworzenie okna informacji o uruchomieniu
	xtt_runModelMessagesDockWindow = new QDockWidget(tr("Execute messages"), this);
	xtt_runModelMessagesDockWindow->setObjectName(QString::fromUtf8("Execute messages"));
	xtt_runModelMessagesDockWindow->setGeometry(QRect(40, 0, 261, 221));
	xtt_runModelMessagesDockWindowContents = new QWidget(xtt_runModelMessagesDockWindow);
	xtt_runModelMessagesDockWindowContents->setObjectName(QString::fromUtf8("xtt_runModelMessagesDockWindowContents"));
	xtt_runModelMessagesDockWindowMessagesList = new ExecMsgListWidget(xtt_runModelMessagesDockWindowContents);
	xtt_runModelMessagesDockWindowMessagesList->setObjectName(QString::fromUtf8("xtt_runModelMessagesDockWindowMessagesList"));
	xtt_runModelMessagesDockWindowInfoCheckBox = new QCheckBox(xtt_runModelMessagesDockWindowContents);
	xtt_runModelMessagesDockWindowInfoCheckBox->setObjectName(QString::fromUtf8("xtt_runModelMessagesDockWindowInfoCheckBox"));
	xtt_runModelMessagesDockWindowInfoCheckBox->setIcon(QIcon(QString::fromUtf8(":/all_images/images/information_small.bmp")));
	xtt_runModelMessagesDockWindowWarningCheckBox = new QCheckBox(xtt_runModelMessagesDockWindowContents);
	xtt_runModelMessagesDockWindowWarningCheckBox->setObjectName(QString::fromUtf8("xtt_runModelMessagesDockWindowWarningCheckBox"));
	xtt_runModelMessagesDockWindowWarningCheckBox->setIcon(QIcon(QString::fromUtf8(":/all_images/images/warning_small.bmp")));
	xtt_runModelMessagesDockWindowLabel = new QLabel(this);
	xtt_runModelMessagesDockWindowLabel->setText("Message filter:");
	xtt_runModelMessagesDockWindowLabel->setMargin(5);
	xtt_runModelMessagesDockWindowErrorCheckBox = new QCheckBox(xtt_runModelMessagesDockWindowContents);
	xtt_runModelMessagesDockWindowErrorCheckBox->setObjectName(QString::fromUtf8("xtt_runModelMessagesDockWindowErrorCheckBox"));
	xtt_runModelMessagesDockWindowErrorCheckBox->setIcon(QIcon(QString::fromUtf8(":/all_images/images/critical_small.bmp")));
	xtt_runModelMessagesDockWindowInfoCheckBox->setText(QString());
	xtt_runModelMessagesDockWindowWarningCheckBox->setText(QString());
	xtt_runModelMessagesDockWindowErrorCheckBox->setText(QString());
	xtt_runModelMessagesDockWindowInfoCheckBox->setChecked(true);
	xtt_runModelMessagesDockWindowWarningCheckBox->setChecked(true);
	xtt_runModelMessagesDockWindowErrorCheckBox->setChecked(true);
	xtt_runModelMessagesDockWindowErrorCheckBox->setIconSize(QSize(18, 18));
	xtt_runModelMessagesDockWindowWarningCheckBox->setIconSize(QSize(18, 18));
	xtt_runModelMessagesDockWindowInfoCheckBox->setIconSize(QSize(18, 18));
	xtt_runModelMessagesDockWindowSpacerItem = new QSpacerItem(131, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);
	xtt_runModelMessagesDockWindowGridLayout = new QGridLayout(xtt_runModelMessagesDockWindowContents);
	#ifndef Q_OS_MAC
		xtt_runModelMessagesDockWindowGridLayout->setSpacing(6);
	#endif
	#ifndef Q_OS_MAC
		xtt_runModelMessagesDockWindowGridLayout->setMargin(9);
	#endif
	#ifdef __USE_SVG
		xtt_runModelMessagesDockWindowGridLayout->setContentsMargins(0, 0, 0, 0);
	#endif
	xtt_runModelMessagesDockWindowGridLayout->setObjectName(QString::fromUtf8("xtt_runModelMessagesDockWindowGridLayout"));
	xtt_runModelMessagesDockWindowGridLayout->addItem(xtt_runModelMessagesDockWindowSpacerItem,        0, 4, 1, 1);
	xtt_runModelMessagesDockWindowGridLayout->addWidget(xtt_runModelMessagesDockWindowMessagesList,    1, 0, 1, 5);
	xtt_runModelMessagesDockWindowGridLayout->addWidget(xtt_runModelMessagesDockWindowLabel,           0, 0, 1, 1);
	xtt_runModelMessagesDockWindowGridLayout->addWidget(xtt_runModelMessagesDockWindowErrorCheckBox,   0, 1, 1, 1);
	xtt_runModelMessagesDockWindowGridLayout->addWidget(xtt_runModelMessagesDockWindowWarningCheckBox, 0, 2, 1, 1);
	xtt_runModelMessagesDockWindowGridLayout->addWidget(xtt_runModelMessagesDockWindowInfoCheckBox,    0, 3, 1, 1);
	xtt_runModelMessagesDockWindow->setWidget(xtt_runModelMessagesDockWindowContents);
	connect(xtt_runModelMessagesDockWindowErrorCheckBox, SIGNAL(toggled(bool)), xtt_runModelMessagesDockWindowMessagesList, SLOT(showErrors(bool)));
	connect(xtt_runModelMessagesDockWindowWarningCheckBox, SIGNAL(toggled(bool)), xtt_runModelMessagesDockWindowMessagesList, SLOT(showWarnings(bool)));
	connect(xtt_runModelMessagesDockWindowInfoCheckBox, SIGNAL(toggled(bool)), xtt_runModelMessagesDockWindowMessagesList, SLOT(showInformations(bool)));
	addDockWidget(Qt::BottomDockWidgetArea, xtt_runModelMessagesDockWindow);
	dockedWindows->addAction(xtt_runModelMessagesDockWindow->toggleViewAction());

}
// -----------------------------------------------------------------------------

/**
 * Metoda tworzaca pasek statusu
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::createStatusBar(void)
{
	statusBar()->showMessage(tr("Ready"));
}
// -----------------------------------------------------------------------------

/**
 * Zwraca tryb pracy aplikacji
 * @returns 0-edytor ARD, 1-edytor XTT
*/
int MainWin_ui::currentMode(void)
{
	return appMode;
}
// -----------------------------------------------------------------------------

/**
 * Ustawia bierzacy tryb pracy aplikacji
 * @param int _newMode - Nowy tryb pracy aplikacji 0-edytor ARD, 1-edyotr XTT
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::setCurrentMode(int _newMode)
{
	if((_newMode < 0) || (_newMode > 1))
		return;
	
	ard_modelView->setVisible(_newMode == ARD_MODE);
	ard_tphDockWindow->setVisible(_newMode == ARD_MODE);
	actionARD_editor->setChecked(_newMode == ARD_MODE);
	actionExoprt_TPH_diagram_to_SVG_file->setVisible(_newMode == ARD_MODE);
	actionExoprt_TPH_diagram_to_BMP_file->setVisible(_newMode == ARD_MODE);
	actionExoprt_TPH_diagram_to_PNG_file->setVisible(_newMode == ARD_MODE);
	actionExoprt_TPH_diagram_to_JPG_file->setVisible(_newMode == ARD_MODE);
	actionExoprt_TPH_diagram_to_PPM_file->setVisible(_newMode == ARD_MODE);
	actionExoprt_TPH_diagram_to_XBM_file->setVisible(_newMode == ARD_MODE);
	actionExoprt_TPH_diagram_to_XPM_file->setVisible(_newMode == ARD_MODE);
	actionCreate_XTT->setVisible(_newMode == ARD_MODE);
	actionARDML_file_ver_1_0->setVisible(_newMode == ARD_MODE);
	
	xtt_graphicsView->setVisible(_newMode == XTT_MODE);
	xtt_errorsDockWindow->setVisible(_newMode == XTT_MODE);
	xtt_runModelMessagesDockWindow->setVisible(_newMode == XTT_MODE);
	actionXTT_editor->setChecked(_newMode == XTT_MODE);
	tableToolBar->setVisible(_newMode == XTT_MODE);
	attributesToolBar->setVisible(_newMode == XTT_MODE);
	connectionsToolBar->setVisible(_newMode == XTT_MODE);
	executeToolBar->setVisible(_newMode == XTT_MODE);
	actionRun->setVisible(_newMode == XTT_MODE);
	actionNew_with_the_same_attributes->setVisible(_newMode == XTT_MODE);
	
	for(int i=0;i<dockedWindows->actions().size();++i)
		dockedWindows->actions().at(i)->setVisible(((i < ARD_DOCKED_WIDGETS) && (_newMode == ARD_MODE)) || ((i >= ARD_DOCKED_WIDGETS) && (_newMode == XTT_MODE)));
		
	// Rozlaczanie odpowiednich slotow
	disconnect(action_Open, 0, 0, 0); 
	disconnect(dial, SIGNAL(valueChanged(int)), 0, 0); 
	disconnect(rotateAngleEdit, SIGNAL(valueChanged(int)), 0, 0);
	disconnect(actionZoom_out_2, SIGNAL(triggered()), 0, 0);
	disconnect(actionZoom_in_2, SIGNAL(triggered()), 0, 0);
	disconnect(actionMove_all_right, SIGNAL(triggered()), 0, 0);
	disconnect(actionMove_all_left, SIGNAL(triggered()), 0, 0);
	disconnect(actionMove_all_up, SIGNAL(triggered()), 0, 0);
	disconnect(actionMove_all_down, SIGNAL(triggered()), 0, 0);
	disconnect(actionAdapt_scene_size, SIGNAL(triggered()), 0, 0);
	
	if(_newMode == ARD_MODE) 
	{
		dial->setValue(fCurrentARDscene->currentAngle());
		rotateAngleEdit->setValue(fCurrentARDscene->currentAngle());
		
		setWindowTitle("ARD Editor - [" + fArdFileName + "]");
		connect(action_Open, SIGNAL(triggered()), this, SLOT(openARDFileDialog()));
		
		connect(dial, SIGNAL(valueChanged(int)), rotateAngleEdit, SLOT(setValue(int)));
		connect(rotateAngleEdit, SIGNAL(valueChanged(int)), this, SLOT(angleEditorChange(int)));
		connect(dial, SIGNAL(valueChanged(int)), fCurrentARDscene, SLOT(Rotate(int)));
		connect(actionZoom_out_2, SIGNAL(triggered()), fCurrentARDscene, SLOT(zout()));
		connect(actionZoom_in_2, SIGNAL(triggered()), fCurrentARDscene, SLOT(zin()));
		connect(actionMove_all_right, SIGNAL(triggered()), fCurrentARDscene, SLOT(MoveItemsRight()));
		connect(actionMove_all_left, SIGNAL(triggered()), fCurrentARDscene, SLOT(MoveItemsLeft()));
		connect(actionMove_all_up, SIGNAL(triggered()), fCurrentARDscene, SLOT(MoveItemsUp()));
		connect(actionMove_all_down, SIGNAL(triggered()), fCurrentARDscene, SLOT(MoveItemsDown()));
		connect(actionAdapt_scene_size, SIGNAL(triggered()), fCurrentARDscene, SLOT(AdaptSceneSize()));
		
		menu_View->setTitle("");
		menu_Edit->setTitle("");
		menu_Connections->setTitle("");
		
		// Pokazanie wskazowki dla trybu ARD
		if(((QSystemTrayIcon::isSystemTrayAvailable())) && (QSystemTrayIcon::supportsMessages()) && (Settings->showSystemTrayIcon()) && (fShowARDtip))
		{
			fShowARDtip = false;
			trayIcon->drawTip(ARD_MODE);
			trayIcon->showDrawedTip();
		}
	}
	
	if(_newMode == XTT_MODE) 
	{
		dial->setValue(xtt_scene->currentAngle());
		rotateAngleEdit->setValue(xtt_scene->currentAngle());
		
		setWindowTitle("XTT Editor - [" + fXttFileName + "]");
		connect(action_Open, SIGNAL(triggered()), this, SLOT(openXTTFileDialog()));
		
		connect(dial, SIGNAL(valueChanged(int)), rotateAngleEdit, SLOT(setValue(int)));
		connect(rotateAngleEdit, SIGNAL(valueChanged(int)), this, SLOT(angleEditorChange(int)));
		connect(dial, SIGNAL(valueChanged(int)), xtt_scene, SLOT(Rotate(int)));
		connect(actionZoom_out_2, SIGNAL(triggered()), xtt_scene, SLOT(zout()));
		connect(actionZoom_in_2, SIGNAL(triggered()), xtt_scene, SLOT(zin()));
		connect(actionMove_all_right, SIGNAL(triggered()), xtt_scene, SLOT(MoveItemsRight()));
		connect(actionMove_all_left, SIGNAL(triggered()), xtt_scene, SLOT(MoveItemsLeft()));
		connect(actionMove_all_up, SIGNAL(triggered()), xtt_scene, SLOT(MoveItemsUp()));
		connect(actionMove_all_down, SIGNAL(triggered()), xtt_scene, SLOT(MoveItemsDown()));
		connect(actionAdapt_scene_size, SIGNAL(triggered()), xtt_scene, SLOT(AdaptSceneSize()));
		
		menu_View->setTitle("&Attributes");
		menu_Edit->setTitle("&Table");
		menu_Connections->setTitle("&Connections");
		
		// Pokazanie wskazowki dla trybu ARD
		if(((QSystemTrayIcon::isSystemTrayAvailable())) && (QSystemTrayIcon::supportsMessages()) && (Settings->showSystemTrayIcon()) && (fShowXTTtip))
		{
			fShowXTTtip = false;
			trayIcon->drawTip(XTT_MODE);
			trayIcon->showDrawedTip();
		}
	}
	
	appMode = _newMode;
	
	// Uaktualnienie trybu kolorow
	actionB_W_view->setChecked(Settings->colorMode(_newMode));
	SwitchColorMode();
	
	// Uaktualnienie flag renderingu
	actionAntialiasing->setChecked(Settings->useAntialiasing(_newMode));
	actionTextAntialiasing->setChecked(Settings->useTextAntialiasing(_newMode));
	actionSmooth_pixmap_transform->setChecked(Settings->useSmoothPixmapTransform(_newMode));
	UpdateRenderHints();
}
// -----------------------------------------------------------------------------

/**
 * Przelacza palikacje w tryb edycji ARD
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::useARDmode(void)
{
	setCurrentMode(ARD_MODE);
}
// -----------------------------------------------------------------------------
	
/**
 * Przelacza palikacje w tryb edycji XTT
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::useXTTmode(void)
{
	setCurrentMode(XTT_MODE);
}
// -----------------------------------------------------------------------------

/**
 * Metoda ustawiajaca bierzaca scene ARD, ktora przypisuje odpowiednie sloty do sceny
 * @param ardGraphicsScene* ardncs - Wskaznik do bierzacej sceny ARD
 * @returns Brak zwracanych wartoci
 */
void MainWin_ui::setCurrentARDscene(ardGraphicsScene* ardncs)
{
	if(fCurrentARDscene == ardncs)
		return;
		
	fCurrentARDscene = ardncs;
	
	// Rozlaczanie slotow
	disconnect(dial, SIGNAL(valueChanged(int)), 0, 0); 
	disconnect(actionZoom_out_2, SIGNAL(triggered()), 0, 0);
	disconnect(actionZoom_in_2, SIGNAL(triggered()), 0, 0);
	disconnect(actionMove_all_right, SIGNAL(triggered()), 0, 0);
	disconnect(actionMove_all_left, SIGNAL(triggered()), 0, 0);
	disconnect(actionMove_all_up, SIGNAL(triggered()), 0, 0);
	disconnect(actionMove_all_down, SIGNAL(triggered()), 0, 0);
	disconnect(actionAdapt_scene_size, SIGNAL(triggered()), 0, 0);
	disconnect(rotateAngleEdit, SIGNAL(valueChanged(int)), 0, 0);
	
	// Tworzenie nowych polaczen
	connect(dial, SIGNAL(valueChanged(int)), rotateAngleEdit, SLOT(setValue(int)));
	connect(rotateAngleEdit, SIGNAL(valueChanged(int)), this, SLOT(angleEditorChange(int)));
	connect(dial, SIGNAL(valueChanged(int)), fCurrentARDscene, SLOT(Rotate(int)));
	connect(actionZoom_out_2, SIGNAL(triggered()), fCurrentARDscene, SLOT(zout()));
	connect(actionZoom_in_2, SIGNAL(triggered()), fCurrentARDscene, SLOT(zin()));
	connect(actionMove_all_right, SIGNAL(triggered()), fCurrentARDscene, SLOT(MoveItemsRight()));
	connect(actionMove_all_left, SIGNAL(triggered()), fCurrentARDscene, SLOT(MoveItemsLeft()));
	connect(actionMove_all_up, SIGNAL(triggered()), fCurrentARDscene, SLOT(MoveItemsUp()));
	connect(actionMove_all_down, SIGNAL(triggered()), fCurrentARDscene, SLOT(MoveItemsDown()));
	connect(actionAdapt_scene_size, SIGNAL(triggered()), fCurrentARDscene, SLOT(AdaptSceneSize()));
	
	dial->setValue(fCurrentARDscene->currentAngle());
	rotateAngleEdit->setValue(fCurrentARDscene->currentAngle());
}
// -----------------------------------------------------------------------------

/**
 * Metoda drukujaca model
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::printModel(void)
{
	if(!printer) 
		printer = new QPrinter;
		
     if(printer) 
	{
		QPainter pp(printer);
		
		if(appMode == ARD_MODE)
		{
			QMessageBox msgBox(this);
			msgBox.setText("Which scene would you like print?");
			QPushButton *tphButton = msgBox.addButton(tr("TPH"), QMessageBox::YesRole);
			QPushButton *ardButton = msgBox.addButton(tr("ARD"), QMessageBox::NoRole);
			msgBox.exec();

			if (msgBox.clickedButton() == tphButton) 
				ard_thpScene->render(&pp);
			else if (msgBox.clickedButton() == ardButton)
				ard_modelScene->render(&pp);
		}
		
		if(appMode == XTT_MODE)
			xtt_scene->render(&pp);
     }
}
// -----------------------------------------------------------------------------

/**
 * Wywoluje ustawienia drukarki i ewentualnie pozwala na wydrukowanie
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::printSetup(void)
{
	if(!printer) 
		printer = new QPrinter;
		
	QPrintDialog *dlg = new QPrintDialog(printer, this);
     if(dlg->exec() != QDialog::Accepted)
		return;
	
	printModel();
}
// -----------------------------------------------------------------------------

/**
 * Metoda konczaca dzialanie aplikacji
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::CloseForm(void)
{	
     close();
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zaistnienia zdarzenia prby zmknicia okna, 
 * aplikacji. Potwierdza zapisanie zmian wprowadzonych w projekcie
 * @param QCloseEvent* event - Wskanik do zdarzenia
 * @returns Brak zwracanych wartoci
 */
void MainWin_ui::closeEvent(QCloseEvent* event)
{	
	bool confirmOnlyExit = true;		// Okresla czy nalezy potwierdzuc samo wyjscie z programu

	// Sprawdzanie modyfiakcji pliku
	// if((currentMode() == ARD_MODE) && (ARD_Changed()))
	// {
		// switch(QMessageBox::question(NULL, "ARD Editor", "Current ARD project has been changed. Do you want to save changes?", QMessageBox::Yes | QMessageBox::No | QMessageBox::Cancel))
		// {
			// case QMessageBox::Yes:
				// saveToXTTML1_0(); !!!!!!!!!!!!
				// confirmOnlyExit = false;
				// break;
			// case QMessageBox::No:
				// confirmOnlyExit = false;
				// break;
			// case QMessageBox::Cancel:
				// event->ignore();
				// return;
				// break;
			// default:
				// event->accept();
		// }
	// }
	
	// Sprawdzanie modyfiakcji pliku
	if((currentMode() == XTT_MODE) && (XTT_Changed()))
	{
		switch(QMessageBox::question(NULL, "XTT Editor", "Current XTT project has been changed. Do you want to save changes?", QMessageBox::Yes | QMessageBox::No | QMessageBox::Cancel))
		{
			case QMessageBox::Yes:
				saveToXTTML1_0();
				confirmOnlyExit = false;
				break;
			case QMessageBox::No:
				confirmOnlyExit = false;
				break;
			case QMessageBox::Cancel:
				event->ignore();
				return;
				break;
			default:
				event->accept();
		}
	}
	
	// Potwierdzenie wyjscia z programu
	QString msgCaption = "ARD Editor";
	if(currentMode() == XTT_MODE)
		msgCaption = "XTT Editor";
	
	if((confirmOnlyExit) && (QMessageBox::question(this, msgCaption, "Do you really want to exit?", QMessageBox::Yes | QMessageBox::No) == QMessageBox::No))
	{
		event->ignore();
		return;
	}
	
	// Ukrycie ikony z zasobnika systemowego
	trayIcon->hide();
	
	// Zakonczenie aplikacji
	QCoreApplication::exit();
}
// -----------------------------------------------------------------------------

/**
 * Metoda przelaczajaca pomiedzy widokiem modelu, w kolorze i na czarnobialo
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::SwitchColorMode(void)
{
     // Odswiezenie widoku
	Settings->setColorMode(actionB_W_view->isChecked(), currentMode());
	
	if(appMode == ARD_MODE)
	{
		ardPropertyList->tphTree()->refresh();
		ardLevelList->gLevelList()->alignLevels(0, true);
	}
	if(appMode == XTT_MODE)
	{
	     for(unsigned int i=0;i<ConnectionsList->Count();i++)
	          ConnectionsList->Connection(i)->Repaint();
	     TableList->RefreshAll();
	}
}
// -----------------------------------------------------------------------------

/**
 * Metoda ustawiajaca status antyaliasingu
 * @param bool isON - okresla czy antyaliasing jest wlaczony
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::setAntialiasingStatus(bool isON)
{
	actionAntialiasing->setChecked(isON);
	UpdateRenderHints();
}
// -----------------------------------------------------------------------------

/**
 * Metoda ustawiajaca status antyaliasingu dla tekstu
 * @param bool isON - okresla czy antyaliasing dla tekstu jest wlaczony
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::setTextAntialiasingStatus(bool isON)
{
	actionTextAntialiasing->setChecked(isON);
	UpdateRenderHints();
}
// -----------------------------------------------------------------------------

/**
 * Metoda ustawiajaca status gladkiej transformacji bitmapy
 * @param bool isON - okresla czy gladka transformacja bitmapy jest wlaczona
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::setSmoothPixmapTransformStatus(bool isON)
{
	actionSmooth_pixmap_transform->setChecked(isON);
	UpdateRenderHints();
}
// -----------------------------------------------------------------------------

/**
 * Metoda przelaczajaca pomiedzy widokiem modelu, w kolorze i na czarnobialo
 * @param bool isBW - okresla czy widoczny model ma byc czarnobialy
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::setColorMode(bool isBW)
{
	actionB_W_view->setChecked(isBW);
	SwitchColorMode();
}
// -----------------------------------------------------------------------------

/**
 * Metoa usuwajca polaczenie o podanym ID
 * @param int cID - Identyfikator polaczenia
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::deleteConnection(unsigned int cID)
{
	int cIndex = ConnectionsList->IndexOfID(cID);
				
	if(cIndex == -1)
		return;
	
	if(QMessageBox::question(NULL, "XTT Editor", "Do you really want to delete selected connection?", QMessageBox::Yes | QMessageBox::No) == QMessageBox::No)
		return;

	// Skasowanie polaczenia
	ConnectionsList->Delete(cIndex);
	
	// Jezeli wybrane bylo zaznaczone
	if(xtt_scene->SelectedConnectionID() == (int)cID)
		xtt_scene->setSelectedConnectionID(-1);
}
// -----------------------------------------------------------------------------

/**
 * Metoa usuwajca tabele o podanym ID
 * @param int tID - Identyfikator polaczenia
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::deleteTable(unsigned int tID)
{
	int tIndex = TableList->IndexOfID(tID);
				
	if(tIndex == -1)
		return;
	
	// Potwierdzenie usuniecia
	if(QMessageBox::question(NULL, "XTT Editor", "Do you really want to remove selected table?", QMessageBox::Yes | QMessageBox::No) == QMessageBox::No) 
		return;

	// Usuwanie
	TableList->Delete(tIndex);
	
	// Jezeli wybrana byla zaznaczona
	if(xtt_scene->SelectedTableID() == (int)tID)
		xtt_scene->setSelectedTableID(-1);
}
// -----------------------------------------------------------------------------

/**
 * Metoa usuwajca aktualnie zaznaczona tabele
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::deleteSelectedTable(void)
{
	deleteTable(xtt_scene->SelectedTableID());
	xtt_scene->setSelectedTableID(-1);
}
// -----------------------------------------------------------------------------

/**
 * Metoa usuwajca aktualnie zaznaczone polaczenie
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::deleteSelectedConnection(void)
{
	deleteConnection(xtt_scene->SelectedConnectionID());
	xtt_scene->setSelectedConnectionID(-1);
}
// -----------------------------------------------------------------------------

/**
 * Metoa wywolywana w momencie kiedy zostanie nacisniety jakis klawisz
 * @param QKeyEvent* event - Wskanik do obiektu przechwoujacego informacje o 
 * zdarzeniu
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::keyPressEvent(QKeyEvent *event)
{
	if(appMode == ARD_MODE)
	{
	     switch(event->key())
	     {
	          case Qt::Key_F5:
	               fCurrentARDscene->AdaptSceneSize();
	               break;

	          case Qt::Key_F9:
	               break;
	               
	          case Qt::Key_Insert:
	               break;

	          case Qt::Key_Delete:
	               break;

	          case Qt::Key_Plus:
	               fCurrentARDscene->zin();
	               break;

	          case Qt::Key_Minus:
	               fCurrentARDscene->zout();
	               break;

	          default:
	               QWidget::keyPressEvent(event);
	     }
	}

	if(appMode == XTT_MODE)
	{
	     switch(event->key())
	     {
	          case Qt::Key_F5:
	               xtt_scene->AdaptSceneSize();
	               break;

	          case Qt::Key_F9:
	               ExecuteModel();
	               break;
	               
	          case Qt::Key_Insert:
	               AddNewAttribute();
	               break;

	          case Qt::Key_Delete:
	               if((xtt_scene->SelectedTableID() > -1) && (TableList->Count() > 0))
					deleteTable(xtt_scene->SelectedTableID());
	               else if((xtt_scene->SelectedConnectionID() > -1) && (ConnectionsList->Count() > 0))
					deleteConnection(xtt_scene->SelectedConnectionID());
	               break;

	          case Qt::Key_Plus:
	               xtt_scene->zin();
	               break;

	          case Qt::Key_Minus:
	               xtt_scene->zout();
	               break;

	          default:
	               QWidget::keyPressEvent(event);
	     }
	}
}
// -----------------------------------------------------------------------------

/**
 * Metoda zalanczajaca/wylanczajaca antyaliasing na scenie
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::ChangeAntialiasingStatus(void)
{
     QPainter::RenderHints flags = 0;
     if(actionAntialiasing->isChecked())
          flags = flags | QPainter::Antialiasing;
     if(actionTextAntialiasing->isChecked())
          flags = flags | QPainter::TextAntialiasing;
     if(actionSmooth_pixmap_transform->isChecked())
          flags = flags | QPainter::SmoothPixmapTransform;

     xtt_graphicsView->setRenderHints(flags);
}
// -----------------------------------------------------------------------------

/**
 * Metoda uaktualniajaca sposob renderowania sceny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::UpdateRenderHints(void)
{
     QPainter::RenderHints flags = 0;
     if(actionAntialiasing->isChecked())
          flags = flags | QPainter::Antialiasing;
     if(actionTextAntialiasing->isChecked())
          flags = flags | QPainter::TextAntialiasing;
     if(actionSmooth_pixmap_transform->isChecked())
          flags = flags | QPainter::SmoothPixmapTransform;
		
	Settings->setAntialiasingMode(actionAntialiasing->isChecked(), currentMode());
	Settings->setTextAntialiasingMode(actionTextAntialiasing->isChecked(), currentMode());
	Settings->setSmoothPixmapTransformMode(actionSmooth_pixmap_transform->isChecked(), currentMode());

	if(appMode == ARD_MODE)
	{
		QList<QGraphicsView*> views_list = ard_modelScene->views();
		for(int i=0;i<views_list.count();i++)
			views_list.at(i)->setRenderHints(flags);
			
		views_list = ard_thpScene->views();
		for(int i=0;i<views_list.count();i++)
			views_list.at(i)->setRenderHints(flags);
	}
	
	if(appMode == XTT_MODE)
	{
		QList<QGraphicsView*> views_list = xtt_scene->views();
		for(int i=0;i<views_list.count();i++)
			views_list.at(i)->setRenderHints(flags);
	}
}
// -----------------------------------------------------------------------------

/**
 * Pokazuje okno konfiguracji programu
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::showConfigurationDialog(void)
{
	Settings->show();
}
// -----------------------------------------------------------------------------

/**
 * Pokazuje okno edycji atrybutu. Dodatkowo konfiguruje je tak aby moc dodac 
 * nowy atrybut
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::AddNewAttribute(void)
{
     delete AttributeEditor;
     AttributeEditor = new AttrEditor(true, 0, -1);
     AttributeEditor->show();
}
// -----------------------------------------------------------------------------

/**
 * Pokazuje okno edycji atrybutu. Dodatkowo konfiguruje je tak aby moc edytowac
 * atrybut
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::EditAttribute(void)
{
     if(AttributeGroups->IsEmpty())
     {
          const QString str2 = "There is no attributes defined yet.";
          QMessageBox::information(NULL, "XTT Editor", str2, QMessageBox::Ok);
          return;
     }

     delete AttributeEditor;
     AttributeEditor = new AttrEditor(false, 0, -1);
     AttributeEditor->show();
}
// -----------------------------------------------------------------------------

/**
 * Pokazuje okno usuwania atrybutu.
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::DeleteAttribute(void)
{
     if(AttributeGroups->IsEmpty())
     {
          const QString str2 = "There is no attributes defined yet.";
          QMessageBox::information(NULL, "XTT Editor", str2, QMessageBox::Ok);
          return;
     }

     delete AttributeDelete;
     AttributeDelete = new AttributeDelete_ui(0);
     AttributeDelete->show();
}
// -----------------------------------------------------------------------------

/**
 * Pokazuje okno menedzera grup
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::GroupManagerShow(void)
{
     delete GroupMan;
     GroupMan = new GroupManager_ui;
     GroupMan->show();
}
// -----------------------------------------------------------------------------

/**
 * Pokazuje okno menedzera atrybutow
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::AttributeManagerShow(void)
{
     delete AttrManager;
     AttrManager = new AttributeManager_ui;
     AttrManager->show();
}
// -----------------------------------------------------------------------------

/**
 * Metoda pokazujaca okienko edytora tabel
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::TableEditorShow(void)
{
     delete TableEdit;
     TableEdit = new TableEditor_ui(true, 0);
     TableEdit->show();
}
// -----------------------------------------------------------------------------

/**
 * Metoda pokazujaca okienko edytora tabel
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::TableEditorEdit(void)
{
     if(TableList->IsEmpty())
     {
          const QString str2 = "There is no tables defined yet.";
          QMessageBox::information(NULL, "XTT Editor", str2, QMessageBox::Ok);
          return;
     }

     // Wyszukiwanie indexu zaznaczonej tabeli
     int tindex = TableList->IndexOfID(xtt_scene->SelectedTableID());
     if(tindex == -1)
          tindex = 0;
     
     delete TableEdit;
     TableEdit = new TableEditor_ui(false, tindex);
     TableEdit->show();
}
// -----------------------------------------------------------------------------

/**
 * Metoda klasy MainWin_ui wyswietlajaca okno w ktorym mozna usuwac tabele
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::DeleteTableShow(void)
{
     if(TableList->IsEmpty())
     {
          const QString str2 = "There is no tables defined yet.";
          QMessageBox::information(NULL, "XTT Editor", str2, QMessageBox::Ok);
          return;
     }

     // Wyszukiwanie indexu zaznaczonej tabeli
     int tindex = TableList->IndexOfID(xtt_scene->SelectedTableID());
     if(tindex == -1)
          tindex = 0;

     delete DelTable;
     DelTable = new DeleteTable_ui(tindex, 0);
     DelTable->show();
}
// -----------------------------------------------------------------------------

/**
 * Metoda klasy MainWin_ui wyswietlajaca okno edytora komorek
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::ShowCellEditor(void)
{
     if(TableList->IsEmpty())
     {
          const QString str2 = "There is no tables defined yet.";
          QMessageBox::information(NULL, "XTT Editor", str2, QMessageBox::Ok);
          return;
     }

     // Wyszukiwanie indexu zaznaczonej tabeli
     int tindex = TableList->IndexOfID(xtt_scene->SelectedTableID());
     if(tindex == -1)
          tindex = 0;

     delete CellEdit;
     CellEdit = new CellEditor_ui(tindex, 0);
     CellEdit->show();
}
// -----------------------------------------------------------------------------

/**
 * Metoda pokazuja okienko edycji polaczen
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::ShowConnEditor(void)
{
     // Wyszukiwanie indexu zaznaczonej tabeli
     int tindex = TableList->IndexOfID(xtt_scene->SelectedTableID());
     if(tindex == -1)
          tindex = 0;
          
     delete ConnEdit;
     ConnEdit = new ConnectionEditor_ui(true, tindex);
     ConnEdit->show();
}
// -----------------------------------------------------------------------------

/**
 * Metoda pokazuja okienko edycji polaczen
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::ShowConnEditorInEditMode(void)
{
     if(ConnectionsList->Count() == 0)
     {
          const QString str2 = "There is no connections defined yet.";
          QMessageBox::information(NULL, "XTT Editor", str2, QMessageBox::Ok);
          return;
     }

     // Wyszukiwanie indexu zaznaczonego polaczenia
     int tindex = ConnectionsList->IndexOfID(xtt_scene->SelectedConnectionID());
     if(tindex == -1)
          tindex = 0;

     delete ConnEdit;
     ConnEdit = new ConnectionEditor_ui(false, tindex);
     ConnEdit->show();
}
// -----------------------------------------------------------------------------

/**
 * Metoda pokazujaca okienko pozwalajaca na usuwanie polaczenia
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::ShowConnectionDeleteWindow(void)
{
     if(ConnectionsList->Count() == 0)
     {
          const QString str2 = "There is no connections defined yet.";
          QMessageBox::information(NULL, "XTT Editor", str2, QMessageBox::Ok);
          return;
     }

     // Wyszukiwanie indexu zaznaczonej tabeli
     int conn_ind = ConnectionsList->IndexOfID(xtt_scene->SelectedConnectionID());
     if(conn_ind == -1)
          conn_ind = 0;
     int tid = ConnectionsList->Connection(conn_ind)->SrcTable();
     int rid = ConnectionsList->Connection(conn_ind)->SrcRow();

     int tindex = TableList->IndexOfID(tid);
     int rindex = TableList->IndexOfID(tid);
     if(tindex == -1)
     {
          QMessageBox::critical(NULL, "XTT Editor", "Table with ID = " + QString::number(tid) + " not exist.", QMessageBox::Ok);
          return;
     }
     // Wyszukiwanie wiersza o podanym ID
     for(unsigned int r=0;r<TableList->Table(tindex)->RowCount();r++)
          if((int)TableList->Table(tindex)->Row(r)->RowId() == rid)
          {
               rindex = r;
               break;
          }
     if(rindex == -1)
     {
          QMessageBox::critical(NULL, "XTT Editor", "Row with ID = " + QString::number(rid) + " not exist in table with ID = " + QString::number(tid) + ".", QMessageBox::Ok);
          return;
     }

     delete DelConn;
     DelConn = new DeleteConnection_ui(tindex, rindex, 0);
     DelConn->show();
}
// -----------------------------------------------------------------------------

/**
 * Metoda klasy, pokazujaca okienko manedera poczen
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::ShowConnectionManager(void)
{
     if(TableList->IsEmpty())
     {
          const QString str2 = "There is no tables defined yet.";
          QMessageBox::information(NULL, "XTT Editor", str2, QMessageBox::Ok);
          return;
     }
     
     // Wyszukiwanie indexu zaznaczonej tabeli
     int tindex = TableList->IndexOfID(xtt_scene->SelectedTableID());
     if(tindex == -1)
          tindex = 0;
          
     delete ConnManager;
     ConnManager = new ConnectionManager_ui(tindex, 0);
     ConnManager->show();
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany kata obrotu sceny
 * @param int _newValue - Wartosc konta docelowego
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::angleEditorChange(int _newValue)
{
	dial->setValue(_newValue);
	if(appMode == ARD_MODE)
		fCurrentARDscene->Rotate(_newValue);
	if(appMode == XTT_MODE)
		xtt_scene->Rotate(_newValue);
}
// -----------------------------------------------------------------------------

/**
 * Metoda restujaca obrot modelu
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::resetRotate(void)
{
	dial->setValue(0);
}
// -----------------------------------------------------------------------------

/**
 * Wyswietla liste nieuzywanych atrybutow
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::ShowUnusedAttributes(void)
{
     if(AttributeGroups->IsEmpty())
     {
          const QString str2 = "There is no attributes defined yet.";
          QMessageBox::information(NULL, "XTT Editor", str2, QMessageBox::Ok);
          return;
     }

     delete UnusedAttr;
     UnusedAttr = new UnusedAtrtribute_ui;
     UnusedAttr->show();
}
// -----------------------------------------------------------------------------

/**
 * Metoda wyswietlajaca okienko z ifnormacja o programie
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::ShowAboutWin(void)
{
     //delete AboutWin;
     //AboutWin = new About_ui;
     AboutWin->show();
}
// -----------------------------------------------------------------------------

/**
 * Metoda sprawdzajaca modyfikacje modelu ARD
 * @returns true jezeli model jest zmodyfikowany, inaczej false
 */
bool MainWin_ui::ARD_Changed(void)
{
	return ardAttributeList->changed() || ardPropertyList->changed() || ardDependencyList->changed();
}
// -----------------------------------------------------------------------------

/**
 * Metoda sprawdzajaca modyfikacje modelu XTT
 * @returns true jezeli model jest zmodyfikowany, inaczej false
 */
bool MainWin_ui::XTT_Changed(void)
{
	return AttributeGroups->Changed() || ConnectionsList->Changed() || TableList->Changed();
}
// -----------------------------------------------------------------------------

/**
 * Metoda ustawiajaca wartosc statusu modyfiakcji modelu ARD
 * @param bool _c - Nowa wartosc statusu
 * @returns Brak zwracanych wartoci
 */
void MainWin_ui::setARD_Changed(bool _c)
{
	ardAttributeList->setChanged(_c);
	ardPropertyList->setChanged(_c);
	ardDependencyList->setChanged(_c);
}
// -----------------------------------------------------------------------------

/**
 * Metoda ustawiajaca wartosc statusu modyfiakcji modelu XTT
 * @param bool _c - Nowa wartosc statusu
 * @returns Brak zwracanych wartoci
 */
void MainWin_ui::setXTT_Changed(bool _c)
{
	ConnectionsList->setChanged(_c);
	TableList->setChanged(_c);
	AttributeGroups->setChanged(_c);
}
// -----------------------------------------------------------------------------

/**
 * Metoda oprozniajaca bufory i towrzaca nowy projekt
 * @param bool _keepAttributes - Okresla czy zostawic liste argumentow
 * @returns 0-Cancel, 1-Yes, -1-No
*/
int MainWin_ui::CreateNewARDProject(void)
{
	QApplication::restoreOverrideCursor();
	
     int res = 1;
	// if(ARD_Changed())
	// {
		// switch(QMessageBox::question(NULL, "ARD Editor", "Current project has been changed. Do you want to save changes?", QMessageBox::Yes | QMessageBox::No | QMessageBox::Cancel))
		// {
			// case QMessageBox::Yes:
				// saveToXTTML1_0();
				// res = 1;
				// break;
			// case QMessageBox::No:
				// res = -1;
				// break;
			// case QMessageBox::Cancel:
				// return 0;
				// break;
			// default:
				// return 0;
		// }
	// }

     QApplication::setOverrideCursor(Qt::WaitCursor);
     fArdFileName = "New project";
     setWindowTitle("ARD Editor - [" + fArdFileName + "]");
	setARD_Changed(false);

     // Kasowanie list elementow
	ardLevelList->flush();
	ardPropertyList->flush();
	ardAttributeList->flush();
	ardDependencyList->flush();
     isARDFile = false;

     QApplication::restoreOverrideCursor();

     return res;
}
// -----------------------------------------------------------------------------

/**
 * Metoda oprozniajaca bufory i towrzaca nowy projekt
 * @param bool _keepAttributes - Okresla czy zostawic liste argumentow
 * @returns 0-Cancel, 1-Yes, -1-No
*/
int MainWin_ui::CreateNewXTTProject(bool _keepAttributes)
{
	QApplication::restoreOverrideCursor();
	
     int res = 1;
	if(XTT_Changed())
	{
		switch(QMessageBox::question(NULL, "XTT Editor", "Current project has been changed. Do you want to save changes?", QMessageBox::Yes | QMessageBox::No | QMessageBox::Cancel))
		{
			case QMessageBox::Yes:
				saveToXTTML1_0();
				res = 1;
				break;
			case QMessageBox::No:
				res = -1;
				break;
			case QMessageBox::Cancel:
				return 0;
				break;
			default:
				return 0;
		}
	}

     QApplication::setOverrideCursor(Qt::WaitCursor);
     fXttFileName = "New project";
     setWindowTitle("XTT Editor - [" + fXttFileName + "]");
	setXTT_Changed(false);

     // Kasowanie list elementow
     ConnectionsList->Flush();
     TableList->Flush();
     if(!_keepAttributes)
          AttributeGroups->Flush();
     isXTTFile = false;
	
	xtt_scene->setSelectedConnectionID(-1);
	xtt_scene->setSelectedTableID(-1);
	
	xtt_runModelMessagesDockWindowMessagesList->deleteAll();
	xtt_errorsList->deleteAll();

     QApplication::restoreOverrideCursor();

     return res;
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywwolywana w momencie klikniecia na przycisk nowego projektu
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::NewClick(void)
{
	if(currentMode() == ARD_MODE)
		CreateNewARDProject();
	if(currentMode() == XTT_MODE)
		CreateNewXTTProject(false);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywwolywana w momencie klikniecia na przycisk nowego projektu z tymi
 * samymi atrybutami
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::NewWhithOldAttributiesClick(void)
{
     CreateNewXTTProject(true);
}
// -----------------------------------------------------------------------------

/**
 * Wywoluje funckje zapisu z parametrem okreslajacym zapis do versji xttml 1.0
 * @returns Brak zwracanych wartoci
 */
void MainWin_ui::saveAs_xttml_1_0(void)
{	
	saveAs(1);
}
// -----------------------------------------------------------------------------

/**
 * Wywoluje funckje zapisu z parametrem okreslajacym zapis do versji xttml 1.0
 * @returns Brak zwracanych wartoci
 */
void MainWin_ui::saveAs_xttml_2_0(void)
{	
	saveAs(2);
}
// -----------------------------------------------------------------------------

/**
 * Metoda ustwaiajaca nazwe pliku
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::saveAs(int version)
{
	QStringList filters;
	filters 	<< "XTTML files ver. 1.0 (*.xttml);;All files (*.*)" 
			<< "XTTML files ver. 2.0 (*.xttml);;All files (*.*)";
	
     // Ustalanie nazwy pliku
     QString fileName = QFileDialog::getSaveFileName(this,
                                 tr("Save project as"),
                                 QDir::currentPath(),
                                 filters.at(version-1));
	
     // Gdy nie wybrano zandego pliku
     if(fileName.isEmpty())
          return;

     fXttFileName = fileName;
     setWindowTitle("XTT Editor - [" + fXttFileName + "]");
     isXTTFile = true;
         
	if(version == 1)
		saveToXTTML1_0();
	if(version == 2)
		saveToXTTML2_0();
}
// -----------------------------------------------------------------------------

/**
 * Metoda otwierajaca okno dialogowe otwarcia pliku XTT
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::openXTTFileDialog(void)
{
     // Ustalanie nazwy pliku
     QString fileName = QFileDialog::getOpenFileName(this,
                                 tr("Open project"),
                                 QDir::currentPath(),
                                 tr("XTTML files (*.xttml);;All files (*.*)"));
						   
	openFile(fileName);
}
// -----------------------------------------------------------------------------

/**
 * Metoda otwierajaca okno dialogowe otwarcia pliku ARD
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::openARDFileDialog(void)
{
     // Ustalanie nazwy pliku
     QString fileName = QFileDialog::getOpenFileName(this,
                                 tr("Open project"),
                                 QDir::currentPath(),
                                 tr("ARDML files (*.ardml);;All files (*.*)"));
						   
	openFile(fileName);
}
// -----------------------------------------------------------------------------

/**
 * Metoda otwierajaca plik i rozpoznawajaca jego zawartosc
 * @param QString _fileName - Nazwa pliku do otwarcia
 * @returns Brak zwracanych wartoci
 */
void MainWin_ui::openFile(QString _fileName)
{
	// Gdy nie wybrano zandego pliku
     if(_fileName.isEmpty())
          return;
		
	if(!QFile::exists(_fileName))
	{
		QMessageBox::critical(this, "XTT Editor", "File " + _fileName + " not exists.");
		return;
	}

	// Czytanie pliku
	QFile file(_fileName);
     if(!file.open(QFile::ReadOnly | QFile::Text))
     {
          QMessageBox::warning(this, tr("Application"), tr("Cannot read file %1:\n%2.").arg(_fileName).arg(file.errorString()));
          return;
     }
	
	// Parsowanie XML
	QDomDocument* domDocument = new QDomDocument;
	QString errorStr;
	int errorLine;
	int errorColumn;

	if(!domDocument->setContent(&file, true, &errorStr, &errorLine, &errorColumn)) 
	{
		QMessageBox::critical(this, tr("HQED"), tr("Parse error at line %1, column %2:\n%3").arg(errorLine).arg(errorColumn).arg(errorStr));
		return;
	}

	// Sprawdzenie czy typ pliku jest obslugiwany
	QDomElement root = domDocument->documentElement();
	if((root.tagName().toLower() != "xttml")  && (root.tagName().toLower() != "ardml") && (root.tagName().toLower() != "attml"))
	{
		QMessageBox::information(this, tr("HQED"), tr("The file is not supported by hqed."));
		return;
	}
	
	// Gdy plik typu attml
	if(root.tagName().toLower() == "attml")
	{
		// Sprawdzenie wersji formatu
		QString version = root.attribute("version", "0.0");
		
		if(version == "1.0")
			loadFileATTML1_0(root);
		else
		{
			QMessageBox::information(this, tr("HQED"), tr("Unrecognized ATTML file version."));
			return;
		}
	}
	
	// Gdy plik typu xttml
	if(root.tagName().toLower() == "xttml")
	{
		// Sprawdzenie wersji formatu
		QString version = root.attribute("version", "0.0");
		
		int result = CreateNewXTTProject(false);
		if(result == 0)
			return;
			
		setCurrentMode(XTT_MODE);
		fXttFileName = _fileName;
	     setWindowTitle("XTT Editor - [" + fXttFileName + "]");
	     isXTTFile = true;
			
		if(version == "1.0")
			loadFileXTTML1_0(root);
		if(version == "2.0")
			loadFileXTTML2_0(root);
		
		// Uaktualnienie rozmiarow sceny
		xtt_scene->AdaptSceneSize();
		
		// Usuniecie elementu ktory podaza za wskaznikiem myszki
		xtt_scene->resetNewItem();
	}
	
	// Gdy plik typu ardml
	if(root.tagName().toLower() == "ardml")
	{
		// Sprawdzenie wersji formatu
		QString version = root.attribute("version", "0.0");
		
		int result = CreateNewARDProject();
		if(result == 0)
			return;
		
		setCurrentMode(ARD_MODE);
		fArdFileName = _fileName;
	     setWindowTitle("ARD Editor - [" + fArdFileName + "]");
	     isARDFile = true;
			
		if(version == "1.0")
			loadFileARDML1_0(root);
		
		// Uaktualnienie rozmiarow sceny
		ard_thpScene->AdaptSceneSize();
		ard_thpScene->update();
	}

	delete domDocument;
	QApplication::restoreOverrideCursor();
}
// -----------------------------------------------------------------------------

/**
 * Metoda otwierajaca plik formatu ATTML
 * @returns Brak zwracanych wartoci
 */
void MainWin_ui::openATTMLFile(void)
{
     // Ustalanie nazwy pliku
     QString fileName = QFileDialog::getOpenFileName(this,
                                 tr("Open"),
                                 QDir::currentPath(),
                                 tr("ATTML files (*.attml);;All files (*.*)"));

     // Gdy nie wybrano zandego pliku
     if(fileName.isEmpty())
          return;
         
     openFile(fileName);
}
// -----------------------------------------------------------------------------

/**
 * Metoda zapisujaca do pliku w formacie XTTML 1.0
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::saveToXTTML1_0(void)
{
     if(!isXTTFile)
     {
          saveAs(1);
          return;
     }

     // Zapis danych do pliku
     QFile file(fXttFileName);
     if (!file.open(QFile::WriteOnly | QFile::Text))
     {
         QMessageBox::warning(this, tr("Application"), tr("Cannot write file %1:\n%2.").arg(fXttFileName).arg(file.errorString()));
         return;
     }

     QApplication::setOverrideCursor(Qt::WaitCursor);
	
// klasa QXmlStreamWriter zostala wprowadzona dopiero od Qt w wersji 4.3
#if QT_VERSION >= 0x040300

	QXmlStreamWriter* outxml = new QXmlStreamWriter(&file);
	outxml->setAutoFormatting(Settings->xmlAutoformating());
	outxml->writeStartDocument();
	outxml->writeStartElement("xttml");
     outxml->writeAttribute("version", "1.0");
		AttributeGroups->XTTML_1_0(outxml);
		TableList->XTTML_1_0(outxml);
		ConnectionsList->XTTML_1_0(outxml);
	outxml->writeEndElement();
	outxml->writeEndDocument();
	delete outxml;
	
#endif

#if QT_VERSION < 0x040300

	QTextStream out(&file);
	
	// Wczytywanie danych
     QStringList forFile, *ag, *tl, *cl;
     forFile.clear();
     ag = AttributeGroups->XTTML_1_0();
     tl = TableList->XTTML_1_0();
     cl = ConnectionsList->XTTML_1_0();
     
     forFile << "<XTTML version=\"1.0\">";
     for(int i=0;i<ag->size();i++)
          forFile.append("\t" + ag->at(i));
     for(int i=0;i<tl->size();i++)
          forFile.append("\t" + tl->at(i));
     for(int i=0;i<cl->size();i++)
          forFile.append("\t" + cl->at(i));
     forFile << "</XTTML>";

     for(int i=0;i<forFile.size();i++)
          out << forFile.at(i) + "\n";
		
	// Kasowanie wskaznikow do danych
	delete ag;
	delete tl;
	delete cl;
	
#endif
		
	// Zapisanie stanu statusu modyfikacji modelu XTT
	setXTT_Changed(false);

     // Przywrocenie kursora
     QApplication::restoreOverrideCursor();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zapisujaca do pliku w formacie XTTML 2.0
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::saveToXTTML2_0(void)
{
     if(!isXTTFile)
     {
          saveAs(2);
          return;
     }

     // Zapis danych do pliku
     QFile file(fXttFileName);
     if (!file.open(QFile::WriteOnly | QFile::Text))
     {
         QMessageBox::warning(this, tr("Application"), tr("Cannot write file %1:\n%2.").arg(fXttFileName).arg(file.errorString()));
         return;
     }

     QApplication::setOverrideCursor(Qt::WaitCursor);
	
// klasa QXmlStreamWriter zostala wprowadzona dopiero od Qt w wersji 4.3
#if QT_VERSION >= 0x040300

	QXmlStreamWriter* outxml = new QXmlStreamWriter(&file);
	outxml->setAutoFormatting(Settings->xmlAutoformating());
	outxml->writeStartDocument();
	outxml->writeStartElement("xttml");
     outxml->writeAttribute("version", "2.0");
		AttributeGroups->ATTML_1_0(outxml);
		TableList->XTTML_2_0(outxml);
		ConnectionsList->XTTML_2_0(outxml);
	outxml->writeEndElement();
	outxml->writeEndDocument();
	delete outxml;
	
#endif

#if QT_VERSION < 0x040300

	QTextStream out(&file);
	
	// Wczytywanie danych
     QStringList forFile, *ag, *tl, *cl;
     forFile.clear();
     ag = AttributeGroups->ATTML_1_0();
     tl = TableList->XTTML_2_0();
     cl = ConnectionsList->XTTML_2_0();
     
     forFile << "<XTTML version=\"2.0\">";
     for(int i=0;i<ag->size();i++)
          forFile.append("\t" + ag->at(i));
     for(int i=0;i<tl->size();i++)
          forFile.append("\t" + tl->at(i));
     for(int i=0;i<cl->size();i++)
          forFile.append("\t" + cl->at(i));
     forFile << "</XTTML>";

     for(int i=0;i<forFile.size();i++)
          out << forFile.at(i) + "\n";
		
	// Kasowanie wskaznikow do danych
	delete ag;
	delete tl;
	delete cl;

#endif
		
	// Zapisanie stanu statusu modyfikacji modelu XTT
	setXTT_Changed(false);

     QApplication::restoreOverrideCursor();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zapisujaca grupy i atrybuty do pliku w formacie ATTML 1.0
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::saveToATTML1_0(void)
{
	QStringList filters;
	filters 	<< "ATTML files ver. 1.0 (*.attml)";
	
     // Ustalanie nazwy pliku
     QString fileName = QFileDialog::getSaveFileName(this,
                                 tr("Export atributes"),
                                 QDir::currentPath(),
                                 filters.at(0));
	
     // Gdy nie wybrano zandego pliku
     if(fileName.isEmpty())
          return;
		
     // Zapis danych do pliku
     QFile file(fileName);
     if (!file.open(QFile::WriteOnly | QFile::Text))
     {
         QMessageBox::warning(this, tr("Application"), tr("Cannot write file %1:\n%2.").arg(fileName).arg(file.errorString()));
         return;
     }
	
	QApplication::setOverrideCursor(Qt::WaitCursor);
	 
// klasa QXmlStreamWriter zostala wprowadzona dopiero od Qt w wersji 4.3
#if QT_VERSION >= 0x040300

	QXmlStreamWriter* outxml = new QXmlStreamWriter(&file);
	outxml->setAutoFormatting(Settings->xmlAutoformating());
	outxml->writeStartDocument();
	outxml->writeStartElement("attml");
     outxml->writeAttribute("version", "1.0");
		AttributeGroups->ATTML_1_0(outxml);
	outxml->writeEndElement();
	outxml->writeEndDocument();
	delete outxml;
	
#endif

#if QT_VERSION < 0x040300

	QTextStream out(&file);

     // Wczytywanie danych
     QStringList forFile, *ag;
     forFile.clear();
     ag = AttributeGroups->ATTML_1_0();
     
     forFile << "<ATTML version=\"1.0\">";
     for(int i=0;i<ag->size();i++)
          forFile.append("\t" + ag->at(i));
     forFile << "</ATTML>";

     for(int i=0;i<forFile.size();i++)
          out << forFile.at(i) + "\n";
		
	// Kasowanie wskaznikow do danych
	delete ag;

#endif

     // Przywrocenie kursora
     QApplication::restoreOverrideCursor();
}
// -----------------------------------------------------------------------------

/**
 * Wczytuje dane z pliku
 * @param QDomElement& root - Referencja do sekcji z zawartoscia pliku
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::loadFileXTTML1_0(QDomElement& root)
 {
     // Sprawdzenie naglowka i wersji formatu XTTML
	if(root.tagName().toLower() != "xttml")
		return;
	if(root.attribute("version", "0.0") != "1.0")
	{
		QMessageBox::critical(this, "XTT Editor", "Incorect XTTML version. Requested version is 1.0");
		return;
	}
 
     // -------------------------- Wczytywanie modelu -------------------------
     bool res = true;
	
	// Reszta zakladamy ze jest ok
	QDomElement DOMag = root.firstChildElement("attr_group");
	QDomElement DOMlt = root.firstChildElement("xtt_list_table");
	QDomElement DOMlc = root.firstChildElement("xtt_list_connections");
	
	if(!DOMag.isNull())
		res = res && AttributeGroups->FromXTTML_1_0(DOMag);
	else
		QMessageBox::information(this, "XTT Editor", "Missing section \"attr_group\" in file.");
		
	if(!DOMlt.isNull())
		res = res && TableList->FromXTTML_1_0(DOMlt);
	else
		QMessageBox::information(this, "XTT Editor", "Missing section \"xtt_list_table\" in file.");
		
	if(!DOMlc.isNull())
		res = res && ConnectionsList->FromXTTML_1_0(DOMlc);
	else
		QMessageBox::information(this, "XTT Editor", "Missing section \"xtt_list_connections\" in file.");

       
     QApplication::restoreOverrideCursor();

     // Jezeli nie udalo sie wszystkiego wczytac
     if(!res)
     {
		//ConnectionsList->Flush();
		//TableList->Flush();
          //AttributeGroups->Flush();
          QMessageBox::information(this, "XTT Editor", "Incorrect file format.");
     }
	
	// Zapisanie stanu statusu modyfikacji modelu XTT
	setXTT_Changed(false);
	
     QApplication::restoreOverrideCursor();
}
// -----------------------------------------------------------------------------

/**
 * Wczytuje dane z pliku
 * @param const QString &fileName - Referencja do nazwy pliku
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::loadFileXTTML2_0(QDomElement& root)
 {
	// Sprawdzenie naglowka i wersji formatu XTTML
	if(root.tagName().toLower() != "xttml")
		return;
	if(root.attribute("version", "0.0") != "2.0")
	{
		QMessageBox::critical(this, "XTT Editor", "Incorect XTTML version. Requested version is 2.0");
		return;
	}
 
     // -------------------------- Wczytywanie modelu -------------------------
     bool res = true;
	
     // Reszta zakladamy ze jest ok
	QDomElement DOMgl = root.firstChildElement("group_list");
	QDomElement DOMal = root.firstChildElement("attribute_list");
	QDomElement DOMtl = root.firstChildElement("xtt_list_table");
	QDomElement DOMcl = root.firstChildElement("xtt_list_connections");
	
	if(!DOMgl.isNull())
		res = res && AttributeGroups->FromATTML_1_0(DOMgl);
	else
		QMessageBox::information(this, "XTT Editor", "Missing section \"group_list\" in file.");
		
	if(!DOMal.isNull())
		res = res && AttributeGroups->FromATTML_1_0(DOMal);
	else
		QMessageBox::information(this, "XTT Editor", "Missing section \"attribute_list\" in file.");
		
	if(!DOMtl.isNull())
		res = res && TableList->FromXTTML_2_0(DOMtl);
	else
		QMessageBox::information(this, "XTT Editor", "Missing section \"xtt_list_table\" in file.");
		
	if(!DOMcl.isNull())
		res = res && ConnectionsList->FromXTTML_2_0(DOMcl);
	else
		QMessageBox::information(this, "XTT Editor", "Missing section \"xtt_list_connections\" in file.");
       
     QApplication::restoreOverrideCursor();

     // Jezeli nie udalo sie wszystkiego wczytac
     if(!res)
     {
		ConnectionsList->Flush();
		TableList->Flush();
          AttributeGroups->Flush();
          QMessageBox::information(this, "XTT Editor", "Incorrect file format.");
     }
	
	// Zapisanie stanu statusu modyfikacji modelu XTT
	setXTT_Changed(false);
}
// -----------------------------------------------------------------------------

/**
 * Wczytuje dane o grupach i atrybutach z pliku
 * @param QDomElement& root - referencja do obiektu przechwoujacego 
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::loadFileATTML1_0(QDomElement& root)
{
	QDomElement child = root.firstChildElement("group_list");
	while(!child.isNull())
	{
		AttributeGroups->FromATTML_1_0(child);
		child = child.nextSiblingElement("attribute_list");
	}
}
// -----------------------------------------------------------------------------

/**
 * Wczytuje dane o grupach i atrybutach z pliku
 * @param const QDomElement& root - Referencja do zawartosci dokumentu
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::loadFileARDML1_0(QDomElement& root)
 {
	// Sprawdzenie naglowka i wersji formatu XTTML
	if(root.tagName().toLower() != "ardml")
		return;
	if(root.attribute("version", "0.0") != "1.0")
	{
		QMessageBox::critical(this, "ARD Editor", "Incorect ARDML version. Requested version is 1.0");
		return;
	}
 
     // -------------------------- Wczytywanie modelu --------------------------

     bool res = true;
	
	// Reszta zakladamy ze jest ok
	QDomElement DOMprp = root.firstChildElement("properties");
	QDomElement DOMtph = root.firstChildElement("tph");
	QDomElement DOMard = root.firstChildElement("ard");
	
	if(!DOMprp.isNull())
		res = res && ardPropertyList->fromARDML_wv(DOMprp);
	else
		QMessageBox::information(this, "ARD Editor", "Missing section \"properties\" in file.");
		
	if(!DOMtph.isNull())
		res = res && ardPropertyList->fromARDML_wv(DOMtph);
	else
		QMessageBox::information(this, "ARD Editor", "Missing section \"tph\" in file.");
		
	if(!DOMard.isNull())
		res = res && ardDependencyList->fromARDML_wv(DOMard);
	else
		QMessageBox::information(this, "ARD Editor", "Missing section \"ard\" in file.");
	
	// Tworzenie pierwszego levela
	if(res)
	{
		ardLevelList->flush();
		ARD_Level* firstLevel = ardLevelList->add();
		QList<ARD_Dependency*>* leafsDeps = ardDependencyList->leafsDependencies();
		QList<ARD_Property*>* leafs = ardPropertyList->listOfLeafs();
		
		for(int i=0;i<leafs->size();++i)
			firstLevel->addProperty(leafs->at(i));
		for(int i=0;i<leafsDeps->size();++i)
			firstLevel->addDependency(leafsDeps->at(i));
			
		firstLevel->gLevel()->placeObjects();
		ardLevelList->buildLevels(0);
		ardLevelList->gLevelList()->alignLevels(0, true);
		
		delete leafs;
		delete leafsDeps;
		
		/* // Pokazanie rezultatu wlasnosci
		QString res = "Utworzono " + QString::number(ardLevelList->size()) + " poziomow:";
		for(int l=0;l<ardLevelList->size();++l)
		{
			res = res + "\nPoziom " + QString::number(ardLevelList->at(l)->level()) + " zawiera: ";
			for(int p=0;p<ardLevelList->at(l)->properties()->size();++p)
				res = res + ardLevelList->at(l)->properties()->at(p)->id() + ", ";
		}
		
		
		// Pokazanie rezultatu zaleznosci
		res += "\n\nZaleznosci";
		for(int l=0;l<ardLevelList->size();++l)
		{
			res = res + "\nPoziom " + QString::number(ardLevelList->at(l)->level()) + " zawiera: ";
			for(int d=0;d<ardLevelList->at(l)->dependencies()->size();++d)
				res = res + "(" + ardLevelList->at(l)->dependencies()->at(d)->independent()->id() + "," + ardLevelList->at(l)->dependencies()->at(d)->dependent()->id() + "), ";
		}
		
		QMessageBox::information(this, "ARD Editor", res);  */
	}
	
	// Zapisanie stanu statusu modyfikacji modelu ARD
	
     QApplication::restoreOverrideCursor();

     // Jezeli nie udalo sie wszystkiego wczytac
     if(!res)
     {
		ardAttributeList->flush();
		ardPropertyList->flush();
		ardDependencyList->flush();
          QMessageBox::information(this, "ARD Editor", "Incorrect file format.");
     }
	setARD_Changed(true);
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik svg
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportSceneToSVGfile(void)
{
#if QT_VERSION >= 0x040300

	QStringList filters;
	filters 	<< "SVG files (*.svg)";
	
     // Ustalanie nazwy pliku
     QString fileName = QFileDialog::getSaveFileName(this,
                                 tr("Export scene picture"),
                                 QDir::currentPath(),
                                 filters.at(0));
	
	// Obszar sceny do zrzutu
	QRect srect;
	
	// Poprawienie rozmiaru sceny, tak aby plik svg mial odpowiedni rozmiar
	
	// Gdy tryb ARD
	if(appMode == ARD_MODE)
	{
		ard_modelScene->AdaptSceneSize();
		
		// Zapisanie wymiarow sceny
		srect.setX((int)ard_modelScene->sceneRect().x());
		srect.setY((int)ard_modelScene->sceneRect().y());
		srect.setWidth((int)ard_modelScene->sceneRect().width());
		srect.setHeight((int)ard_modelScene->sceneRect().height());
	}
	
	// Gdy tryb XTT
	if(appMode == XTT_MODE)
	{
		xtt_scene->AdaptSceneSize();
		
		// Zapisanie wymiarow sceny
		srect.setX((int)xtt_scene->sceneRect().x());
		srect.setY((int)xtt_scene->sceneRect().y());
		srect.setWidth((int)xtt_scene->sceneRect().width());
		srect.setHeight((int)xtt_scene->sceneRect().height());
	}
					
	// Tworzenie pliku svg
	QPainter painter;
	QSvgGenerator* svggen = new QSvgGenerator;
	svggen->setFileName(fileName);
	svggen->setSize(QSize(srect.width(), srect.height()));
	
	painter.begin(svggen);
	//painter.setWindow(srect);
	
	if(appMode == ARD_MODE)
		ard_modelScene->render(&painter);
	if(appMode == XTT_MODE)
		xtt_scene->render(&painter);
	
	painter.end();

#else

	if(appMode == ARD_MODE)
		QMessageBox::information(this, "ARD Editor", "No SVG supported");
	if(appMode == XTT_MODE)
		QMessageBox::information(this, "XTT Editor", "No SVG supported");

#endif
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @param QString _format - Format pliku
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportSceneAsPicture(QString _format)
{
	QStringList formats, hints, filters;
	formats << "BMP" << "JPG" << "PNG" << "PPM" << "XBM" << "XPM";
	hints << "Windows Bitmap" << "Joint Photographic Experts Group" << "Portable Network Graphics" << "Portable Pixmap" << "X11 Bitmap" << "X11 Pixmap";
	char* cFormats[] = {"BMP", "JPG", "PNG", "PPM", "XBM", "XPM"};
	int imageCompression = 100-Settings->xttImageCompression();
	if(appMode == ARD_MODE)
		imageCompression = 100-Settings->ardImageCompression();
	
	QString msgTitle = "XTT Editor";
	if(appMode == ARD_MODE)
		msgTitle = "ARD Editor";
	
	int fi = formats.indexOf(_format.toUpper());
	if(fi == -1)
	{
		QMessageBox::information(this, msgTitle, "Unknown file format " + _format + ".");
          return;
	}
	
	filters << hints.at(fi) + " files (*." + _format.toLower() + ")";
	
     // Ustalanie nazwy pliku
	QString fileName = "";
     fileName = QFileDialog::getSaveFileName(this,
				   tr("Export scene picture"),
				   QDir::currentPath(),
				   filters.at(0));
				   
	if(fileName == "")
		return;
	
	// Obszar sceny do zrzutu
	QRect srect;
	
	// Poprawienie rozmiaru sceny, tak aby plik svg mial odpowiedni rozmiar
	
	// Gdy tryb ARD
	if(appMode == ARD_MODE)
	{
		ard_modelScene->AdaptSceneSize();
		
		// Zapisanie wymiarow sceny
		srect.setX((int)ard_modelScene->sceneRect().x());
		srect.setY((int)ard_modelScene->sceneRect().y());
		srect.setWidth((int)ard_modelScene->sceneRect().width());
		srect.setHeight((int)ard_modelScene->sceneRect().height());
	}
	
	// Gdy tryb XTT
	if(appMode == XTT_MODE)
	{
		xtt_scene->AdaptSceneSize();
		
		// Zapisanie wymiarow sceny
		srect.setX((int)xtt_scene->sceneRect().x());
		srect.setY((int)xtt_scene->sceneRect().y());
		srect.setWidth((int)xtt_scene->sceneRect().width());
		srect.setHeight((int)xtt_scene->sceneRect().height());
	}
					
	// Tworzenie pliku graficznego
	QPainter painter;
	QPixmap* pixmap = new QPixmap(srect.width(), srect.height());
	
	painter.begin(pixmap);
	
	painter.setPen(QColor(Qt::black));
	painter.setBrush(QBrush(Qt::white, Qt::SolidPattern));
	painter.drawRect(pixmap->rect());
	
	if(appMode == ARD_MODE)
		ard_modelScene->render(&painter);
	if(appMode == XTT_MODE)
		xtt_scene->render(&painter);
	
	painter.end();
	
	if(!pixmap->save(fileName, cFormats[fi], imageCompression))
		QMessageBox::information(this, msgTitle, "File not saved correctly.");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportSceneToPNGfile(void)
{
	exportSceneAsPicture("PNG");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportSceneToBMPfile(void)
{
	exportSceneAsPicture("BMP");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportSceneToJPGfile(void)
{
	exportSceneAsPicture("JPG");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportSceneToPPMfile(void)
{
	exportSceneAsPicture("PPM");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportSceneToXBMfile(void)
{
	exportSceneAsPicture("XBM");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportSceneToXPMfile(void)
{
	exportSceneAsPicture("XPM");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik svg
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportTPHtoSVGfile(void)
{
#if QT_VERSION >= 0x040300

	QStringList filters;
	filters 	<< "SVG files (*.svg)";
	
     // Ustalanie nazwy pliku
     QString fileName = QFileDialog::getSaveFileName(this,
                                 tr("Export scene picture"),
                                 QDir::currentPath(),
                                 filters.at(0));
	
	// Obszar sceny do zrzutu
	QRect srect;
	
	// Poprawienie rozmiaru sceny, tak aby plik svg mial odpowiedni rozmiar
	// Gdy tryb ARD
	ard_thpScene->AdaptSceneSize();
	
	// Zapisanie wymiarow sceny
	srect.setX((int)ard_thpScene->sceneRect().x());
	srect.setY((int)ard_thpScene->sceneRect().y());
	srect.setWidth((int)ard_thpScene->sceneRect().width());
	srect.setHeight((int)ard_thpScene->sceneRect().height());
					
	// Tworzenie pliku svg
	QPainter painter;
	QSvgGenerator* svggen = new QSvgGenerator;
	svggen->setFileName(fileName);
	svggen->setSize(QSize(srect.width(), srect.height()));
	
	painter.begin(svggen);
	//painter.setWindow(srect);
	
	ard_thpScene->render(&painter);
	
	painter.end();

#else

	if(appMode == ARD_MODE)
		QMessageBox::information(this, "ARD Editor", "No SVG supported");
	if(appMode == XTT_MODE)
		QMessageBox::information(this, "XTT Editor", "No SVG supported");

#endif
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @param QString _format - Format pliku
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportTPHasPicture(QString _format)
{
	QStringList formats, hints, filters;
	formats << "BMP" << "JPG" << "PNG" << "PPM" << "XBM" << "XPM";
	hints << "Windows Bitmap" << "Joint Photographic Experts Group" << "Portable Network Graphics" << "Portable Pixmap" << "X11 Bitmap" << "X11 Pixmap";
	char* cFormats[] = {"BMP", "JPG", "PNG", "PPM", "XBM", "XPM"};
	int imageCompression = 100-Settings->ardImageCompression();
	
	int fi = formats.indexOf(_format.toUpper());
	if(fi == -1)
	{
		QMessageBox::information(this, "ARD Editor", "Unknown file format " + _format + ".");
          return;
	}
	
	filters << hints.at(fi) + " files (*." + _format.toLower() + ")";
	
     // Ustalanie nazwy pliku
	QString fileName = "";
     fileName = QFileDialog::getSaveFileName(this,
				   tr("Export scene picture"),
				   QDir::currentPath(),
				   filters.at(0));
				   
	if(fileName == "")
		return;
	
	// Obszar sceny do zrzutu
	QRect srect;
	
	// Poprawienie rozmiaru sceny, tak aby plik svg mial odpowiedni rozmiar
	
	// Gdy tryb ARD
	ard_thpScene->AdaptSceneSize();
	
	// Zapisanie wymiarow sceny
	srect.setX((int)ard_modelScene->sceneRect().x());
	srect.setY((int)ard_modelScene->sceneRect().y());
	srect.setWidth((int)ard_modelScene->sceneRect().width());
	srect.setHeight((int)ard_modelScene->sceneRect().height());
					
	// Tworzenie pliku graficznego
	QPainter painter;
	QPixmap* pixmap = new QPixmap(srect.width(), srect.height());
	
	painter.begin(pixmap);
	
	painter.setPen(QColor(Qt::black));
	painter.setBrush(QBrush(Qt::white, Qt::SolidPattern));
	painter.drawRect(pixmap->rect());
	
	ard_thpScene->render(&painter);
	
	painter.end();
	
	if(!pixmap->save(fileName, cFormats[fi], imageCompression))
		QMessageBox::information(this, "ARD Editor", "File not saved correctly.");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportTPHtoPNGfile(void)
{
	exportTPHasPicture("PNG");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportTPHtoBMPfile(void)
{
	exportTPHasPicture("BMP");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportTPHtoJPGfile(void)
{
	exportTPHasPicture("JPG");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportTPHtoPPMfile(void)
{
	exportTPHasPicture("PPM");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportTPHtoXBMfile(void)
{
	exportTPHasPicture("XBM");
}
// -----------------------------------------------------------------------------

/**
 * Metoda pozwalajaca zapisac obraz sceny jako plik graficzny
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::exportTPHtoXPMfile(void)
{
	exportTPHasPicture("XPM");
}
// -----------------------------------------------------------------------------


/**
 * Metoda znajdujaca dla kazdej tabeli liste tabel inicjalizacyjnych polaczonych z dana tabela
 * @param XTT_Table* _initalTable - aktualna tabela inicjalizacyjna
 * @param QList<int>* _tables - lista identyfikatorow tabel ktore juz maja znalezionego przynajmniej jedego rodzica
 * @param QList<QList<XTT_Tables*>>* _initsList - lista wskaznikow do list rodzicow dla tabel, index tabeli z poprzedniej zmiennej jest indexem listy rodzicow tej zmiennej
 * @param int _currentTableID - identyfikator tabeli w ktorej jestesmy aktualnie
 * @returns true jezeli wszystko ok inaczej false
*/
void MainWin_ui::findInitialTables(XTT_Table* _initalTable, QList<unsigned int>* _tables, QList<QList<XTT_Table*>*>* _initsList, unsigned int _currentTableID)
{
	// Sprawdzamy czy bierzaca tabela jest juz na liscie
	int ti = _tables->indexOf(_currentTableID);
	
	// Kiedy tabela wystepuje na liscie juz zdefiniowanych rodzicow
	if(ti > -1)
	{
		// Jezeli tabela i rodzic juz wystepuja to prawdopodobnie jest to polaczenie zapetlajace, wiec powracamy
		if(_initsList->at(ti)->indexOf(_initalTable) > -1)
			return;
		_initsList->at(ti)->append(_initalTable);
	}
	
	// Kiedy tabela nie wystepuje na liscie juz zdefiniowanych rodzicow
	if(ti == -1)
	{
		ti = _tables->size();
		_tables->append(_currentTableID);
		QList<XTT_Table*>* newList = new QList<XTT_Table*>;
		newList->append(_initalTable);
		_initsList->append(newList);
	}
	
	// Wyszukiwanie wszystkich polaczen wychodzacych z bierzacej tabeli
	QList<XTT_Connections*>* outConnList = ConnectionsList->listOfOutConnections(_currentTableID);
	
	// Dla kazdego polaczenia wyszukujemy liste tabel i przechodzimy do nich
	for(int i=0;i<outConnList->size();i++)
		findInitialTables(_initalTable, _tables, _initsList, outConnList->at(i)->DesTable());
		
	delete outConnList;
}
// -----------------------------------------------------------------------------

/**
 * Metoda uruchamiajaca model
 * @returns Brak zwracanych wartoci
*/
void MainWin_ui::ExecuteModel(void)
{
	xtt_runModelMessagesDockWindowMessagesList->deleteAll();
	
	QString error;
	QStringList tableTypes;
	tableTypes << "fact" << "middle" << "halt";

     // Sprawdzanie czy mozna cos uruchomic
     if(TableList->Count() == 0)
     {
		xtt_runModelMessagesDockWindowMessagesList->add(-1, -1, -1, "Model is not executable.", 2);
          QMessageBox::warning(this, "XTT Editor", "Model is not executable.");
          return;
     }

     // Wyszukanie wszystkich tabel ktore nie maja polaczen
	QList<XTT_Table*>* fact_tabele_list = new QList<XTT_Table*>;
	QList<XTT_Table*>* halt_tabele_list = new QList<XTT_Table*>;
	for(unsigned int i=0;i<TableList->Count();i++)
	{
		QList<XTT_Connections*>* cilist = TableList->Table(i)->inConnectionsList();
		QList<XTT_Connections*>* colist = TableList->Table(i)->outConnectionsList();
		
		// Jezeli tabela nie ma poloczen przychodzacych, to uwazamy ja za inicjalizacyjna
		if(((Settings->autoTableTypeRecognition()) && (cilist->size() == 0)) || ((!Settings->autoTableTypeRecognition()) && (TableList->Table(i)->TableType() == 0)))
		{
			fact_tabele_list->append(TableList->Table(i));
			int tt = TableList->Table(i)->TableType();
			if((tt != 0) && (Settings->messageAboutAmbiguousTableType()))
			{
				QString wrng = "Table \'" + TableList->Table(i)->Title() + "\' seems to be fact table, but it is defined as a " + tableTypes.at(tt) + " table.";
				//QMessageBox::warning(this, "XTT_Editor", wrng);
				xtt_runModelMessagesDockWindowMessagesList->add(TableList->Table(i)->TableId(), -1, -1, wrng, 1);
			}
		}
		
		// Jezeli tabela nie ma poloczen przychodzacych, to uwazamy ja za inicjalizacyjna
		if((cilist->size() > 0) && (((Settings->autoTableTypeRecognition()) && (colist->size() == 0)) || ((!Settings->autoTableTypeRecognition()) && (TableList->Table(i)->TableType() == 2))))
		{
			halt_tabele_list->append(TableList->Table(i));
			int tt = TableList->Table(i)->TableType();
			if((tt != 2) && (Settings->messageAboutAmbiguousTableType()))
			{
				QString wrng = "Table \'" + TableList->Table(i)->Title() + "\' seems to be halt table, but it is defined as a " + tableTypes.at(tt) + " table.";
				//QMessageBox::warning(this, "XTT_Editor", wrng);
				xtt_runModelMessagesDockWindowMessagesList->add(TableList->Table(i)->TableId(), -1, -1, wrng, 1);
			}
		}
		
		// Sprawdzanie niedostepnosci wierszy
		int fcri = TableList->Table(i)->firstConnectionRowIndex();
		for(int x=0;x<fcri;x++)
			xtt_runModelMessagesDockWindowMessagesList->add(TableList->Table(i)->TableId(), TableList->Table(i)->Row(x)->RowId(), -1, "inaccessible row.", 1);
		
		delete colist;
		delete cilist;
	}

	// Sprawdzenie czy sa tabele startowe
     if(fact_tabele_list->size() == 0)
     {
          error = "There is no initialize table.";
		xtt_runModelMessagesDockWindowMessagesList->add(-1, -1, -1, error, 2);
          QMessageBox::warning(this, "XTT Editor", error);
          return;
     }

	// Spawdzenie czy tabele startowe maja przynajmniej jeden wiersz
	for(int i=0;i<fact_tabele_list->size();i++)
	{
	     if(fact_tabele_list->at(i)->RowCount() == 0)
	     {
	          error = "Initial table \'" + fact_tabele_list->at(i)->Title() + "\' hasn't rows. Initial table must have at least one row.";
			xtt_runModelMessagesDockWindowMessagesList->add(fact_tabele_list->at(i)->TableId(), -1, -1, error, 0);
	          QMessageBox::warning(this, "XTT Editor", error);
	          return;
	     }
	}

	// Zmiana kursora aplikacji i dorzucenie okna dokowalnego
     QApplication::setOverrideCursor(Qt::WaitCursor);
	
	// Tworzenie list rodzicow (tabel inicjalizacyjnych)
	QList<unsigned int>* _tables = new QList<unsigned int>;				// Lista identyfikatorow tabel
	QList<QList<XTT_Table*>*>* _initsList = new QList<QList<XTT_Table*>*>;	// Lista list tabel bedacych rodzicami danej tabeli, kolejnosc list jest taka sama jak kolejnosc tabel w zmiennej _tables
	
	for(int i=0;i<fact_tabele_list->size();++i)
		findInitialTables(fact_tabele_list->at(i), _tables, _initsList, fact_tabele_list->at(i)->TableId());
		
	// Wyswietlenie mapy w okienku dokowalnym
	if(Settings->createMapMovement())
	{
		xtt_runModelMessagesDockWindowMessagesList->add(-1, -1, -1, "________________ Initialize tables list ________________", 2);
		for(int t=0;t<_tables->size();++t)
		{
			int ti = TableList->IndexOfID(_tables->at(t));
			if(ti == -1)
			{	
				error = "Creating initialize list error.";
				xtt_runModelMessagesDockWindowMessagesList->add(-1, -1, -1, error, 0);
				QMessageBox::warning(this, "XTT Editor", error);
			}
			
			if(ti > -1)
			{
				QString line = ""; //"Table " + TableList->Table(ti)->Title() + ": ";
				for(int p=0;p<_initsList->at(t)->size();++p)
					line += _initsList->at(t)->at(p)->Title() + ", ";
				xtt_runModelMessagesDockWindowMessagesList->add(_tables->at(t), -1, -1, line, 2);
			}
		}
		xtt_runModelMessagesDockWindowMessagesList->add(-1, -1, -1, "________________________________________________", 2);
	}
	
	// Parametry startowe uruchomienia
     int currR = 0;												// Wiersz startowy
	bool* initializeTableFired = new bool[fact_tabele_list->size()];		// Lista wartosci oznaczajaca czy dana tabela inicjalizacyjna byla uruchomiona
	for(int i=0;i<fact_tabele_list->size();++i)
		initializeTableFired[i] = false;

     // Uruchomienie modelu
	for(int t=0;t<fact_tabele_list->size();++t)		// Uruchamianie kolejnych tabel inicjalizacyjnych
		if(!initializeTableFired[t])				// Uruchamiana jest tylko tabela ktora jeszcze nie byla uruchamiana
			if(ExecuteRow(fact_tabele_list, fact_tabele_list->at(t), initializeTableFired, _tables, _initsList, TableList->IndexOfID(fact_tabele_list->at(t)->TableId()), currR, -1, -1) == -1)
				break;

     QApplication::restoreOverrideCursor();
		
	// Kasowanie dynamicznie zaalokowanej pamieci
	delete fact_tabele_list;
	delete halt_tabele_list;
	delete _tables;
	for(int i=0;i<_initsList->size();++i)
		delete _initsList->at(i);
	delete _initsList;
	
	if(Settings->beepOnFinish())
		QApplication::beep();
}
// -----------------------------------------------------------------------------

/**
 * Metoda uruchamiajaca wiersz
 * @param QList<XTT_Table*>* fact_tabele_list - lista tabeli inicjalizacyjnych
 * @param XTT_Table* _initalTable - bierzaca tabela inicjalizacyjna
 * @param bool* _initials_tables_status - status opisujacy czy dana tabela inicjalizacyjna byla uruchomiona
 * @param QList<unsigned int>* _tables - lista tabel w kolejnosci odpowiadajacej kolejnosci w liscie list rodzicow
 * @param QList<QList<XTT_Table*>*>* _initsList - lista list rodzicow dla tabel
 * @param int table_index - index tabeli z ktore rozpoczynamy analize
 * @param int row_index - index wiersza z ktorego rozpoczynamy analize
 * @param int final_table_index - index tabeli koncowej, -1 - jedziemy dokad sie da
 * @param int final_row_index - index wiersza koncowego, -1 - jedziemy dokad sie da
 * @returns 1 jezeli wszystko ok, 0 - jezeli blad, -1 jezeli nastapila niejednoznacznosc (jezeli polaczenia z tabeli inicjalizacyjnej ominely tabele czekajaca na synchronizacje), 2 - jezeli funckja osiagnela wiersz docelowy
*/
int MainWin_ui::ExecuteRow(QList<XTT_Table*>* fact_tabele_list, XTT_Table* _initalTable, bool* _initials_tables_status, QList<unsigned int>* _tables, QList<QList<XTT_Table*>*>* _initsList, int table_index, int row_index, int final_table_index, int final_row_index)
{
	// Zaznaczenie ze dana tabela inicjalizacyjna zostala uruchomiona
	_initials_tables_status[fact_tabele_list->indexOf(_initalTable)] = true;

	// Sprawdzanie czy wchodzimy do tabeli koncowej ponizej wiersza koncowego, jezeli tak to konczymy
	if((table_index == final_table_index) && (row_index >= final_row_index))
		return 2;
		
     // Przechowuje bledy
     QString error;
	QString strResults[3] = {"error", "false", "true"};
     XTT_Table* currT = TableList->Table(table_index);
	
	// !!!!!!!! Sprawdzamy czy tabela do ktorej wchodzimy ma wszystkich rodzicow uruchomionych !!!!!!!!
	// jezeli nie, to musimy wszystkich uruchomic
	int tio = _tables->indexOf(currT->TableId());	// Index tabeli w zmiennej _tables wyszukiwany aby wiedziec gdzie jest lista jej rodzicow
	int listSize = _initsList->at(tio)->size();		// Liczba rodzicow tabeli do ktorej wchodzimy
	for(int i=0;i<listSize;++i)					// Sprawdzamy kazdego rodzica czy byl uruchamiany
		if(!_initials_tables_status[fact_tabele_list->indexOf(_initsList->at(tio)->at(i))])
			if(ExecuteRow(fact_tabele_list, _initsList->at(tio)->at(i), _initials_tables_status, _tables, _initsList, TableList->IndexOfID(_initsList->at(tio)->at(i)->TableId()), 0, table_index, row_index) == -1)
				return -1;

     // Analiza kolejnych wierszy
     for(unsigned int current_row=row_index;current_row<TableList->Table(table_index)->RowCount();current_row++)
     {
		// Sprawdzanie czy do wiersza koncowego, jezeli tak to go nie urachamiamy tylko zwracamy prawde
		if((table_index == final_table_index) && ((int)current_row == final_row_index))
			return 2;
		
          bool continue_main_loop = false;
          XTT_Row* currR = TableList->Table(table_index)->Row(current_row);

          // Uruchomienie analizy
          for(unsigned int c=0;c<currR->Length();c++)
          {
               QString formula = currR->Cell(c)->Content();
			
			// Trzeba tutaj zmienic kursor, poniewaz w momencie proby zapisania blednego wyrazenia
			// kursor bedzie dalej zajety
			QApplication::restoreOverrideCursor();
               int res = currR->Cell(c)->Execute(currR->Cell(c)->Content());
			QApplication::setOverrideCursor(Qt::WaitCursor);
			
               currR->Cell(c)->setContent(formula);
			
			// Jezeli sporzadzamy raport w postaci logu uruchomienia
			if(Settings->showRunCellStatus())
			{	
				int msgType = res==-1?0:2;
				QString message = "executing cell(" + currT->Title() + "," + QString::number(current_row+1) + "," + QString::number(c+1) + ") - return code: " + strResults[1+res];
				if(res == -1)
					message += ": " + currR->Cell(c)->CellError(false);
				xtt_runModelMessagesDockWindowMessagesList->add(currT->TableId(), currR->RowId(), currR->Cell(c)->CellId(), message, msgType);
			}
          
               // Jezeli false w kontekscie conditional
               if((res == 0) && (currT->ColContext(c) == 1))
               {
                    c = currR->Length();
                    continue_main_loop = true;
               }
               if(res == -1)
               {
                    QApplication::restoreOverrideCursor();
                    error = "Error cell content ID=\"" + QString::number(TableList->Table(table_index)->TableId()) + "\" row_index=\"" + QString::number(current_row) + "\" col_index=\"" + QString::number(c) + "\".\nError maessage: " + currR->Cell(c)->CellError();
				
				// Kiedy trzeba pokazac informacje
				if(Settings->xttShowErrorCellMessage())
					QMessageBox::critical(this, "XTT Editor", error);
					
                    TableList->Table(table_index)->GraphicTable()->setTableSelection(true);
                    return 0;
               }
          }

          if(continue_main_loop)
               continue;

          // Wyszukanie kolejnego polaczenia
          int conn_ind = ConnectionsList->IndexOfOutConnections(currT->TableId(), currR->RowId());

          if(conn_ind > -1)
          {
               int ntid = ConnectionsList->Connection(conn_ind)->DesTable();
               int nrid = ConnectionsList->Connection(conn_ind)->DesRow();

               // Wyszukiwanie indexow nastepnego polaczenia
               int ntind = TableList->IndexOfID(ntid);
               if(ntind == -1)
               {
                    QApplication::restoreOverrideCursor();
                    error = "Error out connection in table ID=\"" + QString::number(TableList->Table(table_index)->TableId()) + "\" row_index=\"" + QString::number(current_row) + ". Destination table not exists.";
				
				// Kiedy trzeba pokazac informacje
				if(Settings->xttShowErrorCellMessage())
					QMessageBox::critical(this, "XTT Editor", error);
					
                    TableList->Table(table_index)->GraphicTable()->setTableSelection(true);
                    return 0;
               }

               // Wyszukiwanie indexu wiersza
               int nrind = -1;
               for(unsigned int i=0;i<TableList->Table(ntind)->RowCount();i++)
                    if((int)TableList->Table(ntind)->Row(i)->RowId() == nrid)
                    {
                         nrind = i;
                         break;
                    }
               if(nrind == -1)
               {
                    QApplication::restoreOverrideCursor();
                    error = "Error out connection in table ID=\"" + QString::number(TableList->Table(table_index)->TableId()) + "\" row_index=\"" + QString::number(current_row) + "\". Destination row not exists.";
				
				// Kiedy trzeba pokazac informacje
				if(Settings->xttShowErrorCellMessage())
					QMessageBox::critical(this, "XTT Editor", error);
					
                    TableList->Table(table_index)->GraphicTable()->setTableSelection(true);
                    return 0;
               }

               // Jezeli wszystko ok to uruchamiamy nastepny wiersz
			int execRes = ExecuteRow(fact_tabele_list, _initalTable, _initials_tables_status, _tables, _initsList, ntind, nrind, final_table_index, final_row_index);
               if(execRes != 1)
                    return execRes;
               if(ConnectionsList->Connection(conn_ind)->IsCut())
                    return 1;
          }
     }
	
	// Jezeli mamy aktywne ograniczenia, czyli -> (final_table_index != -1) && (final_row_index != -1)
	// to to wywolanie funckji moze sie skonczyc w tym miejscu tylko wtedy kiedy table_index
	// jest tabela poprzedajaca final_table_index. Mozemy to sprawdzic sprawdzajac listy rodzicow
	// jezeli tabele final_table_index i table_index maja chociaz jednego wspolnego rodzica
	// to nastapilo ominiecie synchronizacji. Dzieje sie tak poniewaz przy poprawnej synchronizacji
	// jezeli tabele maja wspolnego rodzica to wtedy final_table_index = table_index, a ten przypadek
	// jest dobrze rozpatrony i w kazdym wypadku konczy sie wczesniej
	if((final_table_index != -1) && (final_row_index != -1))
	{
		XTT_Table* final_table = TableList->Table(final_table_index);
		XTT_Table* current_table = TableList->Table(table_index);
		int fti = _tables->indexOf(final_table->TableId());
		int cti = _tables->indexOf(current_table->TableId());
		
		// Sprawdzanie rodzicow
		for(int i=0;i<_initsList->at(fti)->size();++i)
			if(_initsList->at(cti)->indexOf(_initsList->at(fti)->at(i)) > -1)
			{
				error = "Arrested connection - synchronization error: this row wasn't been executed.";
				xtt_runModelMessagesDockWindowMessagesList->add(final_table->TableId(), final_table->Row(final_row_index)->RowId(), -1, error, 0);
				return -1;
			}
	}

     return 1;
}
// -----------------------------------------------------------------------------

/**
 * Metoda wczytujaca z lini parametrow tagu XTTML wartosc o podnaej nazwie
 * @param QString line - Linia parametrow
 * @param QString val_name - Nazwa wartosci
 * @returns Wartosc wartosci o podanej nazwie :)
*/
QString XML_ReadValue(QString line, QString val_name)
{
     QString res = "#NAN#";
	val_name = " " + val_name;
	
     if(!line.contains(val_name, Qt::CaseInsensitive))
          return res;

     int val_index = line.indexOf(val_name, Qt::CaseInsensitive);
     int f_index = line.indexOf("\"", val_index, Qt::CaseInsensitive);
     int s_index = line.indexOf("\"", f_index+1, Qt::CaseInsensitive);

     if((f_index == -1) || (s_index == -1))
          return res;

     res = line.mid(f_index+1, s_index-f_index-1);

     return res;
}
// -----------------------------------------------------------------------------

/**
 * Funckja usuwajaca spacje na poczatku i koncu stringu
 * @param QString str - string z ktrego spacje chcemy usunac
 * @returns string bez spacji na koncach
*/
QString RemoveSpaceAtEnds(QString str)
{
     while((str.length() > 0) && (str[0] == ' '))
     {
          str = str.remove(0, 1);
     }

     while((str.length() > 0) && (str[str.length()-1] == ' '))
     {
          str = str.remove(str.length()-1, 1);
     }

     return str;
}
// -----------------------------------------------------------------------------

