 /**
 *                                                                             *
 * @file Settings_ui.cpp                                                       *
 * Project name: HeKatE hqed                                                   *
 * $Id: Settings_ui.cpp,v 1.15 2008-03-03 22:04:31 kinio Exp $                  *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 06.11.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje metod klasy obslugujacej okno           *
 * konfiguracyjne programu                                                     *
 *                                                                             *
 */

#include <QMessageBox>
#include <QtGui>
#include <QDialog>
#include <QObject>
#include <QKeyEvent>
#include <QSettings>

#include "../M/ARD/ARD_LevelList.h"
#include "../M/ARD/ARD_PropertyList.h"
#include "../V/ARD/gARDlevelList.h"
#include "../V/ARD/gTPHtree.h"

#include "../M/XTT/XTT_TableList.h"

#include "sysTrayObject.h"

#include "XTT/MyGraphicsView.h"
#include "ARD/ardGraphicsView.h"

#include "MainWin_ui.h"
#include "Settings_ui.h"
// -----------------------------------------------------------------------------

Settings_ui* Settings;
// -----------------------------------------------------------------------------

/**
 * Konstruktor kalsy
 * @param QWidget *parent - Wskanik do rodzica
 * @returns Brak zwracanych wartosci
*/
Settings_ui::Settings_ui(QWidget*)
{
    setupUi(this);
    
    setWindowFlags(Qt::MSWindowsFixedSizeDialogHint | Qt::WindowMinimizeButtonHint);
    setWindowIcon(QIcon(":/all_images/images/mainico.bmp")); 
    
    connect(listWidget, SIGNAL(currentRowChanged(int)), stackedWidget, SLOT(setCurrentIndex(int)));
    connect(stackedWidget, SIGNAL(currentChanged(int)), this, SLOT(currentTabChanged(int)));
    connect(pushButton, SIGNAL(released()), this, SLOT(applyButtonClick()));
    connect(pushButton_2, SIGNAL(released()), this, SLOT(closeButtonClick()));
    
    connect(toolButton_31, SIGNAL(clicked()), this, SLOT(onSelectColor14()));
    connect(toolButton_21, SIGNAL(clicked()), this, SLOT(onSelectColor15()));
    connect(toolButton_22, SIGNAL(clicked()), this, SLOT(onSelectColor16()));
    connect(toolButton_23, SIGNAL(clicked()), this, SLOT(onSelectColor17()));
    connect(toolButton_24, SIGNAL(clicked()), this, SLOT(onSelectColor18()));
    connect(toolButton_25, SIGNAL(clicked()), this, SLOT(onSelectColor19()));
    connect(toolButton_26, SIGNAL(clicked()), this, SLOT(onSelectColor20()));
    connect(toolButton_27, SIGNAL(clicked()), this, SLOT(onSelectColor21()));
    connect(toolButton_28, SIGNAL(clicked()), this, SLOT(onSelectColor22()));
    connect(toolButton_29, SIGNAL(clicked()), this, SLOT(onSelectColor23()));
    connect(toolButton_32, SIGNAL(clicked()), this, SLOT(onSelectColor24()));
    connect(toolButton_30, SIGNAL(clicked()), this, SLOT(onSelectColor25()));
    connect(toolButton_20, SIGNAL(clicked()), this, SLOT(onSelectColor26()));
    
    connect(toolButton, SIGNAL(clicked()), this, SLOT(onSelectColor1()));
    connect(toolButton_2, SIGNAL(clicked()), this, SLOT(onSelectColor2()));
    connect(toolButton_3, SIGNAL(clicked()), this, SLOT(onSelectColor3()));
    connect(toolButton_4, SIGNAL(clicked()), this, SLOT(onSelectColor4()));
    connect(toolButton_5, SIGNAL(clicked()), this, SLOT(onSelectColor5()));
    connect(toolButton_6, SIGNAL(clicked()), this, SLOT(onSelectColor6()));
    connect(toolButton_7, SIGNAL(clicked()), this, SLOT(onSelectColor7()));
    connect(toolButton_8, SIGNAL(clicked()), this, SLOT(onSelectColor8()));
    connect(toolButton_9, SIGNAL(clicked()), this, SLOT(onSelectColor9()));
    connect(toolButton_10, SIGNAL(clicked()), this, SLOT(onSelectColor10()));
    connect(toolButton_11, SIGNAL(clicked()), this, SLOT(onSelectColor11()));
    connect(toolButton_12, SIGNAL(clicked()), this, SLOT(onSelectColor12()));
    connect(toolButton_13, SIGNAL(clicked()), this, SLOT(onSelectColor13()));
    connect(toolButton_14, SIGNAL(clicked()), this, SLOT(changeTableFont()));
    connect(toolButton_15, SIGNAL(clicked()), this, SLOT(changeTableHeaderFont()));
    connect(toolButton_16, SIGNAL(clicked()), this, SLOT(changeTableTitleFont()));
    connect(toolButton_17, SIGNAL(clicked()), this, SLOT(changeConnectionLabelFont()));
    connect(toolButton_18, SIGNAL(clicked()), this, SLOT(changeTPHFont()));
    connect(toolButton_19, SIGNAL(clicked()), this, SLOT(changeARDdiagramFont()));
    
    connect(horizontalSlider, SIGNAL(valueChanged(int)), this, SLOT(onSlider1ChangePosition(int)));
    connect(horizontalSlider_2, SIGNAL(valueChanged(int)), this, SLOT(onSlider2ChangePosition(int)));
    connect(horizontalSlider_3, SIGNAL(valueChanged(int)), this, SLOT(onSlider3ChangePosition(int)));
    connect(horizontalSlider_4, SIGNAL(valueChanged(int)), this, SLOT(onSlider4ChangePosition(int)));
    connect(horizontalSlider_5, SIGNAL(valueChanged(int)), this, SLOT(onSlider5ChangePosition(int)));
    connect(horizontalSlider_6, SIGNAL(valueChanged(int)), this, SLOT(onSlider6ChangePosition(int)));
    connect(horizontalSlider_7, SIGNAL(valueChanged(int)), this, SLOT(onSlider7ChangePosition(int)));
    connect(horizontalSlider_8, SIGNAL(valueChanged(int)), this, SLOT(onSlider8ChangePosition(int)));
    connect(horizontalSlider_9, SIGNAL(valueChanged(int)), this, SLOT(onSlider9ChangePosition(int)));
    connect(horizontalSlider_10, SIGNAL(valueChanged(int)), this, SLOT(onSlider10ChangePosition(int)));
    connect(horizontalSlider_11, SIGNAL(valueChanged(int)), this, SLOT(onSlider11ChangePosition(int)));
    connect(horizontalSlider_12, SIGNAL(valueChanged(int)), this, SLOT(onSlider12ChangePosition(int)));
    connect(horizontalSlider_13, SIGNAL(valueChanged(int)), this, SLOT(onSlider13ChangePosition(int)));
    connect(horizontalSlider_14, SIGNAL(valueChanged(int)), this, SLOT(changeXttZoomFactorSliderBar(int)));
    connect(horizontalSlider_15, SIGNAL(valueChanged(int)), this, SLOT(onSlider15ChangePosition(int)));
    connect(horizontalSlider_16, SIGNAL(valueChanged(int)), this, SLOT(onSlider16ChangePosition(int)));
    connect(horizontalSlider_17, SIGNAL(valueChanged(int)), this, SLOT(onSlider17ChangePosition(int)));
    connect(horizontalSlider_18, SIGNAL(valueChanged(int)), this, SLOT(onSlider18ChangePosition(int)));
    connect(horizontalSlider_19, SIGNAL(valueChanged(int)), this, SLOT(onSlider19ChangePosition(int)));
    connect(horizontalSlider_20, SIGNAL(valueChanged(int)), this, SLOT(onSlider20ChangePosition(int)));
    connect(horizontalSlider_21, SIGNAL(valueChanged(int)), this, SLOT(onSlider21ChangePosition(int)));
    connect(horizontalSlider_22, SIGNAL(valueChanged(int)), this, SLOT(onSlider22ChangePosition(int)));
    connect(horizontalSlider_23, SIGNAL(valueChanged(int)), this, SLOT(onSlider23ChangePosition(int)));
    connect(horizontalSlider_24, SIGNAL(valueChanged(int)), this, SLOT(onSlider24ChangePosition(int)));
    connect(horizontalSlider_25, SIGNAL(valueChanged(int)), this, SLOT(onSlider25ChangePosition(int)));
    connect(horizontalSlider_26, SIGNAL(valueChanged(int)), this, SLOT(onSlider26ChangePosition(int)));
    connect(horizontalSlider_27, SIGNAL(valueChanged(int)), this, SLOT(onSlider27ChangePosition(int)));
    connect(horizontalSlider_28, SIGNAL(valueChanged(int)), this, SLOT(onSlider28ChangePosition(int)));
    connect(horizontalSlider_29, SIGNAL(valueChanged(int)), this, SLOT(onSlider29ChangePosition(int)));
    connect(horizontalSlider_14, SIGNAL(valueChanged(int)), this, SLOT(changeXttZoomFactorSliderBar(int)));
    connect(horizontalSlider_30, SIGNAL(valueChanged(int)), this, SLOT(changeArdZoomFactorSliderBar(int)));
    
    connect(doubleSpinBox, SIGNAL(valueChanged(double)), this, SLOT(changeXttZoomFactorSpinBox(double)));
    connect(doubleSpinBox_2, SIGNAL(valueChanged(double)), this, SLOT(changeArdZoomFactorSpinBox(double)));
    
    connect(checkBox_9, SIGNAL(toggled(bool)), this, SLOT(checkBox9changed(bool)));
    connect(checkBox_11, SIGNAL(toggled(bool)), this, SLOT(checkBox11changed(bool)));
    connect(checkBox_15, SIGNAL(toggled(bool)), this, SLOT(checkBox15changed(bool)));
    connect(checkBox_28, SIGNAL(toggled(bool)), this, SLOT(onCheckBox28checked(bool)));
    connect(checkBox_29, SIGNAL(toggled(bool)), this, SLOT(onCheckBox29checked(bool)));
    connect(lineEdit, SIGNAL(textChanged(QString)), this, SLOT(spaceCharacterChange(QString)));
    
    // Zaladowanie opcji
    conf = new QSettings(QCoreApplication::applicationDirPath() + "/hqed.ini", QSettings::IniFormat);
    
    listWidget->setCurrentRow(0);
    
    // Wczytanie opcji
    loadOptions();
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie klikniecia przycisku zamknij
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::closeButtonClick(void)
{
	loadOptions();
	applyOptions();
	close();
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie klikniecia przycisku apply
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::applyButtonClick(void)
{
	applyOptions();
	saveOptions();
}
// -----------------------------------------------------------------------------

/**
 * Metoda stosujaca opcje do aplikacji
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::applyOptions(void)
{
	bool cm = colorMode(MainWin->currentMode());
	bool am = useAntialiasing(MainWin->currentMode());
	bool atm = useTextAntialiasing(MainWin->currentMode());
	bool sptm = useSmoothPixmapTransform(MainWin->currentMode());
	MainWin->setColorMode(cm);
	MainWin->setAntialiasingStatus(am);
	MainWin->setTextAntialiasingStatus(atm);
	MainWin->setSmoothPixmapTransformStatus(sptm);

	ardPropertyList->tphTree()->refresh();
	ardLevelList->gLevelList()->alignLevels(0, true);
	MainWin->ard_modelView->setPalette(ardSceneColor());
	MainWin->ard_modelView->scene()->setBackgroundBrush(ardSceneColor());
	MainWin->ard_tphView->setPalette(ardTPHsceneColor());
	MainWin->ard_tphView->scene()->setBackgroundBrush(ardTPHsceneColor());
	
	TableList->RefreshAll();
	MainWin->xtt_graphicsView->setPalette(xttSceneBackgroundColor());
	MainWin->xtt_graphicsView->scene()->setBackgroundBrush(xttSceneBackgroundColor());
	
	// Sprawdzanie czy system operacyjny obsluguje systemTray functions
	if((showSystemTrayIcon()) && (!QSystemTrayIcon::isSystemTrayAvailable()))
	{
		QMessageBox::warning(NULL, "HQED", "This operating system does not support system tray.\n\"Show system tray icon\" option will be reset to false.", QMessageBox::Ok);
		checkBox_29->setChecked(false);
		saveOptions();
	}
	
	if((showTrayTips()) && (!QSystemTrayIcon::supportsMessages()))
	{
		QMessageBox::warning(NULL, "HQED", "This operating system does not support system tray messages.\n\"Show tips\" option will be reset to false.", QMessageBox::Ok);
		checkBox_30->setChecked(false);
		saveOptions();
	}
	
	// Pokazanie/ukrycie ikony w zasobniku systemowym
	if(QSystemTrayIcon::isSystemTrayAvailable())
		MainWin->trayIcon->setVisible(showSystemTrayIcon());
		
	// Paski przewijania
	MainWin->xtt_graphicsView->setHorizontalScrollBarPolicy(sceneScorllBarPolicy());
	MainWin->xtt_graphicsView->setVerticalScrollBarPolicy(sceneScorllBarPolicy());
	MainWin->ard_modelView->setHorizontalScrollBarPolicy(sceneScorllBarPolicy());
	MainWin->ard_modelView->setVerticalScrollBarPolicy(sceneScorllBarPolicy());
	MainWin->ard_tphView->setHorizontalScrollBarPolicy(sceneScorllBarPolicy());
	MainWin->ard_tphView->setVerticalScrollBarPolicy(sceneScorllBarPolicy());
}
// -----------------------------------------------------------------------------

/**
 * Metoda zapisujaca ustawienia aplikacji
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::saveOptions(void)
{
	// Application options
	conf->beginGroup("Application_options");
	conf->setValue("useStartScreen", checkBox_28->isChecked());
	conf->setValue("startScreenBackgroundType", comboBox->currentIndex());
	conf->setValue("startScreenAnimationType", spinBox_4->value());
	conf->setValue("showSystemTrayIcon", checkBox_29->isChecked());
	conf->setValue("showSystemTrayTips", checkBox_30->isChecked());
	conf->setValue("scrollBarsPolicy", comboBox_2->currentIndex());
	conf->setValue("xmlAutoformating", checkBox_33->isChecked());
	conf->endGroup();

	// ARD Apperance
	conf->beginGroup("Colors");
	conf->setValue("TPHnodeColor", toolButton_31->palette().color(QPalette::Button).name());
	conf->setValue("TPHselectedNodeColor", toolButton_21->palette().color(QPalette::Button).name());
	conf->setValue("TPHnotTransformatedNodeColor", toolButton_22->palette().color(QPalette::Button).name());
	conf->setValue("TPHfontColor", toolButton_23->palette().color(QPalette::Button).name());
	conf->setValue("TPHbranchColor", toolButton_24->palette().color(QPalette::Button).name());
	conf->setValue("TPHsceneColor", toolButton_25->palette().color(QPalette::Button).name());
	conf->setValue("ARDpropertyColor", toolButton_26->palette().color(QPalette::Button).name());
	conf->setValue("ARDselectedPropertyColor", toolButton_27->palette().color(QPalette::Button).name());
	conf->setValue("ARDnodeFontColor", toolButton_28->palette().color(QPalette::Button).name());
	conf->setValue("ARDlevelLabelFontColor", toolButton_29->palette().color(QPalette::Button).name());
	conf->setValue("ARDdependencyColor", toolButton_32->palette().color(QPalette::Button).name());
	conf->setValue("ARDsceneColor", toolButton_30->palette().color(QPalette::Button).name());
	conf->setValue("ARDmarginsColor", toolButton_20->palette().color(QPalette::Button).name());
	
	conf->setValue("TPHnodeAplphaChannel", horizontalSlider_22->value());
	conf->setValue("TPHselectedNodeAplphaChannel", horizontalSlider_23->value());
	conf->setValue("TPHnotTransformatedNodeAplphaChannel", horizontalSlider_24->value());
	conf->setValue("TPHfontAplphaChannel", horizontalSlider_25->value());
	conf->setValue("TPHbranchAplphaChannel", horizontalSlider_26->value());
	conf->setValue("TPHsceneAplphaChannel", horizontalSlider_27->value());
	conf->setValue("ARDpropertyAplphaChannel", horizontalSlider_28->value());
	conf->setValue("ARDselectedPropertyAplphaChannel", horizontalSlider_29->value());
	conf->setValue("ARDnodeFontAplphaChannel", horizontalSlider_21->value());
	conf->setValue("ARDlevelLabelFontAplphaChannel", horizontalSlider_20->value());
	conf->setValue("ARDdependencyAplphaChannel", horizontalSlider_19->value());
	conf->setValue("ARDsceneAplphaChannel", horizontalSlider_18->value());
	conf->setValue("ARDmarginsAplphaChannel", horizontalSlider_17->value());
	conf->setValue("ardBlackWhiteColorMode", checkBox_25->isChecked());
	
	// XTT Apperance
	conf->setValue("TableColor", toolButton->palette().color(QPalette::Button).name());
	conf->setValue("SelectedTableColor", toolButton_2->palette().color(QPalette::Button).name());
	conf->setValue("TableHeaderFontColor", toolButton_3->palette().color(QPalette::Button).name());
	conf->setValue("TableBorderColor", toolButton_4->palette().color(QPalette::Button).name());
	conf->setValue("TableFontColor", toolButton_5->palette().color(QPalette::Button).name());
	conf->setValue("TableTitleFontColor", toolButton_6->palette().color(QPalette::Button).name());
	conf->setValue("HoveredCellColor", toolButton_7->palette().color(QPalette::Button).name());
	conf->setValue("CellErrorColor", toolButton_8->palette().color(QPalette::Button).name());
	conf->setValue("ConnectionColor", toolButton_9->palette().color(QPalette::Button).name());
	conf->setValue("SelectedConnectionColor", toolButton_10->palette().color(QPalette::Button).name());
	conf->setValue("CutConnectionColor", toolButton_11->palette().color(QPalette::Button).name());
	conf->setValue("ConnectionLabelFontColor", toolButton_12->palette().color(QPalette::Button).name());
	conf->setValue("SceneBackgroundColor", toolButton_13->palette().color(QPalette::Button).name());
	
	conf->setValue("TableAplphaChannel", horizontalSlider->value());
	conf->setValue("SelectedTableAplphaChannel", horizontalSlider_2->value());
	conf->setValue("TableHeaderFontAplphaChannel", horizontalSlider_3->value());
	conf->setValue("TableBorderAplphaChannel", horizontalSlider_4->value());
	conf->setValue("TableFontAplphaChannel", horizontalSlider_5->value());
	conf->setValue("TableTitleFontAplphaChannel", horizontalSlider_6->value());
	conf->setValue("HoveredCellAplphaChannel", horizontalSlider_7->value());
	conf->setValue("CellErrorAplphaChannel", horizontalSlider_8->value());
	conf->setValue("ConnectionAplphaChannel", horizontalSlider_9->value());
	conf->setValue("SelectedConnectionAplphaChannel", horizontalSlider_10->value());
	conf->setValue("CutConnectionAplphaChannel", horizontalSlider_11->value());
	conf->setValue("ConnectionLabelFontAplphaChannel", horizontalSlider_12->value());
	conf->setValue("SceneBackgroundAplphaChannel", horizontalSlider_13->value());
	conf->setValue("xttBlackWhiteColorMode", checkBox->isChecked());
	conf->endGroup();
	
	conf->beginGroup("ARD_and_TPH_nodes");
	conf->setValue("useFramedNodes", checkBox_27->isChecked());
	conf->endGroup();
	
	
	conf->beginGroup("Zoom_options");
	conf->setValue("ardZoomFactor", doubleSpinBox_2->value());
	conf->setValue("ardUseMouseWheel", checkBox_26->isChecked());
	conf->setValue("xttZoomFactor", doubleSpinBox->value());
	conf->setValue("xttUseMouseWheel", checkBox_8->isChecked());
	conf->endGroup();
	
	conf->beginGroup("Render_hints");
	conf->setValue("ardUseAntialiasing", checkBox_24->isChecked());
	conf->setValue("ardUseTextAntialiasing", checkBox_22->isChecked());
	conf->setValue("ardUseSmoothPixmapTransform", checkBox_23->isChecked());
	conf->setValue("xttUseAntialiasing", checkBox_2->isChecked());
	conf->setValue("xttUseTextAntialiasing", checkBox_6->isChecked());
	conf->setValue("xttUseSmoothPixmapTransform", checkBox_7->isChecked());
	conf->endGroup();
	
	// ARD
	conf->beginGroup("Fonts");
	conf->setValue("ardTPHfont", toolButton_18->font().toString());
	conf->setValue("ardARDdiagramFont", toolButton_19->font().toString());
	conf->endGroup();
	
	conf->beginGroup("ARD_scene");
	conf->setValue("ardImageCompression", horizontalSlider_16->value());
	conf->endGroup();
	
	conf->beginGroup("ARD_others");
	conf->setValue("ardMoveElementsDistance", spinBox_7->value());
	conf->endGroup();
	
	// XTT
	conf->beginGroup("Fonts");
	conf->setValue("xttTableFont", toolButton_14->font().toString());
	conf->setValue("xttTableHeaderFont", toolButton_15->font().toString());
	conf->setValue("xttTableTitleFont", toolButton_16->font().toString());
	conf->setValue("xttConnectionLabelFont", toolButton_17->font().toString());
	conf->endGroup();
	
	conf->beginGroup("XTT_Table_default_dimesions");
	conf->setValue("xttColWidth", spinBox->value());
	conf->setValue("xttRowHeight", spinBox_2->value());
	conf->setValue("xttHeaderHeight", spinBox_3->value());
	conf->endGroup();
	
	conf->beginGroup("XTT_auto_completion");
	conf->setValue("xttAutoAttributeAcronym", checkBox_10->isChecked());
	conf->setValue("xttAutoTableName", checkBox_9->isChecked());
	conf->setValue("xttTableBaseName", lineEdit_2->text());
	conf->endGroup();
	
	conf->beginGroup("XTT_scene");
	conf->setValue("xttImageCompression", horizontalSlider_15->value());
	conf->endGroup();
	
	conf->beginGroup("XTT_others");
	conf->setValue("xttAttributeSpaceChar", lineEdit->text());
	conf->setValue("xttMoveElementsDistance", spinBox_5->value());
	conf->setValue("xttConnectionsDistance", spinBox_6->value());
	conf->setValue("xttEnabledAutocentering", checkBox_31->isChecked());
	conf->setValue("xttEnabledAutoSceneResize", checkBox_32->isChecked());
	conf->endGroup();
	
	// Analizing
	conf->beginGroup("XTT_errors_signalization");
	conf->setValue("xttErrorMessage", checkBox_3->isChecked());
	conf->setValue("xttErrorHighlightCell", checkBox_4->isChecked());
	conf->setValue("xttErrorCellTip", checkBox_5->isChecked());
	conf->endGroup();
	
	conf->beginGroup("XTT_cell_verification");
	conf->setValue("xttCheckAtomicValues", checkBox_12->isChecked());
	conf->endGroup();
	
	conf->beginGroup("XTT_attribute_to_attribute_comparsion");
	conf->setValue("enabled", checkBox_11->isChecked());
	conf->setValue("executeCellWhenOff", checkBox_13->isChecked());
	conf->setValue("executeCellWhenOn", checkBox_14->isChecked());
	conf->endGroup();
	
	// Executing
	conf->beginGroup("XTT_execute_preparing");
	conf->setValue("autoTableTypeRecognition", checkBox_15->isChecked());
	conf->setValue("warningMessageAboutAmbiguousTableType", checkBox_16->isChecked());
	conf->setValue("warningMessageAboutInaccesibleRow", checkBox_17->isChecked());
	conf->endGroup();
	
	conf->beginGroup("XTT_execute_running");
	conf->setValue("createMapMovement", checkBox_18->isChecked());
	conf->setValue("highlightCurrentCell", checkBox_19->isChecked());
	conf->setValue("showRunCellStatus", checkBox_21->isChecked());
	conf->setValue("finishBell", checkBox_20->isChecked());
	conf->endGroup();
}
// -----------------------------------------------------------------------------

void Settings_ui::loadOptions(void)
{
	// Application options
	checkBox_28->setChecked(conf->value("Application_options/useStartScreen", true).toBool());
	comboBox->setCurrentIndex(conf->value("Application_options/startScreenBackgroundType", 0).toInt());
	spinBox_4->setValue(conf->value("Application_options/startScreenAnimationType", 50).toInt());
	checkBox_29->setChecked(conf->value("Application_options/showSystemTrayIcon", true).toBool());
	checkBox_30->setChecked(conf->value("Application_options/showSystemTrayTips", true).toBool());
	comboBox_2->setCurrentIndex(conf->value("Application_options/scrollBarsPolicy", 0).toInt());
	checkBox_33->setChecked(conf->value("Application_options/xmlAutoformating", true).toBool());
	
	
	// Apperance ARD
	checkBox_24->setChecked(conf->value("Render_hints/ardUseAntialiasing", true).toBool());
	checkBox_22->setChecked(conf->value("Render_hints/ardUseTextAntialiasing", true).toBool());
	checkBox_23->setChecked(conf->value("Render_hints/ardUseSmoothPixmapTransform", true).toBool());
	toolButton_31->setPalette(QPalette(QColor(conf->value("Colors/TPHnodeColor", "#55aa7f").toString())));
	toolButton_21->setPalette(QPalette(QColor(conf->value("Colors/TPHselectedNodeColor", "#aaaaff").toString())));
	toolButton_22->setPalette(QPalette(QColor(conf->value("Colors/TPHnotTransformatedNodeColor", "#e0e26e").toString())));
	toolButton_23->setPalette(QPalette(QColor(conf->value("Colors/TPHfontColor", "#000000").toString())));
	toolButton_24->setPalette(QPalette(QColor(conf->value("Colors/TPHbranchColor", "#aa0000").toString())));
	toolButton_25->setPalette(QPalette(QColor(conf->value("Colors/TPHsceneColor", "#000000").toString())));
	toolButton_26->setPalette(QPalette(QColor(conf->value("Colors/ARDpropertyColor", "#55aa7f").toString())));
	toolButton_27->setPalette(QPalette(QColor(conf->value("Colors/ARDselectedPropertyColor", "#aaaaff").toString())));
	toolButton_28->setPalette(QPalette(QColor(conf->value("Colors/ARDnodeFontColor", "#000000").toString())));
	toolButton_29->setPalette(QPalette(QColor(conf->value("Colors/ARDlevelLabelFontColor", "#5500ff").toString())));
	toolButton_32->setPalette(QPalette(QColor(conf->value("Colors/ARDdependencyColor", "#ffaa00").toString())));
	toolButton_30->setPalette(QPalette(QColor(conf->value("Colors/ARDsceneColor", "#000000").toString())));
	toolButton_20->setPalette(QPalette(QColor(conf->value("Colors/ARDmarginsColor", "#0000ff").toString())));
	horizontalSlider_22->setValue(conf->value("Colors/TPHnodeAplphaChannel", 255-150).toInt());
	horizontalSlider_23->setValue(conf->value("Colors/TPHselectedNodeAplphaChannel", 255-150).toInt());
	horizontalSlider_24->setValue(conf->value("Colors/TPHnotTransformatedNodeAplphaChannel", 0).toInt());
	horizontalSlider_25->setValue(conf->value("Colors/TPHfontAplphaChannel", 0).toInt());
	horizontalSlider_26->setValue(conf->value("Colors/TPHbranchAplphaChannel", 0).toInt());
	horizontalSlider_27->setValue(conf->value("Colors/TPHsceneAplphaChannel", 0).toInt());
	horizontalSlider_28->setValue(conf->value("Colors/ARDpropertyAplphaChannel", 0).toInt());
	horizontalSlider_29->setValue(conf->value("Colors/ARDselectedPropertyAplphaChannel", 0).toInt());
	horizontalSlider_21->setValue(conf->value("Colors/ARDnodeFontAplphaChannel", 0).toInt());
	horizontalSlider_19->setValue(conf->value("Colors/ARDlevelLabelFontAplphaChannel", 255-125).toInt());
	horizontalSlider_18->setValue(conf->value("Colors/ARDdependencyAplphaChannel", 255-125).toInt());
	horizontalSlider_17->setValue(conf->value("Colors/ARDsceneAplphaChannel", 0).toInt());
	horizontalSlider_25->setValue(conf->value("Colors/ARDmarginsAplphaChannel", 0).toInt());
	checkBox_25->setChecked(conf->value("Colors/ardBlackWhiteColorMode", false).toBool());
	doubleSpinBox_2->setValue(conf->value("Zoom_options/ardZoomFactor", 5.0).toDouble());
	checkBox_26->setChecked(conf->value("Zoom_options/ardUseMouseWheel", true).toBool());
	checkBox_27->setChecked(conf->value("ARD_and_TPH_nodes/useFramedNodes", true).toBool());

	// Apperance XTT
	checkBox_2->setChecked(conf->value("Render_hints/xttUseAntialiasing", true).toBool());
	checkBox_6->setChecked(conf->value("Render_hints/xttUseTextAntialiasing", true).toBool());
	checkBox_7->setChecked(conf->value("Render_hints/xttUseSmoothPixmapTransform", true).toBool());
	toolButton->setPalette(QPalette(QColor(conf->value("Colors/TableColor", "#b4b4b4").toString())));
	toolButton_2->setPalette(QPalette(QColor(conf->value("Colors/SelectedTableColor", "#00c8ff").toString())));
	toolButton_3->setPalette(QPalette(QColor(conf->value("Colors/TableHeaderFontColor", "#000000").toString())));
	toolButton_4->setPalette(QPalette(QColor(conf->value("Colors/TableBorderColor", "#0000ff").toString())));
	toolButton_5->setPalette(QPalette(QColor(conf->value("Colors/TableFontColor", "#ff0000").toString())));
	toolButton_6->setPalette(QPalette(QColor(conf->value("Colors/TableTitleFontColor", "#000000").toString())));
	toolButton_7->setPalette(QPalette(QColor(conf->value("Colors/HoveredCellColor", "#000000").toString())));
	toolButton_8->setPalette(QPalette(QColor(conf->value("Colors/CellErrorColor", "#000000").toString())));
	toolButton_9->setPalette(QPalette(QColor(conf->value("Colors/ConnectionColor", "#ffffff").toString())));
	toolButton_10->setPalette(QPalette(QColor(conf->value("Colors/SelectedConnectionColor", "#ffff00").toString())));
	toolButton_11->setPalette(QPalette(QColor(conf->value("Colors/CutConnectionColor", "#ff0000").toString())));
	toolButton_12->setPalette(QPalette(QColor(conf->value("Colors/ConnectionLabelFontColor", "#000000").toString())));
	toolButton_13->setPalette(QPalette(QColor(conf->value("Colors/SceneBackgroundColor", "#000000").toString())));
	horizontalSlider->setValue(conf->value("Colors/TableAplphaChannel", 255-150).toInt());
	horizontalSlider_2->setValue(conf->value("Colors/SelectedTableAplphaChannel", 255-150).toInt());
	horizontalSlider_3->setValue(conf->value("Colors/TableHeaderFontAplphaChannel", 0).toInt());
	horizontalSlider_4->setValue(conf->value("Colors/TableBorderAplphaChannel", 0).toInt());
	horizontalSlider_5->setValue(conf->value("Colors/TableFontAplphaChannel", 0).toInt());
	horizontalSlider_6->setValue(conf->value("Colors/TableTitleFontAplphaChannel", 0).toInt());
	horizontalSlider_7->setValue(conf->value("Colors/HoveredCellAplphaChannel", 0).toInt());
	horizontalSlider_8->setValue(conf->value("Colors/CellErrorAplphaChannel", 0).toInt());
	horizontalSlider_9->setValue(conf->value("Colors/ConnectionAplphaChannel", 0).toInt());
	horizontalSlider_10->setValue(conf->value("Colors/SelectedConnectionAplphaChannel", 255-125).toInt());
	horizontalSlider_11->setValue(conf->value("Colors/CutConnectionAplphaChannel", 255-125).toInt());
	horizontalSlider_12->setValue(conf->value("Colors/ConnectionLabelFontAplphaChannel", 0).toInt());
	horizontalSlider_13->setValue(conf->value("Colors/SceneBackgroundAplphaChannel", 0).toInt());
	checkBox->setChecked(conf->value("Colors/xttBlackWhiteColorMode", false).toBool());
	doubleSpinBox->setValue(conf->value("Zoom_options/xttZoomFactor", 5.0).toDouble());
	checkBox_8->setChecked(conf->value("Zoom_options/xttUseMouseWheel", true).toBool());
	
	// ARD
	QFont currFont;
	currFont.fromString(conf->value("Fonts/ardTPHfont", "MS Shell Dlg 2,8.25,-1,5,50,0,0,0,0,0").toString());
	toolButton_18->setFont(currFont);
	currFont.fromString(conf->value("Fonts/ardARDdiagramFont", "MS Shell Dlg 2,8.25,-1,5,50,0,0,0,0,0").toString());
	toolButton_19->setFont(currFont);
	horizontalSlider_16->setValue(conf->value("ARD_scene/ardImageCompression", 0).toInt());
	spinBox_7->setValue(conf->value("ARD_others/ardMoveElementsDistance", 100).toInt());
	
	// XTT
	currFont.fromString(conf->value("Fonts/xttTableFont", "MS Shell Dlg 2,8.25,-1,5,50,0,0,0,0,0").toString());
	toolButton_14->setFont(currFont);
	currFont.fromString(conf->value("Fonts/xttTableHeaderFont", "MS Shell Dlg 2,8.25,-1,5,50,0,0,0,0,0").toString());
	toolButton_15->setFont(currFont);
	currFont.fromString(conf->value("Fonts/xttTableTitleFont", "MS Shell Dlg 2,8.25,-1,5,50,0,0,0,0,0").toString());
	toolButton_16->setFont(currFont);
	currFont.fromString(conf->value("Fonts/xttConnectionLabelFont", "Courier New,8,-1,5,50,0,0,0,0,0").toString());
	toolButton_17->setFont(currFont);
	spinBox->setValue(conf->value("XTT_Table_default_dimesions/xttColWidth", 120).toInt());
	spinBox_2->setValue(conf->value("XTT_Table_default_dimesions/xttRowHeight", 20).toInt());
	spinBox_3->setValue(conf->value("XTT_Table_default_dimesions/xttHeaderHeight", 20).toInt());
	checkBox_10->setChecked(conf->value("XTT_auto_completion/xttAutoAttributeAcronym", true).toBool());
	checkBox_9->setChecked(conf->value("XTT_auto_completion/xttAutoTableName", true).toBool());
	lineEdit_2->setText(conf->value("XTT_auto_completion/xttTableBaseName", "Table").toString());
	horizontalSlider_15->setValue(conf->value("XTT_scene/xttImageCompression", 0).toInt());
	lineEdit->setText(conf->value("XTT_others/xttAttributeSpaceChar", "_").toString());
	spinBox_5->setValue(conf->value("XTT_others/xttMoveElementsDistance", 100).toInt());
	spinBox_6->setValue(conf->value("XTT_others/xttConnectionsDistance", 5).toInt());
	checkBox_31->setChecked(conf->value("XTT_others/xttEnabledAutocentering", true).toBool());
	checkBox_32->setChecked(conf->value("XTT_others/xttEnabledAutoSceneResize", false).toBool());
	
	// Analizing
	checkBox_3->setChecked(conf->value("XTT_errors_signalization/xttErrorMessage", false).toBool());
	checkBox_4->setChecked(conf->value("XTT_errors_signalization/xttErrorHighlightCell", true).toBool());
	checkBox_5->setChecked(conf->value("XTT_errors_signalization/xttErrorCellTip", false).toBool());
	checkBox_11->setChecked(conf->value("XTT_attribute_to_attribute_comparsion/enabled", true).toBool());
	checkBox_13->setChecked(conf->value("XTT_attribute_to_attribute_comparsion/executeCellWhenOff", true).toBool());
	checkBox_14->setChecked(conf->value("XTT_attribute_to_attribute_comparsion/executeCellWhenOn", true).toBool());
	checkBox_12->setChecked(conf->value("XTT_cell_verification/xttCheckAtomicValues", true).toBool());
	
	// Ececuting
	checkBox_15->setChecked(conf->value("XTT_execute_preparing/autoTableTypeRecognition", true).toBool());
	checkBox_16->setChecked(conf->value("XTT_execute_preparing/warningMessageAboutAmbiguousTableType", true).toBool());
	checkBox_17->setChecked(conf->value("XTT_execute_preparing/warningMessageAboutInaccesibleRow", true).toBool());
	checkBox_18->setChecked(conf->value("XTT_execute_running/createMapMovement", true).toBool());
	checkBox_19->setChecked(conf->value("XTT_execute_running/highlightCurrentCell", false).toBool());
	checkBox_20->setChecked(conf->value("XTT_execute_running/finishBell", true).toBool());
	checkBox_21->setChecked(conf->value("XTT_execute_running/showRunCellStatus", false).toBool());
	
	// Wywolanie dodoatkowych funckji ustawiajacych okienko
	checkBox9changed(checkBox_9->isChecked());
	checkBox11changed(checkBox_11->isChecked());
	checkBox15changed(checkBox_15->isChecked());
	onCheckBox28checked(checkBox_28->isChecked());
	onCheckBox29checked(checkBox_29->isChecked());
	
	onSlider1ChangePosition(horizontalSlider->value());
	onSlider2ChangePosition(horizontalSlider_2->value());
	onSlider3ChangePosition(horizontalSlider_3->value());
	onSlider4ChangePosition(horizontalSlider_4->value());
	onSlider5ChangePosition(horizontalSlider_5->value());
	onSlider6ChangePosition(horizontalSlider_6->value());
	onSlider7ChangePosition(horizontalSlider_7->value());
	onSlider8ChangePosition(horizontalSlider_8->value());
	onSlider9ChangePosition(horizontalSlider_9->value());
	onSlider10ChangePosition(horizontalSlider_10->value());
	onSlider11ChangePosition(horizontalSlider_11->value());
	onSlider12ChangePosition(horizontalSlider_12->value());
	onSlider13ChangePosition(horizontalSlider_13->value());
	onSlider15ChangePosition(horizontalSlider_15->value());
	onSlider16ChangePosition(horizontalSlider_16->value());
	onSlider17ChangePosition(horizontalSlider->value());
	onSlider18ChangePosition(horizontalSlider_2->value());
	onSlider19ChangePosition(horizontalSlider_3->value());
	onSlider20ChangePosition(horizontalSlider_4->value());
	onSlider21ChangePosition(horizontalSlider_5->value());
	onSlider22ChangePosition(horizontalSlider_6->value());
	onSlider23ChangePosition(horizontalSlider_7->value());
	onSlider24ChangePosition(horizontalSlider_8->value());
	onSlider25ChangePosition(horizontalSlider_9->value());
	onSlider26ChangePosition(horizontalSlider_10->value());
	onSlider27ChangePosition(horizontalSlider_11->value());
	onSlider28ChangePosition(horizontalSlider_12->value());
	onSlider29ChangePosition(horizontalSlider_13->value());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie klikniecie przycisku zmiany trybu koloru
 * @param bool _cm - Okresla czy tryb kolorowy ma byc wlaczony
 * @param int appMode - okresla dla jakiego trybu pracy aplikacji zmieniamy wartosc
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::setColorMode(bool _cm, int appMode) 
{	
	if(appMode == ARD_MODE)
		checkBox_25->setChecked(_cm);
	if(appMode == XTT_MODE)
		checkBox->setChecked(_cm);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie klikniecie przycisku zmiany trybu antyaliasingu dla obiektow
 * @param bool _nm - Okresla czy tryb antyaliasingu dla obiektow ma byc wlaczony
 * @param int appMode - okresla dla jakiego trybu pracy aplikacji zmieniamy wartosc
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::setAntialiasingMode(bool _nm, int appMode)
{
	if(appMode == ARD_MODE)
		checkBox_24->setChecked(_nm);
	if(appMode == XTT_MODE)
		checkBox_2->setChecked(_nm);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie klikniecie przycisku zmiany trybu antyaliasingu dla tekstu
 * @param bool _nm - Okresla czy tryb antyaliasingu dla tekstu ma byc wlaczony
 * @param int appMode - okresla dla jakiego trybu pracy aplikacji zmieniamy wartosc
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::setTextAntialiasingMode(bool _nm, int appMode)
{
	if(appMode == ARD_MODE)
		checkBox_22->setChecked(_nm);
	if(appMode == XTT_MODE)
		checkBox_6->setChecked(_nm);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie klikniecie przycisku zmiany trybu transformacji map bitowych
 * @param bool _nm - Okresla czy tryb gladki transformacji map bitowych ma byc wlaczony
 * @param int appMode - okresla dla jakiego trybu pracy aplikacji zmieniamy wartosc
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::setSmoothPixmapTransformMode(bool _nm, int appMode)
{
	if(appMode == ARD_MODE)
		checkBox_23->setChecked(_nm);
	if(appMode == XTT_MODE)
		checkBox_7->setChecked(_nm);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany zakldki
 * @param int currTab - Index nowej zakldaki
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::currentTabChanged(int currTab)
{
	listWidget->setCurrentRow(currTab);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie klikniecia na przycisk zmiany czcionki
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::changeTableFont(void)
{
	bool ok;
     QFont font = QFontDialog::getFont(&ok, toolButton_14->font(), this);
     if(ok) 
         toolButton_14->setFont(font);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie klikniecia na przycisk zmiany czcionki
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::changeTableHeaderFont(void)
{
	bool ok;
     QFont font = QFontDialog::getFont(&ok, toolButton_15->font(), this);
     if(ok) 
         toolButton_15->setFont(font);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie klikniecia na przycisk zmiany czcionki
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::changeTableTitleFont(void)
{
	bool ok;
     QFont font = QFontDialog::getFont(&ok, toolButton_16->font(), this);
     if(ok) 
         toolButton_16->setFont(font);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie klikniecia na przycisk zmiany czcionki
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::changeConnectionLabelFont(void)
{
	bool ok;
     QFont font = QFontDialog::getFont(&ok, toolButton_17->font(), this);
     if(ok) 
         toolButton_17->setFont(font);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie klikniecia na przycisk zmiany czcionki
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::changeTPHFont(void)
{
	bool ok;
     QFont font = QFontDialog::getFont(&ok, toolButton_18->font(), this);
     if(ok) 
         toolButton_18->setFont(font);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie klikniecia na przycisk zmiany czcionki
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::changeARDdiagramFont(void)
{
	bool ok;
     QFont font = QFontDialog::getFont(&ok, toolButton_19->font(), this);
     if(ok) 
         toolButton_19->setFont(font);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor1(void)
{
	QColor color = QColorDialog::getColor(toolButton->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton->setPalette(QPalette(color));
	toolButton->setToolTip(toolButton->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor2(void)
{
	QColor color = QColorDialog::getColor(toolButton_2->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_2->setPalette(QPalette(color));
	toolButton_2->setToolTip(toolButton_2->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor3(void)
{
	QColor color = QColorDialog::getColor(toolButton_3->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_3->setPalette(QPalette(color));
	toolButton_3->setToolTip(toolButton_3->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor4(void)
{
	QColor color = QColorDialog::getColor(toolButton_4->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_4->setPalette(QPalette(color));
	toolButton_4->setToolTip(toolButton_4->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor5(void)
{
	QColor color = QColorDialog::getColor(toolButton_5->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_5->setPalette(QPalette(color));
	toolButton_5->setToolTip(toolButton_5->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor6(void)
{
	QColor color = QColorDialog::getColor(toolButton_6->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_6->setPalette(QPalette(color));
	toolButton_6->setToolTip(toolButton_6->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor7(void)
{
	QColor color = QColorDialog::getColor(toolButton_7->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_7->setPalette(QPalette(color));
	toolButton_7->setToolTip(toolButton_7->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor8(void)
{
	QColor color = QColorDialog::getColor(toolButton_8->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_8->setPalette(QPalette(color));
	toolButton_8->setToolTip(toolButton_8->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor9(void)
{
	QColor color = QColorDialog::getColor(toolButton_9->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_9->setPalette(QPalette(color));
	toolButton_9->setToolTip(toolButton_9->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor10(void)
{
	QColor color = QColorDialog::getColor(toolButton_10->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_10->setPalette(QPalette(color));
	toolButton_10->setToolTip(toolButton_10->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor11(void)
{
	QColor color = QColorDialog::getColor(toolButton_11->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_11->setPalette(QPalette(color));
	toolButton_11->setToolTip(toolButton_11->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor12(void)
{
	QColor color = QColorDialog::getColor(toolButton_12->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_12->setPalette(QPalette(color));
	toolButton_12->setToolTip(toolButton_12->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor13(void)
{
	QColor color = QColorDialog::getColor(toolButton_13->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_13->setPalette(QPalette(color));
	toolButton_13->setToolTip(toolButton_13->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor14(void)
{
	QColor color = QColorDialog::getColor(toolButton_31->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_31->setPalette(QPalette(color));
	toolButton_31->setToolTip(toolButton_31->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor15(void)
{
	QColor color = QColorDialog::getColor(toolButton_21->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_21->setPalette(QPalette(color));
	toolButton_21->setToolTip(toolButton_21->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor16(void)
{
	QColor color = QColorDialog::getColor(toolButton_22->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_22->setPalette(QPalette(color));
	toolButton_22->setToolTip(toolButton_22->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor17(void)
{
	QColor color = QColorDialog::getColor(toolButton_23->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_23->setPalette(QPalette(color));
	toolButton_23->setToolTip(toolButton_23->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor18(void)
{
	QColor color = QColorDialog::getColor(toolButton_24->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_24->setPalette(QPalette(color));
	toolButton_24->setToolTip(toolButton_24->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor19(void)
{
	QColor color = QColorDialog::getColor(toolButton_25->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_25->setPalette(QPalette(color));
	toolButton_25->setToolTip(toolButton_25->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor20(void)
{
	QColor color = QColorDialog::getColor(toolButton_26->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_26->setPalette(QPalette(color));
	toolButton_26->setToolTip(toolButton_26->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor21(void)
{
	QColor color = QColorDialog::getColor(toolButton_27->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_27->setPalette(QPalette(color));
	toolButton_27->setToolTip(toolButton_27->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor22(void)
{
	QColor color = QColorDialog::getColor(toolButton_28->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_28->setPalette(QPalette(color));
	toolButton_28->setToolTip(toolButton_28->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor23(void)
{
	QColor color = QColorDialog::getColor(toolButton_29->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_29->setPalette(QPalette(color));
	toolButton_29->setToolTip(toolButton_29->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor24(void)
{
	QColor color = QColorDialog::getColor(toolButton_32->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_32->setPalette(QPalette(color));
	toolButton_32->setToolTip(toolButton_32->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor25(void)
{
	QColor color = QColorDialog::getColor(toolButton_30->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_30->setPalette(QPalette(color));
	toolButton_30->setToolTip(toolButton_30->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany koloru
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSelectColor26(void)
{
	QColor color = QColorDialog::getColor(toolButton_20->palette().color(QPalette::Button), this);
     if(color.isValid()) 
         toolButton_20->setPalette(QPalette(color));
	toolButton_20->setToolTip(toolButton_20->palette().color(QPalette::Button).name());
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider1ChangePosition(int _newVal)
{
	horizontalSlider->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider2ChangePosition(int _newVal)
{
	horizontalSlider_2->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider3ChangePosition(int _newVal)
{
	horizontalSlider_3->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider4ChangePosition(int _newVal)
{
	horizontalSlider_4->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider5ChangePosition(int _newVal)
{
	horizontalSlider_5->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider6ChangePosition(int _newVal)
{
	horizontalSlider_6->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider7ChangePosition(int _newVal)
{
	horizontalSlider_7->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider8ChangePosition(int _newVal)
{
	horizontalSlider_8->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider9ChangePosition(int _newVal)
{
	horizontalSlider_9->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider10ChangePosition(int _newVal)
{
	horizontalSlider_10->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider11ChangePosition(int _newVal)
{
	horizontalSlider_11->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider12ChangePosition(int _newVal)
{
	horizontalSlider_12->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider13ChangePosition(int _newVal)
{
	horizontalSlider_13->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywane w momencie przesuniecia suwaka kompresji obrazow
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider15ChangePosition(int _newVal)
{
	label_24->setText("Scene screen compresion: " + QString::number(_newVal) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywane w momencie przesuniecia suwaka kompresji obrazow
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider16ChangePosition(int _newVal)
{
	label_27->setText("Scene screen compresion: " + QString::number(_newVal) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider17ChangePosition(int _newVal)
{
	horizontalSlider_17->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider18ChangePosition(int _newVal)
{
	horizontalSlider_18->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider19ChangePosition(int _newVal)
{
	horizontalSlider_19->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider20ChangePosition(int _newVal)
{
	horizontalSlider_20->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider21ChangePosition(int _newVal)
{
	horizontalSlider_21->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider22ChangePosition(int _newVal)
{
	horizontalSlider_22->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider23ChangePosition(int _newVal)
{
	horizontalSlider_23->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider24ChangePosition(int _newVal)
{
	horizontalSlider_24->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider25ChangePosition(int _newVal)
{
	horizontalSlider_25->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider26ChangePosition(int _newVal)
{
	horizontalSlider_26->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider27ChangePosition(int _newVal)
{
	horizontalSlider_27->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider28ChangePosition(int _newVal)
{
	horizontalSlider_28->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onSlider29ChangePosition(int _newVal)
{
	horizontalSlider_29->setToolTip("Transparency = " + QString::number(((float)_newVal/255.)*100., 'f', 2) + "%");
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany statusu pokazywania ekranu startowego
 * @param bool _newState - nowa wartosc stanu kontrolki
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::onCheckBox28checked(bool _newState)
{
	label_45->setEnabled(_newState);
	label_46->setEnabled(_newState);
	comboBox->setEnabled(_newState);
	spinBox_4->setEnabled(_newState);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany statusu pokazywania ikony w zasobniku systemowym
 * @param bool _newState - nowa wartosc statusu
 * @returns brak zwracanych wartosci
*/
void Settings_ui::onCheckBox29checked(bool _newState)
{
	checkBox_30->setEnabled(_newState);
	if(!_newState)
		checkBox_30->setChecked(false);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany wartosci zoom factor SpinBox
 * @param double _nv - Nowa wartosc
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::changeArdZoomFactorSpinBox(double _nv)
{
	int sliderValue = (int)(_nv * 100.0);
	horizontalSlider_30->setValue(sliderValue);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka zoom factor
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::changeArdZoomFactorSliderBar(int _newVal)
{
	double spinBoxValue = (double)_newVal/100.0;
	doubleSpinBox_2->setValue(spinBoxValue);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany wartosci zoom factor SpinBox
 * @param double _nv - Nowa wartosc
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::changeXttZoomFactorSpinBox(double _nv)
{
	int sliderValue = (int)(_nv * 100.0);
	horizontalSlider_14->setValue(sliderValue);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany polozenia suwaka zoom factor
 * @param int _newVal - Nowa pozycja suwaka
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::changeXttZoomFactorSliderBar(int _newVal)
{
	double spinBoxValue = (double)_newVal/100.0;
	doubleSpinBox->setValue(spinBoxValue);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany stanu elementu checkBox_9
 * @param bool _nv - Nowy stan
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::checkBox9changed(bool _nv)
{
	label_23->setEnabled(_nv);
	lineEdit_2->setEnabled(_nv);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany domyslengo statusu attr2attr comp
 * @param bool _nv - Nowy stan
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::checkBox11changed(bool _nv)
{
	checkBox_13->setEnabled(!_nv);
	checkBox_14->setEnabled(_nv);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany automatycznego rozpoznawania typu tabeli
 * @param bool _nv - Nowy stan
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::checkBox15changed(bool _nv)
{
	checkBox_16->setEnabled(_nv);
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywolywana w momencie zmiany znaku zastepujacego spacje
 * @param QString _newVal - Nowa tresc pola
 * @returns Brak zwracanych wartosci
*/
void Settings_ui::spaceCharacterChange(QString _newVal)
{
	// Usuwanie wszystkich spacji
	int spaceIndex = _newVal.indexOf(" ");
	while(spaceIndex > -1)
	{
		_newVal = _newVal.remove(spaceIndex, 1);
		spaceIndex = _newVal.indexOf(" ");
	}
	int cp = lineEdit->cursorPosition();
	lineEdit->setText(_newVal);
	lineEdit->setCursorPosition(cp);
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca wartosc wspolczynnika zoom
 * @param int appMode - okresla dla jakiego trybu ma byc zwrocona wartosc
 * @returns Wartosc wspolczynnik powiekszenia/pomniejszenia
*/
double Settings_ui::zoomFactorValue(int appMode)
{	
	double res = 1.0;
	if(appMode == ARD_MODE)
		res = doubleSpinBox_2->value();
	if(appMode == XTT_MODE)
		res = doubleSpinBox->value();
	
	return res;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor tabeli
 * @param int appMode - okresla dla jakiego trybu ma byc zwrocona wartosc
 * @returns Okresla czy nalezy uzyc kolka myszki do zoomowania
*/
bool Settings_ui::useZoomMouseWhell(int appMode)
{	
	bool res = false;
	if(appMode == ARD_MODE)
		res = checkBox_26->isChecked();
	if(appMode == XTT_MODE)
		res = checkBox_8->isChecked();
	
	return res;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kiedy trzeba pokazywac paski przewijania
 * @returns kiedy trzeba pokazywac paski przewijania
*/
Qt::ScrollBarPolicy Settings_ui::sceneScorllBarPolicy(void)
{
	Qt::ScrollBarPolicy policies[3] = {Qt::ScrollBarAsNeeded, Qt::ScrollBarAlwaysOff, Qt::ScrollBarAlwaysOn};
	return policies[comboBox_2->currentIndex()];
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor zwyklego wezla TPH
 * @returns Wybrany nowy kolor zwyklego wezla TPH
*/
QColor Settings_ui::ardTPHnodeColor(void)
{
	QColor result = Qt::white;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_31->palette().color(QPalette::Button).red(), toolButton_31->palette().color(QPalette::Button).green(), toolButton_31->palette().color(QPalette::Button).blue(), 255-horizontalSlider_22->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor zaznaczonego/aktywnego wezla TPH
 * @returns Wybrany nowy kolor zaznaczonego/aktywnego wezla TPH
*/
QColor Settings_ui::ardTPHselectedNodeColor(void)
{
	QColor result = Qt::white;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_21->palette().color(QPalette::Button).red(), toolButton_21->palette().color(QPalette::Button).green(), toolButton_21->palette().color(QPalette::Button).blue(), 255-horizontalSlider_23->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor nietransformowalnego wezla TPH
 * @returns Wybrany nowy kolor nietransformowalnego wezla TPH
*/
QColor Settings_ui::ardTPHnotTransformatedNodeColor(void)
{
	QColor result = Qt::white;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_22->palette().color(QPalette::Button).red(), toolButton_22->palette().color(QPalette::Button).green(), toolButton_22->palette().color(QPalette::Button).blue(), 255-horizontalSlider_24->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor czcionki wezla TPH
 * @returns Wybrany nowy kolor czcionki wezla TPH
*/
QColor Settings_ui::ardTPHfontColor(void)
{
	QColor result = Qt::black;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_23->palette().color(QPalette::Button).red(), toolButton_23->palette().color(QPalette::Button).green(), toolButton_23->palette().color(QPalette::Button).blue(), 255-horizontalSlider_25->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor galezi (polaczenia) drzewa TPH
 * @returns Wybrany nowy kolor galezi (polaczenia) drzewa TPH
*/
QColor Settings_ui::ardTPHbranchColor(void)
{
	QColor result = Qt::black;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_24->palette().color(QPalette::Button).red(), toolButton_24->palette().color(QPalette::Button).green(), toolButton_24->palette().color(QPalette::Button).blue(), 255-horizontalSlider_26->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor sceny TPH
 * @returns Wybrany nowy kolor sceny TPH
*/
QColor Settings_ui::ardTPHsceneColor(void)
{
	QColor result = Qt::white;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_25->palette().color(QPalette::Button).red(), toolButton_25->palette().color(QPalette::Button).green(), toolButton_25->palette().color(QPalette::Button).blue(), 255-horizontalSlider_27->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor wlasnosci ARD
 * @returns Wybrany nowy kolor wlasnosci ARD
*/
QColor Settings_ui::ardPropertyColor(void)
{
	QColor result = Qt::white;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_26->palette().color(QPalette::Button).red(), toolButton_26->palette().color(QPalette::Button).green(), toolButton_26->palette().color(QPalette::Button).blue(), 255-horizontalSlider_28->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor aktywnej wlasnosci ARD
 * @returns Wybrany nowy kolor aktywnej wlasnosci ARD
*/
QColor Settings_ui::ardSelectedPropertyColor(void)
{
	QColor result = Qt::white;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_27->palette().color(QPalette::Button).red(), toolButton_27->palette().color(QPalette::Button).green(), toolButton_27->palette().color(QPalette::Button).blue(), 255-horizontalSlider_29->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor czcionki wlasnosci ARD
 * @returns Wybrany nowy kolor czcionki wlasnosci ARD
*/
QColor Settings_ui::ardPropertyFontColor(void)
{
	QColor result = Qt::black;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_28->palette().color(QPalette::Button).red(), toolButton_28->palette().color(QPalette::Button).green(), toolButton_28->palette().color(QPalette::Button).blue(), 255-horizontalSlider_21->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor czcionki etykiety poziomu
 * @returns Wybrany nowy kolor czcionki etykiety poziomu
*/
QColor Settings_ui::ardLevelLabelFontColor(void)
{
	QColor result = Qt::black;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_29->palette().color(QPalette::Button).red(), toolButton_29->palette().color(QPalette::Button).green(), toolButton_29->palette().color(QPalette::Button).blue(), 255-horizontalSlider_20->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor linii zaleznosci ARD
 * @returns Wybrany nowy kolor linii zaleznosci ARD
*/
QColor Settings_ui::ardDependencyColor(void)
{
	QColor result = Qt::black;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_32->palette().color(QPalette::Button).red(), toolButton_32->palette().color(QPalette::Button).green(), toolButton_32->palette().color(QPalette::Button).blue(), 255-horizontalSlider_19->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor sceny ARD
 * @returns Wybrany nowy kolor sceny ARD
*/
QColor Settings_ui::ardSceneColor(void)
{
	QColor result = Qt::white;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_30->palette().color(QPalette::Button).red(), toolButton_30->palette().color(QPalette::Button).green(), toolButton_30->palette().color(QPalette::Button).blue(), 255-horizontalSlider_18->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor marginesow ARD
 * @returns Wybrany nowy kolor marginesow ARD
*/
QColor Settings_ui::ardMarginsColor(void)
{
	QColor result = Qt::black;
	if(!checkBox_25->isChecked())
		result = QColor(toolButton_20->palette().color(QPalette::Button).red(), toolButton_20->palette().color(QPalette::Button).green(), toolButton_20->palette().color(QPalette::Button).blue(), 255-horizontalSlider_17->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor tabeli
 * @returns Wybrany nowy kolor tabeli
*/
QColor Settings_ui::xttTableColor(void)
{ 
	QColor result = Qt::white;
	if(!checkBox->isChecked())
		result = QColor(toolButton->palette().color(QPalette::Button).red(), toolButton->palette().color(QPalette::Button).green(), toolButton->palette().color(QPalette::Button).blue(), 255-horizontalSlider->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor zaznaczonej tabeli
 * @returns Wybrany nowy kolor aktywnej tabeli
*/
QColor Settings_ui::xttSelectedTableColor(void)
{ 
	QColor result = Qt::white;
	if(!checkBox->isChecked())
		result = QColor(toolButton_2->palette().color(QPalette::Button).red(), toolButton_2->palette().color(QPalette::Button).green(), toolButton_2->palette().color(QPalette::Button).blue(), 255-horizontalSlider_2->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor polaczenia
 * @returns Wybrany nowy kolor polaczenia
*/
QColor Settings_ui::xttConnectionColor(void)
{ 
	QColor result = Qt::black;
	if(!checkBox->isChecked())
		result = QColor(toolButton_3->palette().color(QPalette::Button).red(), toolButton_3->palette().color(QPalette::Button).green(), toolButton_3->palette().color(QPalette::Button).blue(), 255-horizontalSlider_3->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor zaznaczonego polaczenia
 * @returns Wybrany nowy kolor aktywnego polaczenia
*/
QColor Settings_ui::xttSelectedConnectionColor(void)
{ 
	QColor result = Qt::black;
	if(!checkBox->isChecked())
		result = QColor(toolButton_4->palette().color(QPalette::Button).red(), toolButton_4->palette().color(QPalette::Button).green(), toolButton_4->palette().color(QPalette::Button).blue(), 255-horizontalSlider_4->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor polaczenia odcinajacego nawroty
 * @returns Wybrany nowy kolor polaczenia odcinajacego nawroty
*/
QColor Settings_ui::xttCutConnectionColor(void)
{ 
	QColor result = Qt::black;
	if(!checkBox->isChecked())
		result = QColor(toolButton_5->palette().color(QPalette::Button).red(), toolButton_5->palette().color(QPalette::Button).green(), toolButton_5->palette().color(QPalette::Button).blue(), 255-horizontalSlider_5->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor czcionki tabeli
 * @returns Wybrany nowy kolor czcionki tabeli
*/
QColor Settings_ui::xttTableFontColor(void)
{ 
	QColor result = Qt::black;
	if(!checkBox->isChecked())
		result = QColor(toolButton_6->palette().color(QPalette::Button).red(), toolButton_6->palette().color(QPalette::Button).green(), toolButton_6->palette().color(QPalette::Button).blue(), 255-horizontalSlider_6->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor czcionki naglowka tabeli
 * @returns Wybrany nowy kolor czcionki naglowka tabeli
*/
QColor Settings_ui::xtTableTitleFontColor(void)
{ 
	QColor result = Qt::black;
	if(!checkBox->isChecked())
		result = QColor(toolButton_7->palette().color(QPalette::Button).red(), toolButton_7->palette().color(QPalette::Button).green(), toolButton_7->palette().color(QPalette::Button).blue(), 255-horizontalSlider_7->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor czcionki etykiety polaczenia
 * @returns Wybrany nowy kolor czcionki etykiety polaczenia
*/
QColor Settings_ui::xttConnectionLabelColor(void)
{ 
	QColor result = Qt::black;
	if(!checkBox->isChecked())
		result = QColor(toolButton_8->palette().color(QPalette::Button).red(), toolButton_8->palette().color(QPalette::Button).green(), toolButton_8->palette().color(QPalette::Button).blue(), 255-horizontalSlider_8->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor tla sceny
 * @returns Wybrany nowy kolor tla sceny
*/
QColor Settings_ui::xttSceneBackgroundColor(void)
{ 
	QColor result = Qt::white;
	if(!checkBox->isChecked())
		result = QColor(toolButton_9->palette().color(QPalette::Button).red(), toolButton_9->palette().color(QPalette::Button).green(), toolButton_9->palette().color(QPalette::Button).blue(), 255-horizontalSlider_9->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor tla sceny
 * @returns Wybrany nowy kolor tla sceny
*/
QColor Settings_ui::xttHoveredCellColor(void)
{ 
	QColor result = Qt::black;
	if(!checkBox->isChecked())
		result = QColor(toolButton_10->palette().color(QPalette::Button).red(), toolButton_10->palette().color(QPalette::Button).green(), toolButton_10->palette().color(QPalette::Button).blue(), 255-horizontalSlider_10->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor tla sceny
 * @returns Wybrany nowy kolor tla sceny
*/
QColor Settings_ui::xttErrorCellColor(void)
{ 
	QColor result = Qt::black;
	if(!checkBox->isChecked())
		result = QColor(toolButton_11->palette().color(QPalette::Button).red(), toolButton_11->palette().color(QPalette::Button).green(), toolButton_11->palette().color(QPalette::Button).blue(), 255-horizontalSlider_11->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor tla sceny
 * @returns Wybrany nowy kolor tla sceny
*/
QColor Settings_ui::xttTableHeaderFontColor(void)
{ 
	QColor result = Qt::black;
	if(!checkBox->isChecked())
		result = QColor(toolButton_12->palette().color(QPalette::Button).red(), toolButton_12->palette().color(QPalette::Button).green(), toolButton_12->palette().color(QPalette::Button).blue(), 255-horizontalSlider_12->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca kolor tla sceny
 * @returns Wybrany nowy kolor tla sceny
*/
QColor Settings_ui::xttTableBorderColor(void)
{ 
	QColor result = Qt::black;
	if(!checkBox->isChecked())
		result = QColor(toolButton_13->palette().color(QPalette::Button).red(), toolButton_13->palette().color(QPalette::Button).green(), toolButton_13->palette().color(QPalette::Button).blue(), 255-horizontalSlider_13->value()); 
	
	return result;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca wartosc czcionki okreslonego elementu
 * @returns Wybrany nowy kolor tla sceny
*/
QFont Settings_ui::xttTableFont(void)
{
	return toolButton_14->font();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca wartosc czcionki okreslonego elementu
 * @returns Wybrany nowy kolor tla sceny
*/
QFont Settings_ui::xttTableHeaderFont(void)
{
	return toolButton_15->font();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca wartosc czcionki okreslonego elementu
 * @returns Wybrany nowy kolor tla sceny
*/
QFont Settings_ui::xttTableTitleFont(void)
{
	return toolButton_16->font();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca wartosc czcionki okreslonego elementu
 * @returns Wybrany nowy kolor tla sceny
*/
QFont Settings_ui::xttConnectionLabelFont(void)
{
	return toolButton_17->font();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca wartosc czcionki okreslonego elementu
 * @returns Wybrany nowy kolor tla sceny
*/
QFont Settings_ui::ardTPHFont(void)
{
	return toolButton_18->font();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca wartosc czcionki okreslonego elementu
 * @returns Wybrany nowy kolor tla sceny
*/
QFont Settings_ui::ardARDdiagramFont(void)
{
	return toolButton_19->font();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca domyslna szerokosc kolumny
 * @returns Domyslna szerokosc kolumny
*/
int Settings_ui::xttDefaultColumnWidth(void)
{
	return spinBox->value();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca domyslna wysokosc wiersza
 * @returns Domyslna wysokosc wiersza
*/
int Settings_ui::xttDefaultRowHeight(void)
{
	return spinBox_2->value();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca domyslna wysokosc naglowka
 * @returns Domyslna wysokosc naglowka
*/
int Settings_ui::xttDefaultHeaderHeight(void)
{
	return spinBox_3->value();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca dystans translacji lelemntow sceny ARD w kazdym kierunku
 * @returns Dystans translacji lelemntow sceny ARD w kazdym kierunku
*/
int Settings_ui::ardMoveElementsDistance(void)
{
	return spinBox_7->value();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca dystans translacji lelemntow sceny XTT w kazdym kierunku
 * @returns Dystans translacji lelemntow sceny XTT w kazdym kierunku
*/
int Settings_ui::xttMoveElementsDistance(void)
{
	return spinBox_5->value();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca wartosc kompresji plikow graficznych bedacych screenami sceny modelu ard
 * @returns Zwraca wartosc kompresji plikow graficznych bedacych screenami sceny modelu ard
*/
int Settings_ui::ardImageCompression(void)
{
	return horizontalSlider_16->value();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca wartosc kompresji plikow graficznych bedacych screenami sceny modelu xtt
 * @returns Zwraca wartosc kompresji plikow graficznych bedacych screenami sceny modelu xtt
*/
int Settings_ui::xttImageCompression(void)
{
	return horizontalSlider_15->value();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy tworzyc automatycznie nazwe akronimu
 * @returns Zwraca czy nalezy tworzyc automatycznie nazwe akronimu
*/
bool Settings_ui::xttCreateAutoAcronym(void)
{
	return checkBox_10->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy tworzyc automatyczna nazwe tabeli
 * @returns Zwraca czy nalezy tworzyc automatyczna nazwe tabeli
*/
bool Settings_ui::xttCreateTableAutoName(void)
{
	return checkBox_9->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy pokazac widomosc o bledzie komorki
 * @returns Zwraca czy nalezy pokazac widomosc o bledzie komorki
*/
bool Settings_ui::xttShowErrorCellMessage(void)
{
	return checkBox_3->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy podswietlic komorke z bledem
 * @returns Zwraca czy nalezy podswietlic komorke z bledem
*/
bool Settings_ui::xttHighlightErrorCell(void)
{
	return checkBox_4->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy wstawic tresc bledu do hint'a komorki
 * @returns Zwraca czy nalezy wstawic tresc bledu do hint'a komorki
*/
bool Settings_ui::xttShowErrorInToolTip(void)
{
	return checkBox_5->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca domyslna wartosc wlaczonego porownywania atrubutow w komorce
 * @returns Zwraca domyslna wartosc wlaczonego porownywania atrubutow w komorce
*/
bool Settings_ui::xttAttrToAttrComp(void)
{
	return checkBox_11->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy sprawdzac proste (nie bedace wrazeniami artymetycznymi) wartosci w komorce
 * @returns Zwraca czy nalezy sprawdzac proste (nie bedace wrazeniami artymetycznymi) wartosci w komorce
*/
bool Settings_ui::xttCheckAtomicValues(void)
{
	return checkBox_12->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy uruchomic komorke podczas analizy kiedy wylaczony jest attr to attr comp
 * @returns Zwraca czy nalezy uruchomic komorke podczas analizy kiedy wylaczony jest attr to attr comp
*/
bool Settings_ui::xttExecuteCellWhenOff(void)
{
	return checkBox_13->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy uruchomic komorke podczas analizy kiedy wlaczony jest attr to attr comp
 * @returns Zwraca czy nalezy uruchomic komorke podczas analizy kiedy wlaczony jest attr to attr comp
*/
bool Settings_ui::xttExecuteCellWhenOn(void)
{
	return checkBox_14->isChecked();
}
// -----------------------------------------------------------------------------

/// Zwraca czy nalezy samodzielnie rozpoznawac typ tabeli
/**
 * Metoda zwracajaca czy nalezy po zakonczeniu analizy dac sygnal dzwiekowy
 * @returns Zwraca czy nalezy po zakonczeniu analizy dac sygnal dzwiekowy
*/
bool Settings_ui::autoTableTypeRecognition(void)
{
	return checkBox_15->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy pokazac ostrzezenie o niezgodnym typie tabeli
 * @returns Zwraca czy nalezy pokazac ostrzezenie o niezgodnym typie tabeli
*/
bool Settings_ui::messageAboutAmbiguousTableType(void)
{
	return checkBox_16->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy pokazac ostrzezenie o niedostpnych wierszach
 * @returns Zwraca czy nalezy pokazac ostrzezenie o niedostpnych wierszach
*/
bool Settings_ui::massageAboutInaccesibleRow(void)
{
	return checkBox_17->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy wyswietli mape rodzicow tabeli
 * @returns Zwraca czy nalezy wyswietli mape rodzicow tabeli
*/
bool Settings_ui::createMapMovement(void)
{
	return checkBox_18->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy podswietlac komorke ktora jest aktualnie odapalana
 * @returns Zwraca czy nalezy podswietlac komorke ktora jest aktualnie odapalana
*/
bool Settings_ui::highlightCurrentCell(void)
{
	return checkBox_19->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy po zakonczeniu analizy dac sygnal dzwiekowy
 * @returns Zwraca czy nalezy po zakonczeniu analizy dac sygnal dzwiekowy
*/
bool Settings_ui::beepOnFinish(void)
{
	return checkBox_20->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy pokazac informacje o uruchomieniu komorki
 * @returns Zwraca czy nalezy pokazac informacje o uruchomieniu komorki
*/
bool Settings_ui::showRunCellStatus(void)
{
	return checkBox_21->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy pokazac ikone w zasobniku systemowym
 * @returns Zwraca czy pokazac ikone w zasobniku systemowym
*/
bool Settings_ui::showSystemTrayIcon(void)
{
	return checkBox_29->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy pokazywac wskazowki w zasobniku systemowym
 * @returns Zwraca czy pokazywac wskazowki w zasobniku systemowym
*/
bool Settings_ui::showTrayTips(void)
{
	return checkBox_30->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy wycentrowac elementy sceny po najechaniu kursora
 * @returns Zwraca czy wycentrowac elementy sceny po najechaniu kursora
*/
bool Settings_ui::xttEnabledAutocentering(void)
{
	return checkBox_31->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy scena modelu xtt powinna byc automatycznie powiekszana
 * @returns Zwraca czy scena modelu xtt powinna byc automatycznie powiekszana
*/
bool Settings_ui::xttAutoSceneResize(void)
{
	return checkBox_32->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy pliki XML powinny byc formatowane w taki sposob aby mozna bylo zobaczyc ich hierarchie
 * @returns Zwraca czy pliki XML powinny byc formatowane w taki sposob aby mozna bylo zobaczyc ich hierarchie
*/
bool Settings_ui::xmlAutoformating(void)
{
	return checkBox_33->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca podstawe nazwy automatycznej dla tabeli
 * @returns Zwraca podstawe nazwy automatycznej dla tabeli jako string
*/
QString Settings_ui::xttTableBaseName(void)
{
	return lineEdit_2->text();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca odleglosc pomiedzy polaczeniami wychodzacymi z jednej tabeli
 * @returns Zwraca odleglosc pomiedzy polaczeniami wychodzacymi z jednej tabeli
*/
int Settings_ui::xttConnectionsDistance(void)
{
	return spinBox_6->value();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca string ktory jest wstawiany zamiast spacji w wartosichc atrybutu
 * @returns Zwraca string ktory jest wstawiany zamiast spacji w wartosichc atrybutu
*/
QString Settings_ui::spaceReplacer(void)
{
	return lineEdit->text();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca tryb wyswietlania kolorow
 * @param int appMode - okresla dla jakiego trybu pracy aplikacji chcemy wartosc
 * @returns true jezeli tryb jest czarnobialy inaczej false
*/
bool Settings_ui::colorMode(int appMode)
{
	bool res = false;
	if(appMode == ARD_MODE)
		res = checkBox_25->isChecked();
	if(appMode == XTT_MODE)
		res = checkBox->isChecked();
		
	return res;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy uzyc obramowanych wezlow ARD i TPH
 * @returns true jezeli tak inaczej false
*/
bool Settings_ui::useFramedNodes(void)
{
	return checkBox_27->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy stosowac antyaliasing
 * @param int appMode - okresla dla jakiego trybu pracy aplikacji chcemy wartosc
 * @returns true jezeli tak inaczej false
*/
bool Settings_ui::useAntialiasing(int appMode)
{
	bool res = false;
	if(appMode == ARD_MODE)
		res = checkBox_24->isChecked();
	if(appMode == XTT_MODE)
		res = checkBox_2->isChecked();
		
	return res;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy stosowac antyaliasing dla tekstu
 * @param int appMode - okresla dla jakiego trybu pracy aplikacji chcemy wartosc
 * @returns true jezeli tak inaczej false
*/
bool Settings_ui::useTextAntialiasing(int appMode)
{
	bool res = false;
	if(appMode == ARD_MODE)
		res = checkBox_22->isChecked();
	if(appMode == XTT_MODE)
		res = checkBox_6->isChecked();
		
	return res;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalezy stosowac plynna transformacje bitmap
 * @param int appMode - okresla dla jakiego trybu pracy aplikacji chcemy wartosc
 * @returns true jezeli tak inaczej false
*/
bool Settings_ui::useSmoothPixmapTransform(int appMode)
{
	bool res = false;
	if(appMode == ARD_MODE)
		res = checkBox_23->isChecked();
	if(appMode == XTT_MODE)
		res = checkBox_7->isChecked();
		
	return res;
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca czy nalzey pokazac ekran startowy
 * @returns czy nalzey pokazac ekran startowy
*/
bool Settings_ui::useStartScreen(void)
{
	return checkBox_28->isChecked();
}
// -----------------------------------------------------------------------------

/**
 * Metoda zwracajaca typ tla dla ekranu startowego
 * @returns Zwraca typ tla dla ekranu startowego, 0-logo AGH, 1-desktop screenshot
*/
bool Settings_ui::startScreenBackgroundType(void)
{
	return comboBox->currentIndex();
}
// -----------------------------------------------------------------------------

/**
 * Zwraca szybkosc animacji w procentach w oknie startowym
 * @returns szybkosc animacji w procentach w oknie startowym
*/
int Settings_ui::startScreenAnimationSpeed(void)
{
	return spinBox_4->value();
}
// -----------------------------------------------------------------------------
