 /**
 *                                                                             *
 * @file StartScreen_ui.cpp                                                    *
 * Project name: HeKatE hqed                                                   *
 * $Id: StartScreen_ui.cpp,v 1.7 2008-03-03 22:04:31 kinio Exp $              *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 14.01.2008                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje metod klasy obslugujacej okno           *
 * wspomagajace towrzenie zawartosci komorki                                   *
 *                                                                             *
 */

#include <QMessageBox>
#include <QtGui>
#include <QDialog>
#include <QObject>
#include <QKeyEvent>

#include "MainWin_ui.h"
#include "GLStartWidget.h"
#include "StartScreen_ui.h"
// -----------------------------------------------------------------------------

StartScreen_ui* StartScreen;
// -----------------------------------------------------------------------------

/**
 * Konstruktor kalsy
 * @param QWidget *parent - Wskanik do rodzica
 * @returns Brak zwracanych wartosci
*/
StartScreen_ui::StartScreen_ui(QWidget*)
{
    setupUi(this);
    
    setWindowModality(Qt::ApplicationModal);
    setWindowFlags(Qt::SplashScreen | Qt::FramelessWindowHint);
    
    int dWidth = QApplication::desktop()->screenGeometry().width();
    int dHeight = QApplication::desktop()->screenGeometry().height();
    
    setGeometry((dWidth >> 1) - (dHeight >> 2), dHeight >> 2, dHeight >> 1, dHeight >> 1);
    
    glScreen = new GLStartWidget(this);
    glScreen->setCopyArea(QRect(((dWidth >> 1) - (dHeight >> 2))+1, (dHeight >> 2)+1, (dHeight >> 1)-2, (dHeight >> 1)-2));
    glScreen->resize(size());
    connect(glScreen, SIGNAL(runApp()), this, SLOT(runApplication()));
}
// -----------------------------------------------------------------------------

/**
 * Destruktor kalsy
 * @returns Brak zwracanych wartosci
*/
StartScreen_ui::~StartScreen_ui(void)
{
	delete glScreen;
}
// -----------------------------------------------------------------------------

/**
 * Metoda reagujaca na wcisniecie klawisza na klawiaturze
 * @param QKeyEvent* event - obiekt rzechwoujacy parametry zdarzenia
 * @returns Brak zwracanych wartosci
*/
void StartScreen_ui::keyPressEvent(QKeyEvent* event)
{
	glScreen->keyPressEvent(event);
}
// -----------------------------------------------------------------------------


/**
 * Zamyka okno startowe i uruchamia aplikacje
 * @returns Brak zwracanych wartosci
*/
void StartScreen_ui::runApplication(void)
{
	close();
	delete glScreen;
	MainWin->show();
}
// -----------------------------------------------------------------------------
