 /**
 *                                                                             *
 * @file StartScreen_ui.h                                                      *
 * Project name: HeKatE hqed                                                   *
 * $Id: StartScreen_ui.h,v 1.7 2008-03-03 22:04:31 kinio Exp $                *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 14.01.2008                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje klasy oblugujacej okno wspomagajace     *
 * tworzenie zawartosci komorki                                                *
 *                                                                             *
 */


#ifndef StartScreenH
#define StartScreenH
// -----------------------------------------------------------------------------

#include "../ui_StartScreen.h"
// -----------------------------------------------------------------------------

class GLStartWidget;
// -----------------------------------------------------------------------------

class StartScreen_ui : public QWidget, private Ui_StartScreen
{
    Q_OBJECT
    
    GLStartWidget* glScreen;

protected:

	/// Metoda reagujaca na zdarzenie wcisniecia klawisza na klawiaturze
	void keyPressEvent(QKeyEvent*);
     
public:

     /// Konstruktory klasy
     StartScreen_ui(QWidget *parent = 0);
	
	/// Destruktor klasy
	~StartScreen_ui(void);
	
public slots:

	/// Metoda uruchamiajaca aplikacje
	void runApplication(void);
};
// -----------------------------------------------------------------------------

extern StartScreen_ui* StartScreen;
// -----------------------------------------------------------------------------

#endif
