 /**
 *                                                                             *
 * @file AttrDelete_ui.h                                                       *
 * Project name: HeKatE hqed                                                   *
 * $Id: AttributeDelete_ui.h,v 1.12 2008-03-03 22:04:31 kinio Exp $             *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 24.04.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zwierajacy definicje klasy obslugujacej okienko usuwania      *
 * atrybutow. CONTROLLER                                                       *
 *                                                                             *
 */

#ifndef ATTRIBUTEDELETE_H
#define ATTRIBUTEDELETE_H
// -----------------------------------------------------------------------------
 
#include "../../ui_AttributeDelete.h"
// -----------------------------------------------------------------------------

class AttributeDelete_ui : public QWidget, private Ui_DeleteAttribute
{
    Q_OBJECT

private:

     /// Index grupy z ktorej usuwamy atrybuty
     unsigned int fGroupIndex;

public:

     /// Konstruktory klasy
     AttributeDelete_ui(QWidget *parent = 0);
     AttributeDelete_ui(int, QWidget *parent = 0);

     /// Wczytuje nazwy atrybutow
     void ReadAttributes(void);

     /// Wywolywana w momencie nacisniecia przycisku naklawiaturze
     void keyPressEvent(QKeyEvent*);

public slots:

     /// Odpowiednie sloty realizujace operacje wykonywane podczas kilkania na
     /// elementy okienka
     void DeleteClick(void);

     /// Wyswietla okienko wyboru atrybutu
     void SelectGroupClick(void);

     /// Wywolywana w momencie wybrania grupy
     void OnSelectGroupChange(void);

     /// Na zamkniecie okienka
     void OnClose(void);
};
// -----------------------------------------------------------------------------

extern AttributeDelete_ui* AttributeDelete;
// -----------------------------------------------------------------------------

#endif
