 /**
 *                                                                             *
 * @file AttrEditor_ui.h                                                       *
 * Project name: HeKatE hqed                                                   *
 * $Id: AttributeEditor_ui.h,v 1.12 2008-03-03 22:04:31 kinio Exp $             *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 24.04.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zwierajacy definicje klasy obslugujacej okienko edytora       *
 * atrybutow. CONTROLLER                                                       *
 *                                                                             *
 */

#ifndef MYQTAPP_H
#define MYQTAPP_H
// -----------------------------------------------------------------------------
 
#include "../../ui_AttributeEditor.h"
// -----------------------------------------------------------------------------

class AttrEditor : public QWidget, private Ui_attributeEditor
{
    Q_OBJECT

private:

     /// Okresla czy tworzymy nowy atrybut
     bool fNew;

     /// Index grupy w ktorej znajduje sie atrybut
     int fAttrGroupIndex;

     /// Okresla ktory atrybut jest edytowany
     int fAttrIndex;
 
public:

     /// Konstruktory klasy
     AttrEditor(QWidget *parent = 0);
	AttrEditor(int, bool, QWidget *parent = 0);
     AttrEditor(bool, int, int AttrIndex = -1, QWidget *parent = 0);

     /// Ustaiwa parametry okienka w zaleznosci od wybranej grupy i atrybutu
     void SelectedAttributeChanged(int, int);

     /// Wczytuje atrybuty z danej grupy
     void ReadAttributesNames(void);

     /// Wywolywana w momencie nacisniecia przycisku naklawiaturze
     void keyPressEvent(QKeyEvent*);


public slots:

     /// Odpowiednie sloty realizujace operacje wykonywane podczas kilkania na
     /// elementy okienka
     void RadioButton1Click(void);
     void RadioButton2Click(void);
     void RadioButton3Click(void);
     void RadioButton4Click(void);
     void RadioButton5Click(void);
     void RadioButton6Click(void);
     void toolButton1Click(void);
     void toolButton2Click(void);
     void toolButton3Click(void);
     void OKClick(void);
     void ComboBoxChange(int);
	void comboBoxEditTextChange(QString);
     void ComboBox2Change(int);
     void SrcGroupSelect(void);
     void DstGroupSelect(void);

     void intEnumValsChange(void);
     void floatEnumValsChange(void);
     void enumEnumValsChange(void);

     /// Wywolywana w momencie zmiany grupy zrodlowej
     void OnSrcGroupChange(void);

     /// Wywolywana w momencie zmiany grupy docelowej
     void OnDstGroupChange(void);
	
	/// Wywolywana w momencie zmiany tekstu z edytorze ograniczen wyliczeniowych
	void onEnumEditor4TextChange(QString);
	void onEnumEditor5TextChange(QString);
	void onEnumEditor8TextChange(QString);

signals:

     /// Emitowany w momencie klikniecia OK
     void ClickOK(void);
};
// -----------------------------------------------------------------------------

extern AttrEditor* AttributeEditor;
// -----------------------------------------------------------------------------

#endif
