 /**
 *                                                                             *
 * @file AttributeManager_ui.h                                                 *
 * Project name: HeKatE hqed                                                   *
 * $Id: AttributeManager_ui.h,v 1.6 2008-03-03 22:04:31 kinio Exp $           *                                                                  *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 29 kwiecie 2007                                                      *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawiera definicje klasy obslugujacej okienko managera         *
 * atrybutow                                                                   *
 *                                                                             *
 */

#ifndef ATTRIBUTEMANAGER_H
#define ATTRIBUTEMANAGER_H
// -----------------------------------------------------------------------------
 
#include "../../ui_AttributeManager.h"
// -----------------------------------------------------------------------------

class AttributeManager_ui : public QWidget, private Ui_attributeManager
{
    Q_OBJECT

private:

     /// Index grupy ktora aktualnie przegladamy
     unsigned int fGroupIndex;

public:

     /// Konstruktory klasy
     AttributeManager_ui(QWidget *parent = 0);

     /// Wywolywana w momencie nacisniecia przycisku naklawiaturze
     void keyPressEvent(QKeyEvent*);

public slots:

     /// Wywlywana w momencie klikniecia na drzewo nazw grup
     void TreeClick(QTreeWidgetItem*, int);

     /// Wczytuje atrybuty z danej grupy
     void ReadAttributes(void);

     /// Metody wywolywane w momncie klikania na odpowiednie buttony
     void AddNewAttribute(void);
     void EditAttribute(void);
     void DeleteClick(void);
     void NewGroupSelect(void);

     /// Wywolywana w momencie zmiany grupy atrybutu
     void NewGroupChange(void);
};
// -----------------------------------------------------------------------------

extern AttributeManager_ui* AttrManager;
// -----------------------------------------------------------------------------

#endif
