 /**
 *                                                                             *
 * @file CellEditor_ui.h                                                       *
 * Project name: HeKatE hqed                                                   *
 * $Id: CellEditor_ui.h,v 1.12 2008-03-03 22:04:32 kinio Exp $                  *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 28.04.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje klasy oblugujacej okno edycji           *
 * komore w tabeli                                                             *
 *                                                                             *
 */


#ifndef CELLEDITORH
#define CELLEDITORH
// -----------------------------------------------------------------------------
 
#include "../../ui_CellEditor.h"
#include <QMouseEvent>
// -----------------------------------------------------------------------------

class CellEditor_ui : public QWidget, private Ui_CellEditor
{
    Q_OBJECT

public:

     /// Konstruktory klasy
     CellEditor_ui(QWidget *parent = 0);
     CellEditor_ui(int, QWidget *parent = 0);

     /// Wczytuje tabele
     void ReadTabels(void);

     /// Wywolywana w momencie nacisniecia przycisku naklawiaturze
     void keyPressEvent(QKeyEvent*);

public slots:

     /// slot, wejscie na zdarzenie klikniecia na przycisk OK
     void ClickOK(void);

     /// slot, wejscie na zdarzenie zmiany wybranej tabeli
     void TableChange(int);

     /// Zdarzenie na zmiane spinButton
     void SpinButtonChange(int);

     /// Edycja aktualnej tabeli
     void EditTable(void);

     /// Zdarzenie zatwierdzenia edycji tabeli
     void EditTableEvent(void);

     /// Przesuwa aktualny wiersz o jeden w dol
     void MoveDown(void);

     /// Przesuwa aktualny wiersz o jeden w gore
     void MoveUp(void);

     /// Wywolywana w momencie podwojmego klikniecia na tabeli
     void TableDoubleClick(int, int);
};
// -----------------------------------------------------------------------------

extern CellEditor_ui* CellEdit;
// -----------------------------------------------------------------------------

#endif
