 /**
 *                                                                             *
 * @file ColumnEditor_ui.h                                                     *
 * Project name: HeKatE hqed                                                   *
 * $Id: ColumnEditor_ui.h,v 1.12 2008-03-03 22:04:32 kinio Exp $                *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 28.04.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje klasy oblugujacej okno edytora          *
 * kolumny                                                                     *
 *                                                                             *
 */


#ifndef COLUMNEDITOR_H
#define COLUMNEDITOR_H
// -----------------------------------------------------------------------------
 
#include "../../ui_ColumnEditor.h"
// -----------------------------------------------------------------------------

class ColumnEditor_ui : public QWidget, private Ui_ColumnEditor
{
    Q_OBJECT

private:

     /// Okresla czy jest dodawana nowa grupa
     bool fNew;

     /// Okresla index kontekstu
     int fcIndex;

     /// Sciezka dostepu do atrybutu
     QString fPath;

     /// Przechowuja wartosci ustawione w okienku
     QString groupName;
     QString attrName;
     int ctxIndex;

     /// Wczytuje atrybuty z danej grupy
     void ReadAttributes(int);

     /// Wywolywana w momencie nacisniecia przycisku naklawiaturze
     void keyPressEvent(QKeyEvent*);

public:

     /// Konstruktory klasy
     ColumnEditor_ui(QWidget *parent = 0);
     ColumnEditor_ui(bool, QString, int, QWidget *parent = 0);

     /// Zwracaja wartosci ustawione w okienku
     QString GroupName(void){ return groupName; }
     QString AttributeName(void){ return attrName; }
     int ContextIndex(void){ return ctxIndex; }

     /// Ustawia okinko
     void SetWindow(void);

public slots:

     /// slot, wejscie na zdarzenie klikniecia na przycisk OK
     void ClickOk(void);

     /// slot, wejscie na zdarzenie klikniecia na przycisk Cancel
     void ClickCancel(void);

     /// Metoda pozwalajaca wybrac nowa grupe
     void NewGroupSelect(void);

     /// Metoda odswierzajaca widok po zmianie grupy
     void NewGroupChange(void);

signals:

     /// Szgnal zamkniecia
     void onClose(void);
};
// -----------------------------------------------------------------------------

extern ColumnEditor_ui* ColumnEdit;
// -----------------------------------------------------------------------------

#endif
