 /**
 *                                                                             *
 * @file ConnectionManager_ui.h                                                *
 * Project name: HeKatE hqed                                                   *
 * $Id: ConnectionManager_ui.h,v 1.12 2008-03-03 22:04:32 kinio Exp $           *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 28.04.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje klasy oblugujacej okno managera         *
 * polaczen                                                                    *
 *                                                                             *
 */


#ifndef CONNECTIONMANAGERH
#define CONNECTIONMANAGERH
// -----------------------------------------------------------------------------
 
#include "../../ui_ConnectionManager.h"
// -----------------------------------------------------------------------------

class ConnectionManager_ui : public QWidget, private Ui_ConnectionManager
{
    Q_OBJECT

public:

     /// Konstruktory klasy
     ConnectionManager_ui(QWidget *parent = 0);
     ConnectionManager_ui(int, QWidget *parent = 0);

     /// Wywolywana w momencie nacisniecia przycisku naklawiaturze
     void keyPressEvent(QKeyEvent*);

public slots:

     /// Odswierza zawartosc okienka
     void Refresh(void);

     /// slot, wejscie na zdarzenie klikniecia na przycisk OK
     void ClickClose(void);

     /// Wywolywana w momencie zmiany wybranej tabeli
     void SelectedTableChange(int);

     /// Wywolywana w momencie zmiany wybranego wiersza polaczenia wychodzacego
     void ListOfOutConnectionClick(int);

     /// Wywolywana w momencie zmiany wybranego wiersza polaczenia przychodzacego
     void ListOfInConnectionClick(int);

     /// Wywolywana w momencie wybrania konkretnego polaczenia przychodzacego
     void ComboBoxChange(int);

     /// Wywolywana w momencie wybrania konkretnego polaczenia wychodzacego
     void ComboBoxChange_2(int);

     /// Wywolywana w momencie klikniecia na przycisk dodawania nowego polaczenia
     void AddNewConnection(void);

     /// Wywolywana w momencie klikniecia na przycisk edycji polaczenia przychodzacego
     void EditInConnection(void);

     /// Wywolywana w momencie klikniecia na przycisk edycji polaczenia wychodzacego
     void EditOutConnection(void);

     /// Wywolywana w momencie klikniecie przycisku usuwania polaczenia przychodzacego
     void DeleteInConnection(void);

     /// Wywolywana w momencie klikniecie przycisku usuwania polaczenia wychodzacego
     void DeleteOutConnection(void);
};
// -----------------------------------------------------------------------------

extern ConnectionManager_ui* ConnManager;
// -----------------------------------------------------------------------------

#endif
