 /**
 *                                                                             *
 * @file ExecuteMessagesListWidget.h                                           *
 * Project name: HeKatE hqed                                                   *
 * $Id: ExecuteMessagesListWidget.h,v 1.12 2008-03-03 22:04:32 kinio Exp $      *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 27.11.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zwierajacy definicje klasy bedacej kontrolka, lista           *
 * komuniktw podczas uruchomienie modelu                                      *
 *                                                                             *
 */

#ifndef EXECUTEMESSAGESLISTWIDGETH
#define EXECUTEMESSAGESLISTWIDGETH
// -----------------------------------------------------------------------------

class QWidget;
class QListWidget;
// -----------------------------------------------------------------------------

#include <QList>
#include <QListWidget>

#include "../../M/XTT/XTT_Row.h"
#include "../../M/XTT/XTT_Cell.h"
#include "../../M/XTT/XTT_Table.h"
// -----------------------------------------------------------------------------

class ExecMsgListWidget : public QListWidget
{
    Q_OBJECT

private:

	QList<int> fTablesIDs;			// Lista identyfikatorow tabel
	QList<int> fRowIDs;				// Lista identyfikatorow wierszy
	QList<int> fCellsIDs;			// Lista identyfikatorow komorek
	QList<int> fMessagesTypes;		// Lista typow wiadomosci
	QList<XTT_Cell*> fCells;			// Lista wskaznikow do komorek
	QList<XTT_Row*> fRows;			// Lista wskaznikow do wierszy
	QList<XTT_Table*> fTables;		// Lista wskaznikow do tabel
	QList<QString> fMessages;		// Lista wiadomosci
	
	QString icons[3];				// Sciezki dostepu do ikon
	QString msgTypes[3];			// Typy wiadomosci
	
	/// Pola filtru wiadomosci
	bool fShowInfo;				// Czy pokazywac informacje
	bool fShowError;				// Czy pokazywac bledy
	bool fShowWrng;				// Czy pokazywac ostrzezenia
	
public:
	
	/// Kostruktor domyslny
	ExecMsgListWidget(QWidget * parent = 0);
	
	/// Metoda dodajaca element do obiektu
	void add(int, int, int, QString, int _msgType = 0);
	
	/// Metoda usuwajaca wszystkie elementy
	void deleteAll(void);
	
	/// Ustala tresc wiadomosci
	QString messageContent(int);
	
public slots:

	/// Wywolywana w momencie zmiany zaznaczenia
	void onRowChange(int);
	
	/// Wywolywana w momencie klikniecia elementu
	void itemClick(QListWidgetItem*);
	
	/// Ustawia pokazywanie bledow
	void showErrors(bool);
	
	/// Ustawia pokazywanie ostrzezen
	void showWarnings(bool);
	
	/// Ustawia pokazywanie informacji
	void showInformations(bool);
	
	/// Metoda wsywietlajaca wiadomosci wg. filtra
	void applyFilter(void);
};
// -----------------------------------------------------------------------------

#endif
