 /**
 *                                                                             *
 * @file GroupEditor_ui.h                                                      *
 * Project name: HeKatE hqed                                                   *
 * $Id: GroupEditor_ui.h,v 1.12 2008-03-03 22:04:32 kinio Exp $                 *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 28.04.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje klasy oblugujacej okno edytora          *
 * grup                                                                        *
 *                                                                             *
 */


#ifndef GROUPEDITOR_H
#define GROUPEDITOR_H
// -----------------------------------------------------------------------------
 
#include "../../ui_GroupEditor.h"
// -----------------------------------------------------------------------------

class GroupEditor_ui : public QWidget, private Ui_GroupEditor
{
    Q_OBJECT

private:

     /// Okresla czy jest dodawana nowa grupa
     bool fNew;

     /// Okresla index edytowanej grupy
     int fIndex;

     /// Okresla czy jest tworzona grupa glowna
     bool fIsMain;

     /// Wywolywana w momencie nacisniecia przycisku naklawiaturze
     void keyPressEvent(QKeyEvent*);

public:

     /// Konstruktory klasy
     GroupEditor_ui(QWidget *parent = 0);
     GroupEditor_ui(bool, int, bool, QWidget *parent = 0);

     /// Ustawia okinko
     void SetWindow(void);

public slots:

     /// slot, wejscie na zdarzenie klikniecia na przycisk OK
     void ClickOk(void);

     /// slot, wejscie na zdarzenie klikniecia na przycisk Cancel
     void ClickCancel(void);

     /// slot, wejscie na zdarzenie klikniecia przycisku zmiany grupy
     void GroupSelectClick(void);

     /// slot, wejscie na zdarzenie zmiany wyboru grupy
     void OnGroupChange(void);

signals:

     /// Sygnal zamkniecia okna przyciskiem OK
     void onClose(void);
};
// -----------------------------------------------------------------------------

extern GroupEditor_ui* GroupEdit;
// -----------------------------------------------------------------------------

#endif
