 /**
 *                                                                             *
 * @file GroupManager_ui.h                                                     *
 * Project name: HeKatE hqed                                                   *
 * $Id: GroupManager_ui.h,v 1.12 2008-03-03 22:04:32 kinio Exp $                *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 28.04.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plk zawierajacy definicje klasy obslugujacej okno menedzera        *
 * grup                                                                        *
 *                                                                             *
 */


#ifndef GROUPMANAGER_H
#define GROUPMANAGER_H
// -----------------------------------------------------------------------------
 
#include "../../ui_GroupManager.h"
// -----------------------------------------------------------------------------

class GroupManager_ui : public QWidget, private Ui_GroupManager
{
    Q_OBJECT

public:

     /// Konstruktory klasy
     GroupManager_ui(QWidget *parent = 0);

     /// Wywolywana w momencie nacisniecia przycisku naklawiaturze
     void keyPressEvent(QKeyEvent*);

public slots:

     /// Pobiera nazwe elementu drzewa ktory zostal klinkiety
     void TreeClick(QTreeWidgetItem*, int);

     /// Odswierza liste grup
     void refreshGroupTree(void);

     /// Tworza i pokazuja okno edyotra grup, tylko w zaleznosci od przycisku
     /// odpowiednio je dostosowywyuja
     void CreateNewMainGroup(void);
     void CreateNewSubGroup(void);
     void EditGroup(void);

     /// Usuwa zaznaczona grupe
     void DeleteGroup(void);

     /// Wyswietla okno w ktorym wybieramy nowego rodzica
     void SelectNewParent(void);

     /// Zmienia rodzica
     void ChangeParent(void);

     /// Ustawia grupe jako glowna
     void SetAsMain(void);

     /// Na zamkniecie okienka
     void OnClose(void);
};
// -----------------------------------------------------------------------------

extern GroupManager_ui* GroupMan;
// -----------------------------------------------------------------------------

#endif
