 /**
 *                                                                             *
 * @file Hinter_ui.h                                                           *
 * Project name: HeKatE hqed                                                   *
 * $Id: Hinter_ui.h,v 1.12 2008-03-03 22:04:32 kinio Exp $                      *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 28.04.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje klasy oblugujacej okno wspomagajace     *
 * tworzenie zawartosci komorki                                                *
 *                                                                             *
 */


#ifndef HINTER_H
#define HINTER_H
// -----------------------------------------------------------------------------

#include <QLineEdit>

#include "../../ui_Hinter.h"
// -----------------------------------------------------------------------------

class XTT_Table;
class XTT_Attribute;
class XTT_Cell;
class QTableWidgetItem;
class MyLineEdit;
// -----------------------------------------------------------------------------

class Hinter_ui : public QWidget, private Ui_Hinter
{
    Q_OBJECT

private:

    MyLineEdit* line_edit; 
    QCompleter* cmpl;

    int fcolContext;
    XTT_Attribute* fattr;
    QTableWidgetItem* fitem;
    XTT_Cell* fcell;
    XTT_Table* ftable;

    QString textUnderCursor(void) const;
    
    /// Metoda kasujaca dynamicznie zaalokowany completitor
    void freeDynamicAlocatedMemory(void);

protected:

     /// Wywolywana w momencie nacisniecia przycisku naklawiaturze
     void keyPressEvent(QKeyEvent*);
     
public:

     /// Konstruktory klasy
     Hinter_ui(QWidget *parent = 0);
     Hinter_ui(int, XTT_Table*, XTT_Attribute*, XTT_Cell*, QTableWidgetItem*, QWidget *parent=0);
	~Hinter_ui(void);

public slots:

     /// Wywolywana w moencie klikniecie na przycisk cancel
     void CancelClick(void);

     /// Wywolywana w moencie klikniecie na przycisk OK
     void OKClick(void);
	
signals:
	
	void ClickOK(void);
};
// -----------------------------------------------------------------------------

extern Hinter_ui* Hinter;
// -----------------------------------------------------------------------------

#endif
