 /**
 *                                                                             *
 * @file MyLineEdit.h                                                          *
 * Project name: HeKatE hqed                                                   *
 * $Id: MyLineEdit.h,v 1.12 2008-03-03 22:04:32 kinio Exp $                     *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 27.05.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawiera definicje nowej kontrolki edytujecej tekst            *
 *                                                                             *
 */

#ifndef MyLineEditH
#define MyLineEditH
//---------------------------------------------------------------------------

class QCompleter;
class QKeyEvent;
class QString;
class QWidget;
//---------------------------------------------------------------------------

#include <QLineEdit>
//---------------------------------------------------------------------------

class MyLineEdit : public QLineEdit
{
     Q_OBJECT

private:

     /// Kompliter
     QCompleter *c;

protected:

     /// Wywolywana w momencie nacisniecia klawisza
     void keyPressEvent(QKeyEvent*);

public:

     /// Konstruktor
     MyLineEdit(QWidget *parent = 0);

     /// Destruktor
     ~MyLineEdit(void);

     /// Zwraca bierzace slowo
     QString textUnderCursor(void) const;

     /// Wskaznik do komplitera
     QCompleter* completer(void) const;

     /// Ustawia kompliter
     void setCompleter(QCompleter*);

private slots:

     /// Wywolywany w momencie wstawiania tekstu przez kompletitior
     void insertCompletion(const QString &completion);
};
//---------------------------------------------------------------------------
#endif
