 /**
 *                                                                             *
 * @file SelectGroup_ui.cpp                                                    *
 * Project name: HeKatE hqed                                                   *
 * $Id: SelectGroup_ui.cpp,v 1.12 2008-03-03 22:04:32 kinio Exp $               *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 28.04.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawiera definicje metod obiektu obslugujacego okno            *
 * wyboru grupy                                                                *
 *                                                                             *
 */

#include <QMessageBox>
#include <QtGui>
#include <QDialog>
#include <QObject>
#include <QKeyEvent>

#include "SelectGroup_ui.h"
#include "../../M/XTT/XTT_AttributeGroups.h"
// -----------------------------------------------------------------------------

SelectGroup_ui* SelGroup;
// -----------------------------------------------------------------------------

/**
 * Konstruktor kalsy
 * @param QWidget *parent - Wskanik do rodzica
 * @returns Brak zwracanych wartosci
*/
SelectGroup_ui::SelectGroup_ui(QWidget*)
{
    setupUi(this);
    setWindowIcon(QIcon(":/all_images/images/mainico.bmp")); 

    connect(pushButton, SIGNAL(clicked()), this, SLOT(OkClick()));
    connect(treeWidget, SIGNAL(itemClicked(QTreeWidgetItem*, int)), this, SLOT(TreeClick(QTreeWidgetItem*, int)));
    setWindowFlags(Qt::WindowMaximizeButtonHint);

    treeWidget->insertTopLevelItems(0, AttributeGroups->CreateTree());
    res_name = "";
}
// -----------------------------------------------------------------------------

/**
 * Metoda wywoywana w momencie kliknicia na obiekcie Tree
 * @param QTreeWidgetItem* item - Wskanik do obiektu tree
 * @param int col - Kolumna w ktorej nastapilo klikniecie
 * @returns Brak zwracanych wartoci
*/
void SelectGroup_ui::TreeClick(QTreeWidgetItem* item, int col)
{
     // Pobranie nazwy gkliknietej grupy
     res_name = item->text(col);
}
// -----------------------------------------------------------------------------

/**
 * Metoda klasy SelectGroup_ui, wywoywana w momencie kliknicia na obiekcie OK
 * @returns Brak zwracanych wartoci
*/
void SelectGroup_ui::OkClick(void)
{
     // Emisja syganlu OK
     emit ResultOK();
     close();
}
// -----------------------------------------------------------------------------

/**
 * Metoa wywolywana w momencie kiedy zostanie nacisniety jakis klawisz
 * @param QKeyEvent* event - Wskanik do obiektu przechwoujacego informacje o 
 * zdarzeniu
 * @returns Brak zwracanych wartoci
*/
void SelectGroup_ui::keyPressEvent(QKeyEvent *event)
{
     switch (event->key())
     {
          case Qt::Key_Escape:
               close();
               break;

          case Qt::Key_Return:
               OkClick();
               break;

          default:
               QWidget::keyPressEvent(event);
     }
}
// -----------------------------------------------------------------------------
