 /**
 *                                                                             *
 * @file TableEditor_ui.h                                                      *
 * Project name: HeKatE hqed                                                   *
 * $Id: TableEditor_ui.h,v 1.12 2008-03-03 22:04:32 kinio Exp $                 *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 28.04.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje klasy oblugujacej okno edytora          *
 * tabel                                                                       *
 *                                                                             *
 */


#ifndef TABLEEDITOR_H
#define TABLEEDITOR_H
// -----------------------------------------------------------------------------
 
#include "../../ui_TableEditor.h"
// -----------------------------------------------------------------------------

class TableEditor_ui : public QWidget, private Ui_TableEditor
{
    Q_OBJECT

private:

     /// Okresla czy jest dodawana nowa grupa
     bool fNew;

     /// Okresla index edytowanej tabeli
     int fIndex;

     /// Lista nazw kontekstow
     QStringList clist;

public:

     /// Konstruktory klasy
     TableEditor_ui(QWidget *parent = 0);
     TableEditor_ui(bool, int, QWidget *parent = 0);

     /// Ustawia okinko
     void SetWindow(void);

     /// Wywolywana w momencie nacisniecia przycisku naklawiaturze
     void keyPressEvent(QKeyEvent*);

public slots:

     /// slot, wejscie na zdarzenie klikniecia na przycisk OK
     void ClickOk(void);

     /// slot, wejscie na zdarzenie klikniecia na przycisk Cancel
     void ClickCancel(void);

     /// Pokazuje okienko edycji kolumnhy w trybie dodawania nowej
     void NewCol(void);

     /// Pokazuje okienko edycji kolumnhy w trybie edycji
     void EditCol(void);

     /// Metoda wywolywana w momencie klikniecie na OK w okienku gdzie dodajemy
     /// nowa kolumne
     void AddColumnEvent(void);

     /// Wywolywana w momencie zatwierdzenia zmian edycyjnych kolumny
     void EditColumnEvent(void);

     /// Usuwa wybrany wiersz tabeli kolumn
     void DeleteCol(void);

     /// Pozwala cofnac usuwanie z danej kolumny, pod warunkiem ze nie jest ona
     /// nowa
     void UnDelete(void);

     /// Przesuwa wybrana pozycje do gory
     void MoveUp(void);

     /// Przesuwa wybrana pozycje na dol
     void MoveDown(void);

     /// Wywolywana na zmiane wybranej tabeli
     void SelectedTableChange(int);

signals:

     /// Sygnal zamkniecia okna
     void onClose(void);
};
// -----------------------------------------------------------------------------

extern TableEditor_ui* TableEdit;
// -----------------------------------------------------------------------------

#endif
