 /**
 *                                                                             *
 * @file sysTrayObject.h                                                       *
 * Project name: HeKatE hqed                                                   *
 * $Id: sysTrayObject.h,v 1.2 2008-03-03 22:04:31 kinio Exp $                  *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 29.01.2008                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje klasy pochodnej elementu bedacego       *
 * reprezentacja programu w zasobniku systemowym                               *
 *                                                                             *
 */


#ifndef SYSTRAYOBJECTH
#define SYSTRAYOBJECTH
// -----------------------------------------------------------------------------

#include <QSystemTrayIcon>
// -----------------------------------------------------------------------------

class QAction;
// -----------------------------------------------------------------------------

class sysTrayObject : public QSystemTrayIcon
{
	Q_OBJECT
    
	/// Przechowuje ostatnio wyosowana wskazowke
	QString fLastTip;
    
	/// Menu zasobnika systemowego
	QMenu* trayIconMenu;
	
	// Polecenie menu zsobnika systemowego
	QAction* trayMenu_netxTip;
	QAction* trayMenu_restore;
	QAction* trayMenu_minimize;
	QAction* trayMenu_maximize;
	QAction* trayMenu_options;
	QAction* trayMenu_about;
	QAction* trayMenu_quit;
     
public:

     /// Konstruktor klasy
     sysTrayObject(QWidget* oParent = 0);
	
	/// Destruktor klasy
     ~sysTrayObject(void);
	
	/// Pokazuje wskazowke dotyczaca obslugi programu
	void drawTip(int);
	
	/// Pokzuje ostatnio wylosowana wskazowke
	void showDrawedTip(void);
	
	
public slots:

	/// Metoda wywolywana w momencie kliknecia wywolania polecenia nastepnej wskazowki
	void onNextTip(void);
	
	/// Metoda wywolywana w momencie kliknecia wywolania polecenia przywrocenia okna
	void onRestore(void);
	
	/// Metoda wywolywana w momencie kliknecia wywolania polecenia minimalizowania okna
	void onMinimize(void);
	
	/// Metoda wywolywana w momencie kliknecia wywolania polecenia maksymalizacji okna
	void onMaximize(void);
	
	/// Metoda wywolywana w momencie kliknecia wywolania polecenia pokazania okna
	void onOptions(void);
	
	/// Metoda wywolywana w momencie kliknecia wywolania polecenia pokazania okna o porgramie
	void onAbout(void);
	
	/// Metoda wywolywana w momencie kliknecia wywolania polecenia zamkniecia aplikacji
	void onQuit(void);
	
	/// Metoda wywolywana w momencie kliknecia informacji
	void onMessageClick(void);
	
	/// Metoda wywolywana w momencie pokazania menu kontekstowego
	void onShowMenu(void);
	
	/// Metoda wywolana w momencie aktywacji ikony w zasobniku
	void onActivate(QSystemTrayIcon::ActivationReason);
};
// -----------------------------------------------------------------------------
#endif
