 /**
 *                                                                             *
 * @file ARD_AttributeList.h                                                   *
 * Project name: HeKatE hqed                                                   *
 * $Id: ARD_AttributeList.h,v 1.7 2008-03-03 22:04:33 kinio Exp $              *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 22.12.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zwiera definicje obiektu bedacego pojemnikiem na atrybuty     *
 * ARD                                                                         *
 */
 
#ifndef ARD_ATTRIBUTELISTH
#define ARD_ATTRIBUTELISTH
// -----------------------------------------------------------------------------

#include <QtCore/QString>
#include <QStringList>
#include <QList>
// -----------------------------------------------------------------------------

class ARD_Attribute;
class XTT_Attribute;
// -----------------------------------------------------------------------------

class ARD_AttributeList : public QList<ARD_Attribute*>
{

private:

	/// Nastepny identyfikator atrybutu
	unsigned int fNextID;
	
	/// Okresla status czy zawartosc pojemnika byla zmieniona
	bool fChanged;
	
public:

	/// Konstruktor domyslny
	ARD_AttributeList(void);
	
	/// Destruktor
	~ARD_AttributeList(void);
	
	/// ----------------- Metody ustawiajace wartosci pol klasy -----------------
	
	/// Ustawia status zmiany na zadana wartosc
	void setChanged(bool);
	
	/// ----------------- Metody operacyjne -----------------
	
	/// Oproznia pojemnik
	void flush(void);
	
	/// Dodaje nowy atrybut
	ARD_Attribute* add(void);
	
	/// Dodaje nowy atrybut
	void add(ARD_Attribute*);
	
	/// Usuwa wybrany atrybut
	void remove(int);
	
	/// Wyszukuje atrybuty na podstawie nazwy
	int indexOfName(QString);
	
	/// Wyszukuje atrybuty po ID
	int indexOfID(unsigned int);
	
	/// Sortuje atrybuty po nazwie
	void sort(void);
	
	/// Zwraca czy atrybuty byly modyfikowane
	bool changed(void);
};
// -----------------------------------------------------------------------------

extern ARD_AttributeList* ardAttributeList;
// -----------------------------------------------------------------------------
#endif
