 /**
 *                                                                             *
 * @file gARDexpander.h.h                                                      *
 * Project name: HeKatE hqed                                                   *
 * $Id: gARDexpander.h,v 1.7 2008-03-03 22:04:34 kinio Exp $                 *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 7.01.2008                                                             *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje obiektu bedacego elemntem               *
 * pozwalajacym na zwijanie i rozwijanie poziomow ARD                          *
 *                                                                             *
 */

#ifndef GARDEXPANDERH
#define GARDEXPANDERH
//---------------------------------------------------------------------------

#include <QPainter>
#include <QGraphicsItem>
#include <QGraphicsSceneMouseEvent>
#include <QStyleOptionGraphicsItem>
//---------------------------------------------------------------------------

class QGraphicsItem;
class gARDlevel;
//---------------------------------------------------------------------------

class gARDexpander : public QGraphicsItem
{
private:
	
	/// Rodzic graficznej reprezentacji poziomu
	gARDlevel* fGparent;
	
	/// Okresla ktory obraz ma byc wyswietlany
	QString fPictureStr;

public:

     /// Konstruktor przyjmujacy rodzica
     gARDexpander(gARDlevel*);
	
	/// Destruktor
	~gARDexpander(void);
	
	/// ----------------- Metody zwracajace wartosci pol klasy -----------------
	
	/// Zwraca wskaznik do rodzica graficznego
	gARDlevel* gParent(void);

	/// ----------------- Metody operacyjne -----------------
	
	
     /// Metoda rysowania obiektu
     void paint(QPainter*, const QStyleOptionGraphicsItem*, QWidget* widget=0);
	
	/// Metoda wywolywana w momencie najechania wskaznikiem myszki na obiekt
	void hoverEnterEvent(QGraphicsSceneHoverEvent*);
	
	/// Metoda wywolywana w momencie zjechania wskaznikiem myszki z obiektu
	void hoverLeaveEvent(QGraphicsSceneHoverEvent*);
	
	/// Metoda wywolywana w momencie klikniecia na obiekt myszka
	void mousePressEvent(QGraphicsSceneMouseEvent*);

     /// Metoda okreslajaca kwadrat w jakim sie znajduje obiekt
     QRectF boundingRect() const;
};
//---------------------------------------------------------------------------
#endif
