 /**
 *                                                                             *
 * @file gARDnode.h                                                            *
 * Project name: HeKatE hqed                                                   *
 * $Id: gARDnode.h,v 1.7 2008-03-03 22:04:34 kinio Exp $                       *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 2.01.2008                                                             *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje obiektu bedacego wezlem,                *
 * diagramu ARD                                                                *
 *                                                                             *
 */

#ifndef GARDNODEH
#define GARDNODEH
//---------------------------------------------------------------------------

#include <QPainter>
#include <QGraphicsItem>
#include <QGraphicsSceneMouseEvent>
#include <QStyleOptionGraphicsItem>
//---------------------------------------------------------------------------

class QGraphicsItem;
class ARD_Property;
class gARDlevel;
//---------------------------------------------------------------------------

class gARDnode : public QGraphicsItem
{
private:

	/// Identyfikator wezla
	unsigned int fID;

     /// Odpowiednik w modelu
     ARD_Property* fParent;
	
	/// Rodzic graficznej reprezentacji poziomu
	gARDlevel* fGparent;
	
	/// Rodzice w diagramie ARD
     QList<gARDnode*>* fARDparents;

public:

     /// Konstruktor przyjmujacy rodzica
     gARDnode(unsigned int, ARD_Property*, gARDlevel*);
	
	/// Destruktor
	~gARDnode(void);
	
	/// ----------------- Metody zwracajace wartosci pol klasy -----------------
	
	/// Zwraca identyfikator wezla
	unsigned int id(void);
	
	/// Zwraca wskaznik do rodzica
	ARD_Property* parent(void);
	
	/// Zwraca wskaznik do rodzica graficznego
	gARDlevel* gParent(void);
	
	/// Zwraca liste rodzicow w diagramie ARD
	QList<gARDnode*>* ardParents(void);

	/// ----------------- Metody operacyjne -----------------
	
	/// Zwraca index wezla o zadanym identyfikatorze
	int indexOfParent(unsigned int);
	
     /// Metoda rysowania obiektu
     void paint(QPainter*, const QStyleOptionGraphicsItem*, QWidget* widget=0);

     /// Metoda wywolywana w momencie podwojnego klikniecia
     void mouseDoubleClickEvent(QGraphicsSceneMouseEvent*);
	
	/// Metoda wywolywana w momencie klikniecia na obiekt myszka
	void mousePressEvent(QGraphicsSceneMouseEvent*);

     /// Metoda okreslajaca kwadrat w jakim sie znajduje obiekt
     QRectF boundingRect() const;

     /// Metoda wywolywana w momencie zmiany pozycji obiektu
     QVariant itemChange(GraphicsItemChange, const QVariant&);
	
	/// Zwraca obszar prostokatny do rysowania i wypisywania atrybutow
	QRectF fieldArea(void) const;
};
//---------------------------------------------------------------------------
#endif
