 /**
 *                                                                             *
 * @file gTPHnode.h                                                            *
 * Project name: HeKatE hqed                                                   *
 * $Id: gTPHnode.h,v 1.7 2008-03-03 22:04:35 kinio Exp $                       *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 2.01.2008                                                             *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje obiektu bedacego wezlem,                *
 * diagramu TPH                                                                *
 *                                                                             *
 */

#ifndef GTPHNODEH
#define GTPHNODEH
//---------------------------------------------------------------------------

#include <QPainter>
#include <QGraphicsItem>
#include <QGraphicsSceneMouseEvent>
#include <QStyleOptionGraphicsItem>
//---------------------------------------------------------------------------

class QGraphicsItem;
class ARD_Property;
//---------------------------------------------------------------------------

class gTPHnode : public QGraphicsItem
{
private:

     /// Rodzic
     ARD_Property* fParent;
	
	/// Rodzic w diagramie TPH
     ARD_Property* fTPHparent;
	
	/// Odleglosc od rodzica w pionie
	float fVerticalDistance;
	
	/// Odleglosc od rodzica w poziomie
	float fHorizontalDistance;

public:

     /// Konstruktor przyjmujacy rodzica
     gTPHnode(ARD_Property*);
	
	/// ----------------- Metody zwracajace wartosci pol klasy -----------------
	
	/// Zwraca odleglosc od rodzica w pionie
	float verticalDistance(void);
	
	/// Zwraca odleglosc od rodzica w poziomie
	float horizontalDistance(void);
	
	/// Ustawia wskaznik na rodzica w diagramie TPH
	void setTPHparent(ARD_Property*);
	
	/// ----------------- Metody ustawiajace wartosci pol klasy -----------------
	
	/// Ustawia odleglosc od rodzica w pionie
	void setVerticalDistance(float);
	
	/// Ustawia odleglosc od rodzica w poziomie
	void setHorizontalDistance(float);

	/// ----------------- Metody operacyjne -----------------
	
     /// Metoda rysowania obiektu
     void paint(QPainter*, const QStyleOptionGraphicsItem*, QWidget* widget=0);

     /// Metoda wywolywana w momencie podwojnego klikniecia
     void mouseDoubleClickEvent(QGraphicsSceneMouseEvent*);
	
	/// Metoda wywolywana w momencie klikniecia na obiekt myszka
	void mousePressEvent(QGraphicsSceneMouseEvent*);

     /// Metoda okreslajaca kwadrat w jakim sie znajduje obiekt
     QRectF boundingRect() const;

     /// Metoda wywolywana w momencie zmiany pozycji obiektu
     QVariant itemChange(GraphicsItemChange, const QVariant&);
	
	/// Zwraca obszar prostokatny do rysowania i wypisywania atrybutow
	QRectF fieldArea(void) const;
};
//---------------------------------------------------------------------------
#endif
