 /**
 *                                                                             *
 * @file gTPHtree.h                                                            *
 * Project name: HeKatE hqed                                                   *
 * $Id: gTPHtree.h,v 1.7 2008-03-03 22:04:35 kinio Exp $                       *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 02.01.2008                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje obiektu bedacego zarzadzajacym          *
 * postacia diagramu TPH                                                       *
 *                                                                             *
 */


#ifndef GTPHTREEH
#define GTPHTREEH
//---------------------------------------------------------------------------

class ARD_PropertyList;
class ARD_Property;
class ardGraphicsScene;
class gTPHnode;
//---------------------------------------------------------------------------

class gTPHtree
{
private:

     /// Rodzic
     ARD_PropertyList* fParent;

public:

     /// Konstruktor
     gTPHtree(ARD_PropertyList*);

     /// Destruktor
     ~gTPHtree(void);
	
	/// Odnawia caly diagram
	void refresh(void);
	
	/// Ustawia w kazdym wezle wskaznik do rodzica
	void setParents(void);
	
	/// Ustawia zeleznosci pomiedzy odleglosciami miedzy wezlami a ich rodzicami
	void createTree(ARD_Property*);
	
	/// Ustawia zeleznosci pomiedzy odleglosciami miedzy wezlami a ich rodzicami
	void getTreeGeometry(int, QList<QList<ARD_Property*>*>*, QList<QList<float>*>*, QList<float>*);
};
//---------------------------------------------------------------------------
#endif
