 /**
 *                                                                             *
 * @file GConncetion.h                                                         *
 * Project name: HeKatE hqed                                                   *
 * $Id: GConnection.h,v 1.12 2008-03-03 22:04:35 kinio Exp $                    *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 21.05.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje obiektu symbolizujacego                 *
 * polaczenie miedzy tabelami                                                  *
 *                                                                             *
 */

#ifndef GConnectionH
#define GConnectionH
//---------------------------------------------------------------------------

#include <QGraphicsItem>
#include <QPainter>
#include <QGraphicsSceneMouseEvent>
#include <QStyleOptionGraphicsItem>
//---------------------------------------------------------------------------

class XTT_Connections;
class GWire;
//---------------------------------------------------------------------------

class GConnection
{
private:

	/// Okresla podstawe odleglosci pomiedzy polaczeniami
	float WIRE_SPACE_BASE_SIZE;

     /// Okresla ile jest aktualnie wymaganych elemntow lini
     unsigned int fEssentialWiresQuantity;

     /// Tablica wskaznikow na polaczenia miedzy tabelami
     GWire* fWire[5];

     /// Obiekt polaczenia, ktore symbolizuje
     XTT_Connections* fParent;

     /// Pola wlasciwoasci lini

     /// Okresla stosunek podzialu pierszewj odleglosci poziomej przy 3 czesciowym polaczeniu
     float line_1_pos_3p;
	
	/// Okresla stosunek podzialu pierszewj odleglosci poziomej przy 5 czesciowym polaczeniu
     float line_1_pos_5p;
	
	/// Okresla stosunek podzialu pierszewj odleglosci pionowej przy 5 czesciowym polaczeniu
     float line_2_pos;
	
	/// Okresla stosunek podzialu drugiej odleglosci poziomej przy 5 czesciowym polaczeniu
     float line_5_pos;
	
	/// Wartosci przechowujace informacje o lokalizacji zrodlowej i docelowej polaczenia
	
	/// Source Table Index
	int fsti;
	
	/// Source Row Index
	int fsri;
	
	/// Destination Table Index
	int fdti;
	
	/// Destination Row Index
	int fdri;
	
	
	/// Punkt startowy i koncowy polaczenia
	QPointF startP, endP;
	
	/// Okresla odlegolosc miedzy polaczeniami w zaleznosci od wiersza z ktorego wychodza
	float wirespace_2;
	
	/// Okresla odlegolosc miedzy polaczeniami w zaleznosci od wiersza z ktorego wychodza
	float wirespace_4;

public:

     /// Konstruktor
     GConnection(XTT_Connections*);

     /// Destruktor
     ~GConnection(void);

     /// Zwraca wskaznik do rodzica
     XTT_Connections* Parent(void);

     /// Metoda rysujace placzenia
     void RePaint(void);

     /// Metoda ustawiajaca wszystkie elemnty jako wybrane
     void SelectAll(void);
     void ClearSelection(void);

     /// Metoda zwracajaca wskazniki do lini
     GWire* Wires(int);

     /// Metoda wykonywana w momecie zmiany pozycji elementu
     void PosChange(int);
	
	/// Metoda wczytujaca informacje o lokalizacji zrodlowej i docelowej polaczenia
	void setLocalizationParameters(void);
};
//---------------------------------------------------------------------------
#endif
