 /**
 *                                                                             *
 * @file GLine.cpp                                                             *
 * Project name: HeKatE hqed                                                   *
 * $Id: GLine.cpp,v 1.12 2008-03-03 22:04:35 kinio Exp $                        *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 15.05.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje metod obiektu bedacego linia            *
 *                                                                             *
 */

#include <QMessageBox>
#include <QtGui>
#include <QDialog>
#include <QObject>

#include "../../M/XTT/XTT_Table.h"
#include "../../C/Settings_ui.h"
#include "GLine.h"
//---------------------------------------------------------------------------

/**
 * Konstruktor klasy przyjmujacy wartosci wszystkich pol, poniewaz sa one 
 * niezbedne do popranwego dzialania aplikacji
 * @param XTT_Table* _parent - Wskanik do tabeli rodzica ktroego symbolizuje
 * @param bool _isVert - Okresla czy linia jest pionowa
 * @param int _sizeIndex - Okresla do ktorego wiersza/kolumny linia jest 
 * przypisana
 * przyrostu polozenia w kierunku dodatnim
 * @returns Brak zwracanych wartosci
*/
GLine::GLine(XTT_Table* _parent, bool _isVert, int)
{
     setZValue(2);
     
     fParent = _parent;
     fIsVertical = _isVert;
}
//---------------------------------------------------------------------------

/**
 * Metoda klasy zwracajaca obszar prostokatny w ktorym sie znajduje obiekt
 * @returns Obszar prostokatny zawierajacy obiekt
*/
QRectF GLine::boundingRect() const
{
     int dx = 3;
     int dy = 3;

     if(!fIsVertical)
          dx = fParent->Width();
     if(fIsVertical)
          dy = fParent->Height();

     return QRectF(-1, -1, dx+1, dy+1);
}
//---------------------------------------------------------------------------

/**
 * Metoda klasy GRect rysujaca kwadrat na ekranie
 * @param QPainter* _p - Wskanik do plutna rysowania
 * @param const QStyleOptionGraphicsItem* - Wskanik do stylu rysowania
 * @param QWidget* widget - Wskanik nieuzywany
 * @returns Brak zwracanych wartoci
*/
void GLine::paint(QPainter* _p, const QStyleOptionGraphicsItem*, QWidget*)
{
     // Ustalanie wspolrzednych
     int dx = 0;
     int dy = 0;

     if(!fIsVertical)
          dx = fParent->Width();
     if(fIsVertical)
          dy = fParent->Height();

     QLineF line(0, 0, dx, dy);
     _p->setPen(QPen(Settings->xttTableBorderColor(), 2, Qt::SolidLine, Qt::SquareCap, Qt::RoundJoin));
     _p->drawLine(line);
}
//---------------------------------------------------------------------------
