 /**
 *                                                                             *
 * @file GLine.h                                                               *
 * Project name: HeKatE hqed                                                   *
 * $Id: GLine.h,v 1.12 2008-03-03 22:04:35 kinio Exp $                          *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 15.05.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje klasy bedacej linia, ktora              *
 * wchodzi w sklad tabeli rysowanej, jako krawedz                              *
 *                                                                             *
 */

#ifndef GLineH
#define GLineH
//---------------------------------------------------------------------------

#include <QGraphicsItem>
#include <QPainter>
#include <QGraphicsSceneMouseEvent>
#include <QStyleOptionGraphicsItem>
//---------------------------------------------------------------------------

class XTT_Table;
//---------------------------------------------------------------------------

class GLine : public QGraphicsItem
{
private:

     /// Tabela rodzic
     XTT_Table* fParent;

     /// Okresla czy jest to pionowa linia
     bool fIsVertical;

public:

     /// Konstruktor przyjmujacy wartosci wszystkich pol. Stosujemy tutaj tylko
     /// taki konstruktor poniewaz konieczym jest okreslenie wartosci wszystkich
     /// pol
     GLine(XTT_Table*, bool, int);

     /// Metoda rysowania obiektu
     void paint(QPainter*, const QStyleOptionGraphicsItem*, QWidget* widget=0);

     /// Metoda okreslajaca kwadrat w jakim sie znajduje obiekt
     QRectF boundingRect() const;

     /// Ponizesz metody pozalaja ustawic parametry obiektu
     void setVerticality(bool _v){ fIsVertical = _v; }
};
//---------------------------------------------------------------------------
#endif
