 /**
 *                                                                             *
 * @file GLine.h                                                               *
 * Project name: HeKatE hqed                                                   *
 * $Id: GRect.h,v 1.12 2008-03-03 22:04:35 kinio Exp $                          *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 15.05.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zawierajacy definicje obiektu bedacego prostokatem,           *
 * odpowiednikiem jednej z tabel                                               *
 *                                                                             *
 */

#ifndef GRectH
#define GRectH
//---------------------------------------------------------------------------

#include <QPainter>
#include <QGraphicsSceneMouseEvent>
#include <QStyleOptionGraphicsItem>
//---------------------------------------------------------------------------
 
class QGraphicsItem;
class XTT_Table;
//---------------------------------------------------------------------------

class GRect : public QGraphicsItem
{
private:

     /// Tabela rodzic
     XTT_Table* fParent;

public:

     /// Konstruktor przyjmujacy rodzica
     GRect(XTT_Table*);

     /// Metoda rysowania obiektu
     void paint(QPainter*, const QStyleOptionGraphicsItem*, QWidget* widget=0);

     /// Metoda wywolywana w momencie podwojnego klikniecia
     void mouseDoubleClickEvent(QGraphicsSceneMouseEvent*);
	
	/// Metoda wywolywana w momencie klikniecia na obiekt myszka
	void mousePressEvent(QGraphicsSceneMouseEvent*);

     /// Metoda okreslajaca kwadrat w jakim sie znajduje obiekt
     QRectF boundingRect() const;

     /// Metoda wywolywana w momencie zmiany pozycji obiektu
     QVariant itemChange(GraphicsItemChange, const QVariant&);
};
//---------------------------------------------------------------------------
#endif
